/*
 ķ
   Program..: _DCFUNCT.PRG                                 
   Author...:  Roger J. Donnay                             
   Notice...: (c) DONNAY Software Designs 1987-2008        
   Date.....: Jan 10, 2008                                 
   Notes....: eXPress++ Misc Functions                     
 Ľ
*/


#INCLUDE "inkey.ch"
#INCLUDE "dcdir.ch"
#INCLUDE "appevent.ch"
#INCLUDE "xbp.ch"
#INCLUDE "dcprint.ch"
#INCLUDE "dcmsg.ch"
#INCLUDE "dll.ch"
#include "dccursor.ch"
#Include "thread.ch"
#INCLUDE "class.CH"
#INCLUDE "dmlb.CH"
#INCLUDE "fileio.CH"
#INCLUDE "dctree.CH"
#INCLUDE "dcicon.CH"
#INCLUDE "SystemMetrics.CH"

#command  XDLLFUNCTION <Func>([<x,...>]) ALIAS <cAlias>;
                   USING <sys:CDECL,OSAPI,STDCALL,SYSTEM> ;
                    FROM <(Dll)> ;
=> ;
          FUNCTION <Func>([<x>]);;
                   STATIC cTpl;;
                   LOCAL nDll:=DllLoad(<(Dll)>);;
                   LOCAL xRet;;
                   if cTpl == NIL;;
                      cTpl := DllprepareCall(<(Dll)>,__Sys(<sys>),<(cAlias)>);;
                   endif;;
                   xRet := DLLExecuteCall( cTpl [,<x>] );;
                   RETURN xRet


#DEFINE CRLF Chr(13)+Chr(10)

#define XBPSTATIC_SYSICON_SYSTEM        0       // Windows Default Pointer
#define SPI_GETDRAGFULLWINDOWS     38
#define SPI_SETDRAGFULLWINDOWS     37
#define SPI_GETWORKAREA            48
#define SPI_SETWORKAREA            47
#define SPI_GETNONCLIENTMETRICS    41
#define SPIF_UPDATEINIFILE    0x0001
#define SPIF_SENDWININICHANGE 0x0002
#define SPIF_SENDCHANGE       SPIF_SENDWININICHANGE

// defines from WINUSER.H
#define SW_HIDE             0
#define SW_SHOWNORMAL       1
#define SW_NORMAL           1
#define SW_SHOWMINIMIZED    2
#define SW_SHOWMAXIMIZED    3
#define SW_MAXIMIZE         3
#define SW_SHOWNOACTIVATE   4
#define SW_SHOW             5
#define SW_MINIMIZE         6
#define SW_SHOWMINNOACTIVE  7
#define SW_SHOWNA           8
#define SW_RESTORE          9
#define SW_SHOWDEFAULT      10
#define SW_MAX              10

#define KEYEVENTF_KEYUP     0x02
#define VK_MENU             0x12
#define VK_SNAPSHOT         0x2C
#DEFINE VK_LBUTTON          0x01
#DEFINE VK_RBUTTON          0x02

#define LOGPIXELSX          88
#define LOGPIXELSY          90

#define WS_EX_LAYERED 0x80000
#define LWA_ALPHA 0x2
#define GCL_STYLE -26
#define CS_DROPSHADOW 0x20000

// Excel Orientation
#DEFINE xlLandscape           2
#DEFINE xlPortrait            1

#DEFINE xlWorkbookNormal  -4143
#DEFINE xlCellTypeLastCell  11

MEMVAR oBitMap

STATIC soMenu, soBrowse, scQout

* ------------

FUNCTION DC_BaseFontSize(nPointSize)  // Jack Duijf 17-07-2014
STATIC scPointSize   := 8
If ValType(nPointSize) = "N"   ; scPointSize   := nPointSize          ; Endif
Return scPointSize

* -------------

FUNCTION DC_BaseFont(nPointSize,cFontName,lBold)  // Jack Duijf 17-07-2014
LOCAL cRet           := ""
STATIC scFont        := "MS Sans Serif"
iF Valtype(lBold)      <> "L"   ; lBold         := .F.                ; Endif
If ValType(cFontName)   = "C"   ; scFont        := AllTrim(cFontName) ; Endif
If ValType(nPointSize) <> "N"   ; nPointSize    := DC_BaseFontSize()  ; Endif
cRet                 := AllTrim(Var2Char(Int(nPointSize))) + "." + AllTrim(scFont)
If lBold
   cRet           += " Bold"
Endif
Return cRet

* --------------

FUNCTION DC_Recursion( cProcName, nTimes, lMessage )

LOCAL nLen := Len(cProcName), nCount := 0, i := 1

DO WHILE .t.
  IF Empty(ProcName(i))
     EXIT
  ELSEIF Substr(Upper(Alltrim(ProcName(i))),1,nLen) == Upper(Alltrim(cProcName))
     nCount++
     IF nCount >= nTimes
        IF lMessage
          DC_MsgBox({'Excessive Recursions in procedure ' + cProcName, ;
                     'Remove any calls from to ' + cProcName + ;
                     '() from DATALINK clauses'})
        ENDIF
        RETURN .t.
     ENDIF
  ENDIF
  i++
ENDDO
RETURN .f.

* ------------

FUNCTION DC_VersionExpress( n )

n := IIF( Valtype(n)='N',n,0 )
IF n = 0
  RETURN 'eXPress++ (c) Version 2.0'
ELSEIF n = 1
  RETURN '2'
ELSEIF n = 2
  RETURN '0'
ELSEIF n = 3
  RETURN '263'
ENDIF
RETURN ''

* ------------

FUNCTION DC_CompleteEvents( aGetList, oDialog )

LOCAL i, mp1, mp2, oXbp, nEvent, nSeconds := Seconds()

If Valtype(aGetList) = 'A'
  RETURN DC_ReadGuiEventLoop( aGetList,,,oDialog,,.001,.1,.f. )
ENDIF

nEvent := -1
DO WHILE nEvent # 0 .AND. Seconds() - nSeconds < 2
  nEvent := AppEvent( @mp1, @mp2, @oXbp, .1 )
  IF nEvent == DCGUI_EVENT_ACTION
    Eval(mp1)
  ELSEIF nEvent > 0 .AND. Valtype(oXbp) == 'O' .AND. !(nEvent = xbeM_Motion .AND. mp1 == NIL)
    oXbp:handleEvent( nEvent, mp1, mp2 )
  ENDIF
ENDDO

RETURN .T.

* -------------

FUNCTION DC_MergeBlocks( bBlock1, bBlock2 )

IF Valtype(bBlock1) = 'B' .AND. Valtype(bBlock2) = 'B'
   RETURN {|mp1,mp2,oXbp|Eval(bBlock1,mp1,mp2,oXbp),Eval(bBlock2,mp1,mp2,oXbp)}
ELSEIF Valtype(bBlock1) = 'B'
   RETURN bBlock1
ELSEIF Valtype(bBlock2) = 'B'
   RETURN bBlock2
ENDIF

RETURN nil

* --------------

FUNCTION DC_MoveObject( oXbp, mp1, nDragMode, nCursor, aDesign, nStopEvent, ;
                        nGridRows, nGridCols, lObjectUpdated )

LOCAL oPS, oParent, nEvent, mp2, ;
      aSize, aPos, oObject, nRowOffset, nColOffset, ;
      nColPos, nRowPos, nWidth, nHeight, oThread, nTop, nRight, ;
      lSnap, lHotMove, nGridType, nSaveWidth, nSaveHeight, ;
      nSaveRow, nSaveCol, nSaveBG, nSaveFG, aCoords

lObjectUpdated := .f.
DEFAULT aDesign := {}
ASize(aDesign,6)
lSnap := aDesign[1]
DEFAULT lSnap := .t.
lHotMove := aDesign[2]
DEFAULT lHotMove := .t.
nGridType := aDesign[3]
DEFAULT nGridType := 0
IF Empty(nGridCols)
  nGridCols := aDesign[4]
ENDIF
DEFAULT nGridCols := 7
IF Empty(nGridRows)
  nGridRows := aDesign[5]
ENDIF
DEFAULT nGridRows := 10
DEFAULT nCursor := POINTER_ARROW_1
DEFAULT mp1 := {0,0}
DEFAULT nDragMode := DCGUI_DRAG_ENTIRE_OBJECT
DEFAULT nStopEvent := xbeM_LbUp

STORE -1 TO nSaveWidth, nSaveHeight, nSaveRow, nSaveCol

oParent := oXbp:SetParent()
oParent:CaptureMouse(.t.)
oParent:SetPointer( nil, nCursor, 1 )
nColOffset := mp1[1]
nRowOffset := mp1[2]
IF oParent:isDerivedFrom('XbpTabPage')
  IF oParent:tabHeight <= 0
    nRowOffset += 20
  ELSE
    nRowOffset += oParent:tabHeight
  ENDIF
ENDIF

/*
nSaveBG := oXbp:setColorBG()

IF nSaveBG == nil
  nSaveBG := oXbp:setParent():setColorBG()
ENDIF
nSaveFG := oXbp:setColorFG()
IF nSaveFG == nil
  nSaveFG := oXbp:setParent():setColorFG()
ENDIF

oXbp:setColorBG(GRA_CLR_RED)
oXbp:setColorFG(GRA_CLR_WHITE)
IF Valtype(nSaveBG) # 'N'
  nSaveBG := GRA_CLR_BACKGROUND
ENDIF
IF Valtype(nSaveFG) # 'N'
  nSaveFG := GRA_CLR_DEFAULT
ENDIF
*/

oObject := oXbp
SetAppFocus(oObject)
nEvent := xbeP_None
// DC_ClearEvents()
aSize := oXbp:CurrentSize()
aPos  := oXbp:CurrentPos()
IF nGridType > 0
  oThread := Thread():new()
  Sleep(10)
  oPS := oParent:lockPS()
  oThread:start( {||_FillGrid( oPS, oParent, nGridCols, nGridRows, nGridType )} )
ENDIF
nColPos := aPos[1]
nRowPos := aPos[2]
nWidth  := aSize[1]
nHeight := aSize[2]
aCoords := { nColPos, nil, nRowPos, nil, nWidth, nil, nHeight, nil }
nTop    := nRowPos + nHeight
nRight  := nColPos + nWidth
IF nDragMode = DCGUI_DRAG_ENTIRE_OBJECT
ELSEIF nDragMode = DCGUI_DRAG_TOP
  nWidth := aSize[1]
ELSEIF nDragMode = DCGUI_DRAG_BOTTOM
  nWidth := aSize[1]
  nRowPos += nHeight
ELSEIF nDragMode = DCGUI_DRAG_LEFT
  nHeight := aSize[2]
  nColPos += nWidth
ELSEIF nDragMode = DCGUI_DRAG_RIGHT .OR. nDragMode = DCGUI_DRAG_LEFT
  nHeight := aSize[2]
ENDIF

DO WHILE nEvent <> xbeP_Close

  nEvent := AppEvent( @mp1, @mp2, @oXbp, 0 )

  IF nEvent = xbeM_Motion .AND. mp1 == NIL
    Sleep(1)
    LOOP
  ELSEIF nEvent == 0 .OR. Empty(oXbp)
    Sleep(1)
    LOOP
  ENDIF

  oXbp:handleEvent( nEvent, mp1, mp2 )

  IF nEvent = xbeM_Motion

    aPos := mp1
    lObjectUpdated := .t.

    IF nDragMode = DCGUI_DRAG_ENTIRE_OBJECT

      nColPos := aPos[1]-nColOffset
      nRowPos := aPos[2]-nRowOffset

    ELSEIF nDragMode = DCGUI_DRAG_TOP

      nHeight := aPos[2]-nRowPos

    ELSEIF nDragMode = DCGUI_DRAG_BOTTOM

      nRowPos := aPos[2]
      nHeight := nTop - aPos[2]

    ELSEIF nDragMode = DCGUI_DRAG_LEFT

      nColPos := aPos[1]
      nWidth := nRight - aPos[1]

    ELSEIF nDragMode = DCGUI_DRAG_RIGHT

      nWidth := aPos[1]-nColPos

    ELSEIF nDragMode = DCGUI_DRAG_RIGHT_TOP

      nWidth := aPos[1]-nColPos
      nHeight := aPos[2]-nRowPos

    ELSEIF nDragMode = DCGUI_DRAG_LEFT_TOP

      nColPos := aPos[1]
      nWidth := nRight - aPos[1]
      nHeight := aPos[2]-nRowPos

    ELSEIF nDragMode = DCGUI_DRAG_LEFT_BOTTOM

      nColPos := aPos[1]
      nWidth := nRight - aPos[1]
      nRowPos := aPos[2]
      nHeight := nTop - aPos[2]

    ELSEIF nDragMode = DCGUI_DRAG_RIGHT_BOTTOM

      nRowPos := aPos[2]
      nHeight := nTop - aPos[2]
      nWidth := aPos[1]-nColPos

    ENDIF

  ELSEIF nEvent = xbeP_Keyboard .AND. mp1 = K_ESC

    EXIT

  ELSEIF nEvent = nStopEvent

    IF oObject:isDerivedFrom('XbpTabPage')
      nRowOffset-=20
    ENDIF
    IF lSnap
      nColPos := Round( nColPos / nGridCols, 0 ) * nGridCols
      nRowPos := Round( nRowPos / nGridRows, 0 ) * nGridRows
    ENDIF
    IF nWidth > 0 .AND. nHeight > 0 //.AND. nDragMode # DCGUI_DRAG_ENTIRE_OBJECT
      oObject:setPos( { nColPos, nRowPos } )
      oObject:setSize( { nWidth, nHeight } )
    ENDIF
    EXIT

  ENDIF

  IF lHotMove
    IF nWidth > 0 .AND. nHeight > 0
      IF nColPos # nSaveCol .OR. nRowPos # nSaveRow
        oObject:setPos( { nColPos, nRowPos } )
        oObject:toFront()
      ENDIF
      IF (nWidth # nSaveWidth .OR. nHeight # nSaveHeight) .AND. nDragMode # DCGUI_DRAG_ENTIRE_OBJECT
        oObject:setSize( { nWidth, nHeight } )
      ENDIF
    ENDIF
  ENDIF

  nSaveWidth := nWidth
  nSaveHeight := nHeight
  nSaveCol := nColPos
  nSaveRow := nRowPos

ENDDO

aCoords[2] := nColPos
aCoords[4] := nRowPos
aCoords[6] := nWidth
aCoords[8] := nHeight

/*
IF Valtype(nSaveBG) = 'N'
  oObject:setColorBG(nSaveBG)
ENDIF
IF Valtype(nSaveFG) = 'N'
  oObject:setColorFG(nSaveFG)
ELSE
  oObject:setColorFG(GRA_CLR_BLACK)
ENDIF
*/

oParent:CaptureMouse(.f.)
IF Valtype(oPS) = 'O'
  oParent:unlockPS( oPS )
ENDIF

oParent:invalidateRect()

/*
oParent:hide()
oParent:show()
oXbp:toFront()
*/

RETURN aCoords

* --------------

STATIC PROCEDURE _FillGrid ( oPS, oParent, nGridCols, nGridRows, nGridType )

LOCAL i, j, nWidth, nHeight, aAttr[ GRA_AA_COUNT ]

nWidth := oParent:currentSize()[1]
nHeight := oParent:currentSize()[2]

aAttr[ GRA_AL_COLOR ] := GRA_CLR_DARKGRAY
oPS := oParent:lockPS()
IF nGridType = 1  // dots
  aAttr[ GRA_AL_TYPE ]    := GRA_LINETYPE_DOT
  GraSetAttrLine( oPS, aAttr )
  FOR i := 1 TO nWidth STEP nGridCols
    FOR j := 1 TO nHeight STEP nGridRows
      GraLine( oPS, { i, j }, { i+1, j+1 } )
    NEXT
    Sleep(.1)
  NEXT
ELSEIF nGridType = 2 // lines
  GraSetAttrLine( oPS, aAttr )
  FOR i := 1 TO nWidth STEP nGridCols
    GraLine( oPS, {i,1}, {i,nHeight} )
  NEXT
  FOR j := 1 TO nHeight STEP nGridRows
    GraLine( oPS, {1, j }, {nWidth, j} )
  NEXT
ENDIF

RETURN

* -------------

FUNCTION DC_FontHeight( cFont, oXbp, oParent )

IF Empty(cFont)
  IF Valtype(oXbp)='O'
    cFont := oXbp:SetFontCompoundName()
  ENDIF
  IF Empty(cFont) .AND. Valtype(oParent)='O'
    cFont := oParent:SetFontCompoundName()
  ENDIF
ENDIF
IF !Empty(cFont)
  RETURN Val(Substr(cFont,1,At('.',cFont)-1))
ENDIF
RETURN 0

* ------------

FUNCTION DC_GetBlock( aBlock, cType, lDisplayError )

LOCAL bBlock, cVar, cPicture, bLink, cValue, cValtype, xSetVal, ;
      bErrorBlock

IF Valtype(aBlock)='C'
  bBlock := nil
  IF !Empty(aBlock)
    bErrorBlock := ErrorBlock({||_BlockError(aBlock,lDisplayError)})
    BEGIN SEQUENCE
    bBlock := &(aBlock)
    END SEQUENCE
    ErrorBlock(bErrorBlock)
  ENDIF
  RETURN bBlock
ELSEIF Valtype(aBlock)='A' .AND. !Empty(aBlock)
  IF Valtype(aBlock[1]) $ 'BNA'
    RETURN aBlock[1]
  ENDIF
  IF Len(aBlock) == 2
    RETURN nil
  ENDIF
  bBlock := aBlock[1]
  ASize( aBlock, 8 )
  cVar     := aBlock[2]
  IF Valtype(cType) # 'C'
    cType    := aBlock[3]
    IF Empty(cType) .AND. !Empty(cVar)
      cType := Type(cVar)
    ENDIF
  ENDIF
  cPicture := aBlock[5]
  bLink    := aBlock[6]
  cValue   := aBlock[7]
  IF !Empty(cVar)
    bErrorBlock := ErrorBlock({||_BlockError()})
    BEGIN SEQUENCE
    bBlock := NIL
    IF Left(Alltrim(Strtran(cVar,' ','')),2) = '{|'
      bBlock := &(cVar)
    ELSE
      cValtype := Valtype(&cVar)
      IF !Empty(bLink)
        bLink := &(bLink)
      ENDIF
      IF !Empty(cValue)
        xSetVal := cValue
        IF Valtype(bLink)='B'
          bBlock := {|x,u| IIf( PCount()==0, u:=&cVar,;
                  &cVar := IIF(Valtype(x)='L',IIF(x,xSetVal,&cVar),xSetVal)), ;
                  Eval(bLink),u}
        ELSE
          bBlock := {|x| IIf( PCount()==0, &cVar, ;
                  &cVar := IIF(Valtype(x)='L',IIF(x,xSetVal,&cVar),xSetVal))}
        ENDIF
      ELSEIF cType $ 'OLANCM'
        IF Valtype(bLink)='B'
          bBlock := {|x,u| IIf( PCount()==0 , u:=&cVar, &cVar:=x), ;
                           Eval(bLink), u }
        ELSE
          bBlock := {|x| IIf( PCount()==0 , &cVar, &cVar:=x) }
        ENDIF
      ELSEIF cValType = 'D'
        IF Valtype(bLink)='B'
          bBlock := {|x| IIF( PCount()==0 , Transform(&cVar,cPicture), ;
                   &cVar := Ctod(x) ), Eval(bLink), &cVar }
        ELSE
          bBlock := {|x| IIF( PCount()==0 , Transform(&cVar,cPicture), ;
                   &cVar := Ctod(x) ) }
        ENDIF
      ELSEIF cValType = 'L'
        IF Valtype(bLink)='B'
          bBlock := {|x| IIF( PCount()==0 , IIF(&cVar,'Y','N'), ;
            &cVar := IIF(UPPER(x)='Y',.t.,.f.) ), Eval(bLink), &cVar }
        ELSE
          bBlock := {|x| IIF( PCount()==0 , IIF(&cVar,'Y','N'), ;
            &cVar := IIF(UPPER(x)='Y',.t.,.f.) ) }
        ENDIF
      ELSEIF cValType = 'N'
        IF Valtype(bLink)='B'
          bBlock := {|x| IIF( PCount()==0 , Transform(&cVar,cPicture), ;
               &cVar := Val(x) ), Eval(bLink), &cVar }
        ELSE
          bBlock := {|x| IIF( PCount()==0 , Transform(&cVar,cPicture), ;
               &cVar := Val(x) ) }
        ENDIF
      ELSE
        IF Valtype(bLink)='B'
          bBlock := {|x| IIF( PCount()==0 , Transform(&cVar,cPicture), ;
               &cVar := Val(x) ), Eval(bLink), &cVar }
        ELSE
          bBlock := {|x| IIF( PCount()==0 , Transform(&cVar,cPicture), ;
               &cVar := Val(x) ) }
        ENDIF
      ENDIF
    ENDIF
    END SEQUENCE
    ErrorBlock(bErrorBlock)
  ELSE
    bBlock := NIL
  ENDIF
  aBlock[1] := bBlock
ELSE
  bBlock := aBlock
ENDIF

RETURN bBlock


* ---------------------

STATIC PROCEDURE _BlockError( cBlock, lDisplayError )

DEFAULT lDisplayError := .t.
IF !Empty(cBlock) .AND. lDisplayError
  DC_WinAlert('Invalid Code Block' + Chr(13) + cBlock )
ENDIF
BREAK
RETURN

* ---------------------

FUNCTION DC_BitMapDraw ( oParent, ncbResource, lClearBox, nBGColor )

LOCAL aSize, aTarget, aSource, nAspect, lAutoScale, oPS, ;
      aCargo, aAttr, lCenter, oBitmap

DEFAULT lClearBox := .t., ;
        nBGColor := GRA_CLR_BACKGROUND

IF oParent:status() <= 0
  RETURN nil
ENDIF

aCargo := oParent:cargo[LEN(oParent:cargo)]

oPS := oParent:lockPS()

// oPS     := aCargo[1]
oBitMap := aCargo[2]

IF Valtype(ncbResource) = 'B'
  ncbResource := Eval(ncbResource)
ENDIF

/*
IF Valtype(ncbResource)='N' .AND. !Empty(ncbResource)
  oBitMap:load( NIL, ncbResource )
ELSEIF Valtype(ncbResource)='C' .AND. (Empty(ncbResource) .OR. File(ncbResource))
  IF '.JPG' $ Upper(ncbResource) .OR. '.GIF' $ Upper(ncbResource) .OR. ;
     '.BMP' $ Upper(ncbResource) .OR. '.PNG' $ Upper(ncbResource) .OR. Empty(ncbResource)
    oBitMap:LoadFile( ncbResource )
  ENDIF
ELSEIF Valtype(ncbResource)$'MC'
  oBitMap:setBuffer(ncbResource)
ELSEIF Valtype(ncbResource)='O'
  oBitMap := ncbResource
ENDIF
*/

aTarget    := nil // aCargo[3]
aSource    := aCargo[4]
lAutoScale := aCargo[5]
lCenter    := aCargo[6]

DEFAULT lCenter := .t.
aSize   := oParent:currentSize()
IF Valtype(aTarget) # 'A'
  aTarget := {1,1,aSize[1]-2,aSize[2]-2}
ENDIF

IF lClearBox
  aAttr := Array( GRA_AA_COUNT )
  aAttr [ GRA_AA_COLOR ] := nBGColor
  GraSetAttrArea( oPS, aAttr )
  GraBox( oPS, {aTarget[1],aTarget[2]}, {aTarget[3],aTarget[4]} , GRA_FILL )
ENDIF
//
// oBitmap := DC_GetBitmap( ncbResource )
// J. Duijf 11-01-2013  Also allow icons
// J. Duijf 17-06-2013  Pass parent size for optimal icon size.
//
oBitmap := DC_GetBitmap( ncbResource,,,,,.T.,{aTarget[3],aTarget[4]} )
IF Valtype(oBitmap) # 'O'
  RETURN oPS
ENDIF

IF Valtype(aSource) # 'A'
  aSource := {0,0,oBitmap:xSize,oBitmap:ySize}
  IF aSource[3] <= 0
    aSource := aTarget
  ENDIF
ENDIF

IF oBitMap:xSize <=0 .OR. oBitMap:ySize <=0
  oParent:unlockPS()
  RETURN oPS
ENDIF

nAspect    := aSource[3] / aSource[4]

IF lAutoScale
  IF nAspect > aTarget[3] / aTarget[4]
    aTarget[4] := aTarget[3] / nAspect
  ELSE
    aTarget[3] := aTarget[4] * nAspect
  ENDIF
ENDIF

IF lCenter
  IF aTarget[3] < aSize[1]-2
    nAspect := ( aSize[1]-2-aTarget[3] ) / 2
    aTarget[1] += nAspect
    aTarget[3] += nAspect
  ENDIF
  IF aTarget[4] < aSize[2]-2
    nAspect := ( aSize[2]-2-aTarget[4] ) / 2
    aTarget[2] += nAspect
    aTarget[4] += nAspect
  ENDIF
ENDIF

IF oBitmap:isDerivedFrom('XbpIcon')
  oBitmap:draw( oPS, aTarget )
ELSE
  oBitmap:draw( oPS, aTarget, aSource, , GRA_BLT_BBO_IGNORE )
ENDIF

Sleep(1)

oParent:unlockPS()

RETURN oPS

* -------------

FUNCTION DC_ClearEvents ( nClearEvent, oClearXbp, aKeyboardQueue, aKeepEvents )

LOCAL nEvent := 1, aNewQueue := {}, mp1, mp2, oXbp, lAddToQueue,i

DO WHILE nEvent <> 0
  nEvent := AppEvent( @mp1, @mp2, @oXbp, .01 )
  IF Valtype(aKeyboardQueue) = 'A' .AND. nEvent == xbeP_Keyboard
    AAdd(aKeyboardQueue,mp1)
  ENDIF
  IF Valtype(nClearEvent) = 'N' .AND. Valtype(oClearXbp) = 'O' .AND. ;
     !( nEvent == nClearEvent .AND. oXbp == oClearXbp )
     lAddToQueue := .t.
  ELSEIF Valtype(nClearEvent) = 'N' .AND. !( nEvent == nClearEvent )
     lAddToQueue := .t.
  ELSEIF Valtype(oClearXbp) = 'O' .AND. !( oXbp == oClearXbp )
     lAddToQueue := .t.
  ELSEIF Valtype(aKeepEvents) == 'A' .AND. nEvent $ aKeepEvents
     lAddToQueue := .t.
  ELSE
     lAddToQueue := .f.
  ENDIF
  IF lAddToQueue
    AADD( aNewQueue, { nEvent, mp1, mp2, oXbp }  )
  ENDIF
ENDDO

FOR i := 1 TO LEN(aNewQueue)
   PostAppEvent( aNewQueue[i,1], aNewQueue[i,2], aNewQueue[i,3], aNewQueue[i,4] )
NEXT

RETURN nil

* -------------

FUNCTION DC_SaveEvents ()

LOCAL aEventQueue := {}, nEvent := 1, mp1, mp2, oXbp

DO WHILE nEvent <> 0
  nEvent := AppEvent( @mp1, @mp2, @oXbp, .01 )
  IF nEvent # 0
     AAdd( aEventQueue, { nEvent, mp1, mp2, oXbp } )
  ENDIF
ENDDO

RETURN aEventQueue

* -------------

FUNCTION DC_RestoreEvents( aEventQueue )

LOCAL i, nEvent, mp1, mp2, oXbp

FOR i := 1 TO Len(aEventQueue)
  nEvent := aEventQueue[i,1]
  mp1 := aEventQueue[i,2]
  mp2 := aEventQueue[i,3]
  oXbp := aEventQueue[i,4]
  PostAppEvent( nEvent, mp1, mp2, oXbp )
NEXT

RETURN nil

* ------------

FUNCTION DC_GetCodeBlockText( bBlock )

RETURN Var2Char(bBlock)

* ------------

FUNCTION DC_CenterObject( oXbp, oRel )

LOCAL nRelWidth, nRelHeight, nWidth, nHeight, nCol, nRow, aPos

DEFAULT oRel := oXbp:setParent()

nWidth := oXbp:currentSize()[1]
nHeight := oXbp:currentSize()[2]
nRelWidth := oRel:currentSize()[1]
nRelHeight := oRel:currentSize()[2]
nCol := (nRelWidth-nWidth)/2
nRow := (nRelHeight-nHeight)/2

IF oRel == oXbp:setParent()
  oXbp:setPos( {nCol,nRow} )
ELSE
  aPos := DC_CalcAbsolutePosition({0,0},oRel)
  oXbp:setPos( {aPos[1]+nCol,aPos[2]+nRow} )
ENDIF

RETURN nil

* ------------------------

FUNCTION DC_CenterObject_X( oXbp )

oXbp:setPos({(oXbp:setParent():currentSize()[1]-oXbp:currentSize()[1])/2, ;
             oXbp:currentPos()[2]})

RETURN nil

* ------------------------

FUNCTION DC_CenterObject_Y( oXbp )

oXbp:setPos({oXbp:currentPos()[1], ;
             (oXbp:setParent():currentSize()[2]-oXbp:currentSize()[2])/2})

RETURN nil



* ------------------------

CLASS MagicHelp FROM Thread

  HIDDEN:
  METHOD DisplayToolTip()
  METHOD PaintTheTip()

  EXPORTED:
  VAR producerID
  VAR oLastMotionXBP
  VAR oLastTipXBP
  VAR oBlockedXBP
  VAR nLastTipTime
  VAR nLastShowTime
  VAR aLastMotionPos
  VAR oTip
  VAR lTipIsShown
  VAR nTipSensitivity
 // VAR aToolTips
  VAR lActive
  VAR aToolColor
  VAR cToolFont
  VAR nToolTime

  PROTECTED:
  VAR terminated
  // VAR nLastCellPos

  INLINE METHOD init()
    IF DC_LangSet() == DCLANG_CHINESE
      ::nTipSensitivity := .5
    ELSE
      ::nTipSensitivity := DC_ToolTipSensitivity()
    ENDIF

    ::thread:init()
    ::producerID := ThreadID()
    ::terminated  := .F.
    ::lActive := .t.
    ::aToolColor := { GRA_CLR_BLACK, GRA_CLR_WHITE }
    ::nLastShowTime := 0
  RETURN

  EXPORTED:
  METHOD execute()
  METHOD atStart()
  METHOD showTip()
  METHOD hideTip()
  METHOD terminate()
  METHOD CheckTermination()

ENDCLASS

* --------------------

METHOD MagicHelp:atStart()
  ::lTipIsShown       := .F.
  ::oLastMotionXBP    := NIL
  ::aLastMotionPos    := NIL
  // ::nLastCellPos      := 0
RETURN

* --------------------

METHOD MagicHelp:Execute()

  LOCAL nEvent, mp1:=0, mp2:=0, oXbp:=NIL, nLastMotionTime := 0, oSaveXbp, ;
        xSavemp1, nSaveEvent, nTimeOut := DC_ToolTipTimeOut(), oLastXbp, ;
        lastmp1, nLastEvent

  DO WHILE !::Terminated

     nEvent := LastAppEvent(@mp1,@mp2,@oXbp,::producerID)

     IF Valtype(oXbp) # 'O'
       LOOP
     ELSEIF oXbp:isDerivedFrom('DC_SetTimerEvent')
       oXbp := oSaveXbp
       mp1 := xSavemp1
       nEvent := nSaveEvent
       IF Empty(oXbp)
         LOOP
       ENDIF
     ELSE
       oSaveXbp := oXbp
       xSavemp1 := mp1
       nSaveEvent := nEvent
     ENDIF

     Sleep( 10 )
     IF(oXbp:isDerivedFrom("XbpIWindow"))
       oXbp := oXbp:setParent()
     ENDIF
     IF(ValType(::oBlockedXBP)=="O" .AND. oXbp == ::oBlockedXBP )
       LOOP
     ENDIF

     IF Valtype(oLastXbp) # 'O'
        oLastXbp := oXbp
        nLastEvent := nEvent
        lastmp1 := mp1
     ELSEIF oXbp == oLastXbp .AND. Valtype(lastmp1) = 'A' .AND. Valtype(mp1) = 'A' .AND. lastmp1[1] == mp1[1] .AND. ;
         lastmp1[2] == mp1[2] .AND. nLastEvent == nEvent
       IF ::nLastShowTime == -1
         LOOP
       ENDIF
     ELSEIF oXbp == oLastXbp .AND. Valtype(lastmp1) = 'A' .AND. Valtype(mp1) = 'A' .AND. (lastmp1[1] # mp1[1] .OR. lastmp1[2] # mp1[2])
       ::nLastShowTime := Seconds()
       oLastXbp := oXbp
       lastmp1 := mp1
       nLastEvent := nEvent
       LOOP
     ENDIF

     IF Valtype(::oLastTipXBP) == 'O' .AND. ::nLastShowTime >= 0 .AND. Seconds() - ::nLastShowTime > nTimeOut
         ::nLastShowTime := -1
         ::hideTip()
         oLastXbp := oXbp
         lastmp1 := mp1
         nLastEvent := nEvent
         LOOP
     ENDIF

     IF(nEvent == xbeM_Motion) .AND. ::lActive .AND. Valtype(mp1) = 'A' .AND. ;
         Len(mp1) == 2 .AND. mp1[1] > 0 .AND. mp1[2] > 0

       ::oBlockedXBP := NIL

       IF ( ValType( ::oLastMotionXBP) == "O" .AND. oXbp == ::oLastMotionXBP )

         IF( ::aLastMotionPos[1] == mp1[1] .AND. ::aLastMotionPos[2] == mp1[2] )

           IF ((Seconds() - nLastMotionTime) > ::nTipSensitivity)
             // IF oXbp:isderivedFrom("XbpCellGroup")
             //  ::nLastCellPos := oXbp:cellFromPos(mp1)
             //ENDIF
             ::showTip(oXbp)
           ENDIF
         ELSEIF ValType(::oLastTipXBP) == 'O' .AND. ;
                oXbp:setParent() == ::oLastTipXBP:setParent() .AND. ;
                (oXbp:isderivedFrom("XbpCellGroup") .OR. oXbp:isDerivedFrom("XbpScrollBar") )
           ::hideTip()
           ::oLastMotionXBP  := oXbp
           ::aLastMotionPos  := AClone(mp1)
           nLastMotionTime := Seconds()
           IF( ::nLastTipTime>0 .AND. (Seconds()-::nLastTipTime)<=0.5 )
             // ::nLastCellPos := oXbp:cellFromPos(mp1)
             ::showTip(oXbp)
           ENDIF
         ELSE
           ::aLastMotionPos := AClone(mp1)
           nLastMotionTime := Seconds()
         ENDIF
       ELSEIF ( ValType(::oLastTipXBP) == "O" .AND. ;
            oXbp:setParent() == ::oLastTipXBP:setParent() .AND. oXbp != ::oLastTipXBP )
         ::hideTip()
         ::oLastMotionXBP  := oXbp
         ::aLastMotionPos  := AClone(mp1)
         nLastMotionTime := Seconds()
         IF( ::nLastTipTime>0 .AND. (Seconds()-::nLastTipTime)<=0.5 )
           // IF oXbp:isderivedFrom("XbpCellGroup")
           //  ::nLastCellPos := oXbp:cellFromPos(mp1)
           // ENDIF
           ::showTip(oXbp)
         ENDIF
       ELSE
         ::oLastMotionXBP  := oXbp
         ::aLastMotionPos  := AClone(mp1)
         nLastMotionTime   := Seconds()
         ::hideTip()
       ENDIF
     ELSEIF nEvent != xbeP_Paint .AND. Valtype(oXbp)='O'
       IF(oXbp==::oLastTipXBP .AND. !oXbp:isDerivedFrom("XbpCellGroup"))
         ::oBlockedXBP    := oXbp
       ENDIF
       ::oLastMotionXBP := NIL
       ::hideTip()
     ENDIF

     ::checkTermination()

  ENDDO

RETURN

* --------------------

METHOD MagicHelp:showTip()

  IF(!::lTipIsShown)
    ::DisplayToolTip(::oLastMotionXBP)
    IF Valtype(::oTip) = 'O'
      ::oTip:show()
      ::lTipIsShown  := .T.
      ::oLastTipXBP  := ::oLastMotionXBP
      ::nLastShowTime := Seconds()
    ELSEIF !::oLastMotionXBP:isDerivedFrom("XbpCellGroup")
      ::lTipIsShown  := .F.
      ::oLastTipXBP  := nil
    ELSEIF !::oLastMotionXBP:isDerivedFrom("XbpScrollBar")
      ::lTipIsShown  := .F.
      ::oLastTipXBP  := nil
    ENDIF
    ::oBlockedXBP := NIL
  ENDIF
RETURN

* --------------------

METHOD MagicHelp:hideTip()
  IF(::lTipIsShown)
    // ::oTip:hide()
    IF ::oTip:status() > 0
      ::oTip:destroy()
    ENDIF
    ::lTipIsShown := .F.
    ::nLastTipTime := Seconds()
  ENDIF
RETURN

* --------------------

METHOD MagicHelp:terminate

RETURN ( ::terminated := .T. )

* --------------------

METHOD MagicHelp:checkTermination
IF ::terminated
  ::hideTip()
  ::terminated := .F.
  ::quit()
  Sleep(5)
ENDIF
RETURN self

* --------------------

METHOD MagicHelp:DisplayToolTip(oXbpRequestingHint)

LOCAL cText := "(nil)"
LOCAL aPos
LOCAL oHelpLink
LOCAL cFont, nColorFG, nColorBG, nDelayTime
LOCAL aMax  := Dc_DeskTopSize()                       // J. Duijf 02-01-2006

IF oXbpRequestingHint:isDerivedFrom('XbpCrt')
  RETURN self
ENDIF
aPos  := DC_CalcAbsolutePosition(::aLastMotionPos,oXbpRequestingHint)
IF aPos[1] > aMax[1]                                  // J. Duijf 02-01-2006
  aPos[1] := aMax[1]                                  // Maximum horizontal position of tooltip
ENDIF
IF aPos[2] > aMax[2]                                  // Maximum vertical position of tooltip
  aPos[2] := aMax[2]
ENDIF
//IF aPos[1] > 2000
//  aPos[1] := 2000
//ENDIF
//IF aPos[2] > 2000
//  aPos[2] := 2000
//ENDIF
aPos[1] += 6
aPos[2] -= 16
oHelpLink := DC_GetHelpLink(oXbpRequestingHint,DCGUI_HELP_TOOLTIP)

IF (ValType(oHelpLink)=="O" .AND. oHelpLink:isDerivedFrom("MagicHelpLabel")) ;
    .OR. DC_ToolTipShowSource()

  IF Valtype(oHelpLink) == 'O'
    cText := oHelpLink:getToolTip()
  ELSE
    cText := ''
  ENDIF

  IF !Empty(cText)
    IF Valtype(cText) = 'A'
      ASize(cText,5)
      cFont := cText[2]
      nColorFG := cText[3]
      IF Valtype(nColorFG) == 'A'
        nColorFG := GraMakeRGBColor(nColorFG)
      ENDIF
      nColorBG := cText[4]
      IF Valtype(nColorBG) == 'A'
        nColorBG := GraMakeRGBColor(nColorBG)
      ENDIF
      nDelayTime := cText[5]
      cText := cText[1]
    ENDIF
    IF Valtype(cText) = 'B'
      cText := DC_XtoC(Eval(cText,oXbpRequestingHint))
      IF cText == nil
        RETURN self
      ENDIF
     elseif ValType(cText) = "N"
      cText := alltrim(str(cText))
     elseif ValType(cText) = "D"
      cText := dtoc(cText)
     elseif ValType(cText) = "L"
      cText := if(cText,"TRUE","FALSE")
    ENDIF
  ENDIF
  IF DC_ToolTipShowSource()
    IF !Empty(cText)
       cText += Chr(13)+Chr(13)
    ENDIF
    cText += DC_ShowSourceCode(oXbpRequestingHint)
  ENDIF
ENDIF

IF cText == '(nil)' .AND. oXbpRequestingHint:isDerivedFrom('XbpCellGroup') .AND. ;
   Valtype(oXbpRequestingHint:cargo) = 'A' .AND. Len(oXbpRequestingHint:cargo) >= 3 .AND. ;
   !Empty(oXbpRequestingHint:cargo[3])
  cText := oXbpRequestingHint:cargo[3]
ELSEIF cText == '(nil)' .AND. oXbpRequestingHint:isDerivedFrom('XbpScrollBar') .AND. ;
   Valtype(oXbpRequestingHint:cargo) = 'A' .AND. Len(oXbpRequestingHint:cargo) >= 3 .AND. ;
   !Empty(oXbpRequestingHint:cargo[3])
  cText := oXbpRequestingHint:cargo[3]
ENDIF

IF (Valtype(cText) $ 'CM' .AND. ( cText # '(nil)' .AND. !Empty(cText) )) .OR. ;
    Valtype(cText) == 'O'
  ::oTip := XbpStatic():new()
  ::oTip:options := XBPSTATIC_TYPE_FGNDFRAME
  ::oTip:create(AppDesktop(),AppDesktop(), aPos, { 0 , 0 })
  IF Empty(cFont) .AND. !Empty(::cToolFont)
    cFont := ::cToolFont
  ENDIF
  IF Valtype(cFont) == 'C'
    ::oTip:setFontCompoundName(cFont)
  ELSEIF Valtype(cFont) == 'O'
    ::oTip:setFont(cFont)
  ENDIF
  ::oTip:cargo := { cText, cFont, nColorFG, nColorBG, nDelayTime }
  ::PaintTheTip(cText)
ELSE
  ::oTip := nil
ENDIF
RETURN(SELF)

* --------------------

METHOD MagicHelp:PaintTheTip(cText)

LOCAL aAttr, oPS, aText, i, nOffset, aPoints, aSize, oBitMap, ;
      aOrigPos := ::oTip:currentPos(), nMaxWidth, aMaxSize, aPos

IF Valtype(cText) = 'O' .AND. cText:isDerivedFrom('XbpBitMap')

  oBitMap := cText
  aSize := {oBitMap:xSize,oBitMap:ySize }
  aPos := {aOrigPos[1]+15,aOrigPos[2]+10-aSize[2]}

  aMaxSize     := DC_DeskTopSize()

  nMaxWidth    := aMaxSize[1]
  IF aPos[1] + aSize[1] > aMaxSize[1]
    aPos[1] := aMaxSize[1] - aSize[1]
  ENDIF
  IF aPos[2] < 0
    aPos[2] := 0
  ENDIF

  ::oTip:setPos(aPos)
  ::oTip:setSize(aSize,.F.)

  oPS := ::oTip:lockPS()
  oBitMap:draw( oPS )

ELSE

  oPS := ::oTip:lockPS()

  cText := Strtran(cText,';',Chr(13)+Chr(10))
  cText := Strtran(cText,'<%059>',';')
  aText := DC_TokenArray(cText,Chr(13)+Chr(10))
  aSize := { 0,0 }

  FOR i := 1 TO Len(aText)
    aPoints := GraQueryTextBox( oPS, aText[i] )
    aSize[1] := Max(aSize[1],(aPoints[3,1] - aPoints[1,1]) + 8 ) // width
  NEXT

  IF aPoints == nil
    ::oTip:unLockPS( oPS)
    RETURN(SELF)
  ENDIF

  aSize[2] := ((aPoints[1,2] - aPoints[2,2]) * Len(aText)) + 4 // height

  ::oTip:setPos({::oTip:currentPos()[1], ;
                 ::oTip:currentPos()[2]-aSize[2]})

  ::oTip:unlockPS()

  aMaxSize     := DC_DeskTopSize()                    // J. Duijf 02-01-2006
  nMaxWidth    := aMaxSize[1]

  IF ::oTip:currentPos()[1] + aSize[1] > aMaxSize[1] .AND. ::oTip:currentPos()[1] < aMaxSize[1]
     ::oTip:setPos( { aMaxSize[1] - aSize[1], ;
                      ::oTip:currentPos()[2] - aSize[2] } )
  ENDIF

  IF ::oTip:currentPos()[2] < 0
    ::oTip:setPos( { ::oTip:currentPos()[1], 0 } )
  ENDIF

  ::oTip:setSize(aSize,.F.)
  oPS := ::oTip:lockPS()

  DEFAULT ::oTip:cargo[3] := ::aToolColor[1], ;
          ::oTip:cargo[4] := ::aToolColor[2]

  aAttr := Array( GRA_AA_COUNT )
  aAttr [ GRA_AA_COLOR ] := ::oTip:cargo[4]
  GraSetAttrArea( oPS, aAttr )
  GraBox( oPS, { 1, 1}, { aSize[ 1] + 4, aSize[ 2] + 4}, GRA_FILL)

  aAttr := Array( GRA_AS_COUNT )
  aAttr [ GRA_AS_COLOR ] := ::oTip:cargo[3]
  GraSetAttrString( oPS, aAttr )
  GraBox( oPS, {0,0}, {aSize[1] - 1, aSize[2] - 1})

  nOffset := 0
  FOR i := Len(aText) TO 1 STEP -1
    GraStringAt( oPS, {4,4+nOffset}, aText[i])
    nOffset += (aPoints[1,2] - aPoints[2,2])
  NEXT

ENDIF

::oTip:unLockPS( oPS)
RETURN(SELF)

* --------------------

CLASS MagicHelpLabel

  CLASS VAR nLangID
  VAR nID
  VAR bcToolTip

  INLINE CLASS METHOD initClass()
   ::nLangID := 1
  RETURN

  INLINE METHOD init(nID,bcToolTip)
     ::nID := nID
     ::bcToolTip := bcToolTip
  RETURN

  EXPORTED:
  INLINE CLASS METHOD setLanguage(nID)
     ::nLangID := nID
  RETURN

  INLINE METHOD getID()
  RETURN ::nID

  INLINE METHOD getToolTip()
  RETURN ::bcToolTip

ENDCLASS

* --------------------

FUNCTION DC_CalcAbsolutePosition(aPos,oXbp,oTop)

   LOCAL aAbsPos, oParent := oXbp

   DEFAULT oTop := AppDeskTop()
   DEFAULT aPos := {0,0}

   aAbsPos := AClone(aPos)

   DO WHILE oParent <> oTop // .AND. !(oParent:isDerivedFrom('XbpCrt'))
      IF !oParent:isderivedFrom('XbpCellGroup') .OR. Val(Version(3)) >= 330 // Xbase 1.9
        aAbsPos[1] += oParent:currentPos()[1]
        aAbsPos[2] += oParent:currentPos()[2]
      ENDIF
      oParent := oParent:setParent()
      IF Valtype(oParent) # 'O'
        EXIT
      ENDIF
   ENDDO

RETURN(aAbsPos)

* ---------------------

FUNCTION DC_SetHelpLink( helpLink, nMode, oHelp, oHelpObject )

IF Valtype(helpLink) = 'A'
   ASize(helpLink,3)
ELSE
   helpLink := Array(3)
ENDIF

helpLink[nMode] := oHelp
IF Valtype(oHelpObject) = 'O'
   helpLink[nMode] := oHelp
   oHelp:helpObject := oHelpObject
ELSEIF Valtype(oHelpObject) = 'B'
   helpLink[nMode] := oHelpObject
ENDIF

RETURN helpLink

* ---------------------

FUNCTION DC_GetHelpLink( oXbp, nMode )

IF Valtype(oXbp:helpLink) = 'O'
  RETURN oXbp:helpLink
ELSEIF Valtype(oXbp:helpLink) = 'A'
   ASize(oXbp:helpLink,3)
ELSE
   oXbp:helpLink := Array(3)
ENDIF

RETURN oXbp:helpLink[nMode]

* ----------------------

FUNCTION DC_AddSetKeys( GetList )

LOCAL nInkey, nKey, bKey

IF Valtype(GetList) # 'A'
  GetList := {}
ENDIF

FOR nInkey := -47 TO 421
  bKey := SetKey( nInkey )
  IF VALTYPE(bKey) = 'B'
    nKey := DC_KeyTran(nInkey,2)
    DCHOTKEY nKey ACTION bKey
  ENDIF
NEXT

RETURN GetList

* -----------------------

FUNCTION DC_CascadeCoords( oParent, lTextBased, aDefault, lTranslate, oExclude )

LOCAL nTop, nLeft, i, j, aChildList, aChildChildList, oXbp, ;
      lSiblingFound, nBottom

DEFAULT lTextBased := .f., ;
        lTranslate := .t.

IF Valtype(oParent) # 'O'
   oParent := AppDeskTop()
ENDIF

IF Valtype(aDefault) # 'A'
  aDefault := {0,0}
ENDIF

aChildList := oParent:childlist()

IF Empty(aChildList)
  RETURN aDefault
ENDIF

IF lTextBased
  nTop := 0
ELSE
  nTop := oParent:currentSize()[2]
ENDIF
nLeft := 0
lSiblingFound := .f.

FOR i := 1 TO Len(aChildList)

   oXbp := aChildList[i]
   IF Valtype(oExclude) = 'O' .AND. oXbp == oExclude
     LOOP
   ELSEIF Valtype(oExclude) = 'A' .AND. AScan( oExclude, oXbp ) > 0
     LOOP
   ELSEIF !oXbp:isVisible()
     LOOP
   ELSEIF oXbp:isderivedFrom('XBPDIALOG') .AND. !oXbp:titleBar
     LOOP
   ELSEIF oXbp:isderivedFrom('XBPDIALOG') .AND. oXbp:getFrameState() # XBPDLG_FRAMESTAT_NORMALIZED
     LOOP
   ELSEIF oXbp:isderivedFrom('XBPMENUBAR') .OR. oXbp:isderivedFrom('XBPCRT')
     LOOP
   ELSEIF oXbp:isderivedFrom('XBPIWINDOW')
     aChildChildList := oXbp:childList()
     FOR j := 1 TO Len(aChildChildList)
       oXbp := aChildChildList[j]
       IF !oXbp:isVisible()
         LOOP
       ELSEIF oXbp:isderivedFrom('XBPDIALOG') .AND. oXbp:getFrameState() # XBPDLG_FRAMESTAT_NORMALIZED
         LOOP
       ENDIF
       IF lTextBased
         nTop := Max(nTop,oXbp:SetParent():currentSize()[2]-(oXbp:CurrentPos()[2]+oXbp:CurrentSize()[2]))
         nBottom := nTop - oXbp:currentSize()[2]
       ELSE
         nTop := Min(nTop,oXbp:CurrentPos()[2]+oXbp:CurrentSize()[2])
         nBottom := oXbp:currentSize()[2]
       ENDIF
       nLeft := oXbp:CurrentPos()[1]
       lSiblingFound := .t.
     NEXT

   ELSEIF !oXbp:isDerivedFrom('XbpDialog')

      LOOP

   ELSE

     IF lTextBased
       nTop := Max(nTop,oXbp:SetParent():currentSize()[2]-(oXbp:CurrentPos()[2]+oXbp:CurrentSize()[2]))
       nBottom := nTop - oXbp:currentSize()[2]
     ELSE
       nTop := Min(nTop,oXbp:CurrentPos()[2]+oXbp:CurrentSize()[2])
       nBottom := oXbp:currentSize()[2]
     ENDIF
     nLeft := oXbp:CurrentPos()[1]
     lSiblingFound := .t.

   ENDIF

NEXT

IF lSiblingFound
  IF lTranslate
    IF lTextBased
      nTop += 25
    ELSE
      nTop -= 25
    ENDIF
    nLeft += 25
  ELSE
    nTop := nBottom - 25
    nLeft += 25
  ENDIF
ELSE
  nTop := aDefault[1]
  nLeft := aDefault[2]
ENDIF

IF lTextBased
  nTop /= 20
  nLeft /= 7
ENDIF

RETURN { nTop, nLeft }

* --------------

FUNCTION DC_FieldWBlock( cFieldName, xDataSource, bFormat, aStru )

LOCAL cAlias, bGetSet, oCol, nLen, nDec, cDataType := Valtype(xDataSource), ;
      cType, xValue, nPos

IF xDataSource == NIL .OR. cDataType == 'C' // alias

  IF xDataSource == NIL
    cAlias := Alias()
  ELSE
    cAlias := xDataSource
  ENDIF

  IF Empty(aStru)
    aStru := (cAlias)->(dbStruct())
  ENDIF

  nPos := (cAlias)->(FieldPos( cFieldName ))
  cType := aStru[nPos,2]
  nLen := aStru[nPos,3]
  IF cType $ 'CMT'
    xValue := "Space(" + Alltrim(Str(nLen)) + ")"
  ELSEIF cType $ 'NI'
    xValue := "0"
  ELSEIF cType == 'D'
    xValue := "Ctod('')"
  ELSEIF cType == 'L'
    xValue := ".f."
  ELSE
    xValue := "''"
  ENDIF

  IF '->' $ cFieldName

    bGetSet :=  &( '{|x|IIF(x==NIL .OR. x==' + cFieldName + ',' + ;
                'IsNull(' + cFieldName +',' + xValue + '),' + cFieldName + ':=x)}' )
  ELSE

    bGetSet := &( '{|x|IIF(x==NIL .OR. x==' + cAlias + '->' + cFieldName + ',' + ;
           'IsNull(' + cAlias + '->' + cFieldName + ',' + xValue + '),' + cAlias + '->' + cFieldName + ':=x)}' )

  ENDIF

ELSEIF cDataType == 'N' // ADS SQL cursor

   bGetSet := DC_AdsFieldBlock( xDataSource, cFieldName, bFormat )

ELSEIF cDataType == 'O' // SQLexpress cursor

  oCol := xDataSource:getSQLColumn(cFieldName)
  nLen := oCol:length

  IF oCol:ValType == "C"

    bGetSet := {|x|if(PCount()==0,PadR(xDataSource:fieldGet(cFieldName),nLen),;
                  xDataSource:fieldPut(cFieldName,Trim(x)))}

  ELSEIF oCol:ValType == "N"

    nDec := oCol:decimals

    bGetSet := {|x|if(PCount()==0,Str(xDataSource:fieldGet(cFieldName),nLen,nDec),;
                  xDataSource:fieldPut(cFieldName,val(x)))}

  ELSE

    bGetSet := {|x|if(PCount()==0,xDataSource:fieldGet(cFieldName),;
               xDataSource:fieldPut(cFieldName,x))}

  ENDIF

ENDIF

RETURN bGetSet

* ------------------

FUNCTION DC_FieldWDebug( lDebug, cField, lWriteOnly )

STATIC slDebug := .f., scField := '', slWriteOnly := .t.

IF Valtype(cField) = 'C'
   scField := cField
ELSE
   cField := scField
ENDIF
IF Valtype(lDebug) = 'L'
   slDebug := lDebug
ENDIF
IF Valtype(lWriteOnly) = 'L'
   slWriteOnly := lWriteOnly
ELSE
   lWriteOnly := slWriteOnly
ENDIF

RETURN slDebug

* ------------------

FUNCTION DC_FieldWDisplay( x, xFieldName, cAlias, cFieldName )

LOCAL cField, lWriteOnly
DC_FieldWDebug( nil, @cField, @lWriteOnly )

IF lWriteOnly .AND. x == NIL
  RETURN nil
ENDIF

IF Empty(cField) .OR. Empty(cFieldName) .OR. Upper(cField) == Upper(cFieldName)
  DC_Qout({x,xFieldName,cAlias,cFieldName})
  DC_QoutCallStack(5)
  DC_Qout(dbrLockList())
ENDIF

RETURN  nil

* ------------------

FUNCTION DC_PopFile( cFileName, cDirectory, cWildCard, cTitle, aFileFilter, ;
                     lSaveAs, lRestoreDir, lMultiple, oParent, oOwner )

LOCAL oXbp, cNewFile, nLength

DEFAULT cFileName := '', ;
        cDirectory := '', ;
        cWildCard := '*.*', ;
        cTitle    := '', ;
        aFileFilter := {}, ;
        lSaveAs := .F., ;
        lRestoreDir := .T.,;
        lMultiple := .F.

oXbp := XbpFileDialog():new( oParent, oOwner )
oXbp:center := .T.
oXbp:restoreDir := lRestoreDir

IF !Empty(cTitle)
   oXbp:Title := cTitle
ENDIF

IF Valtype(aFileFilter)='A'
   oXbp:fileFilters := aFileFilter
ENDIF

oXbp:create(,SetAppWindow())

nLength := Len(cFileName)

IF Empty(cFileName) .AND. (!Empty(cDirectory) .OR. !Empty(cWildCard))
  IF !Empty(cDirectory) .AND. Right(cDirectory,1) # '\'
    cDirectory += '\'
  ENDIF
  cFileName := cDirectory + cWildCard
ELSE
  IF !Empty(cDirectory) .AND. Right(cDirectory,1) # '\'
    cDirectory += '\'
  ENDIF
  cFileName := cDirectory + cFileName
ENDIF

IF lSaveAs
  cNewFile := oXbp:saveAs( Alltrim(cFileName),.t. )
ELSE
  cNewFile := oXbp:open( Alltrim(cFileName),.t.,lMultiple,.t. )        // Modified S.B.Drakos 6/29/2005 0:27AM
ENDIF

oXbp:destroy()

IF Empty(cNewFile)
  RETURN cFileName
ELSE
  //cNewFile := StrTran(cNewFile,'\:\\','\\')                          // Original
  IF ValType(cNewFile) == 'A'                                          // Added S.B.Drakos 6/29/2005 0:27AM
    AEval(cNewFile,{|a| a := StrTran(a,'\:\\','\\')})                  // ...
  ELSE                                                                 // ...
    cNewFile := StrTran(cNewFile,'\:\\','\\')                          // ...
  ENDIF                                                                // ...
ENDIF

IF nLength == 0 .OR. !Empty(cFileName)
  //nLength := Len(cNewFile)                                           // Original
  IF ValType(cNewFile) == 'A'                                          // Added S.B.Drakos 6/29/2005 0:27AM
    AEval(cNewFile,{|a| nLength := Len(a), a := Pad(a,nLength)})       // ...
  ELSE                                                                 // ...
    nLength := Len(cNewFile)                                           // ...
  ENDIF                                                                // ...

ENDIF

nLength := Max(nLength,Len(cNewFile))

RETURN IIF( ValType(cNewFile) == 'A', cNewFile, Pad(cNewFile,nLength)) // Modified S.B.Drakos 6/29/2005 0:27AM

* -----------------------

FUNCTION DC_SourceRead( cSource, nLine, nStartPos, nEndPos )

LOCAL cString := '', nSourceLine, cLine

nSourceLine := nLine

DO WHILE .t.

   cLine := Trim( MemoLine( cSource, 1024, nSourceLine ) ) + Chr(13) + Chr(10)
   IF nLine = nSourceLine
      nEndPos := MLPos( cSource, 1024, nLine + 1 )
   ENDIF

   IF Empty(Strtran(cLine,Chr(13)+Chr(10),'')) .OR. nSourceLine == 1
      EXIT
   ELSEIF Right(Trim(Strtran(cLine,Chr(13)+Chr(10),'')),1) # ';' .AND. nSourceLine # nLine
      EXIT
   ENDIF
   cString := cLine + cString
   nSourceLine--

ENDDO

nStartPos := MLPos( cSource, 1024, nSourceLine+1 )

RETURN cString

* -----------------------

FUNCTION DC_SourceWrite( cSource, cSourceLine, nStartPos, nEndPos )

LOCAL cString1 := SubStr(cSource, 1, nStartPos - 1)
LOCAL cString2 := SubStr(cSource, nEndPos)

RETURN cString1 + cSourceLine + cString2

* -----------------------

FUNCTION DC_SourceRepl( cString, nStartRow, nStartCol, nWidth, nHeight, nType, aCoords, lPixel )

LOCAL i, cOutput, lStart := .t., lGetRow := .f., lGetCol := .f.,  ;
      lGetWidth := .f., lGetHeight := .f., aTokens, lGetWidthOnly := .f., ;
      lGetHeightOnly := .f., nIndent := 0

DEFAULT lPixel := .f.

aTokens := DC_ParseArray( cString, @nIndent )

cOutput := ''

FOR i := 1 TO Len(aTokens)

  IF aTokens[i] = '@' .AND. lStart

    lStart := .f.
    lGetRow := .t.

  ELSEIF lGetRow .AND. ( Val(aTokens[i]) # 0 .OR. '0' $ Alltrim(aTokens[i]) )

    lGetRow := .f.
    lGetCol := .t.
    IF aCoords[3] # aCoords[4] .OR. aCoords[7] # aCoords[8]
      aTokens[i] := Alltrim(Str(nStartRow,6,IIF(lPixel,0,2))) + IIF( Chr(13)+Chr(10) $ aTokens[i], Chr(13)+Chr(10), '' )
    ENDIF

  ELSEIF lGetCol .AND. ( Val(aTokens[i]) # 0 .OR. '0' $ Alltrim(aTokens[i]) )

    lGetCol := .f.

    IF aCoords[1] # aCoords[2]
      aTokens[i] := Alltrim(Str(nStartCol,6,IIF(lPixel,0,2))) + IIF( Chr(13)+Chr(10) $ aTokens[i], Chr(13)+Chr(10), '' )
    ENDIF

  ELSEIF lGetWidth .AND. ( Val(aTokens[i]) # 0 .OR. '0' $ Alltrim(aTokens[i]) )

    lGetWidth := .f.
    lGetHeight := .t.
    IF aCoords[5] # aCoords[6]
      aTokens[i] := Alltrim(Str(nWidth,6,IIF(lPixel,0,2))) + IIF( Chr(13)+Chr(10) $ aTokens[i], Chr(13)+Chr(10), '' )
    ENDIF

  ELSEIF lGetWidthOnly .AND. ( Val(aTokens[i]) # 0 .OR. '0' $ Alltrim(aTokens[i]) )

    lGetWidthOnly := .f.
    IF aCoords[5] # aCoords[6]
      aTokens[i] := Alltrim(Str(nWidth,6,IIF(lPixel,0,2))) + IIF( Chr(13)+Chr(10) $ aTokens[i], Chr(13)+Chr(10), '' )
    ENDIF

  ELSEIF lGetHeight .AND. ( Val(aTokens[i]) # 0 .OR. '0' $ Alltrim(aTokens[i]) )

    lGetWidth := .f.
    lGetHeight := .f.
    IF aCoords[7] # aCoords[8]
      aTokens[i] := Alltrim(Str(nHeight,6,IIF(lPixel,0,2))) + IIF( Chr(13)+Chr(10) $ aTokens[i], Chr(13)+Chr(10), '' )
    ENDIF

  ELSEIF lGetHeightOnly .AND. ( Val(aTokens[i]) # 0 .OR. '0' $ Alltrim(aTokens[i]) )

    lGetHeightOnly := .f.
    IF aCoords[7] # aCoords[8]
      aTokens[i] := Alltrim(Str(nHeight,6,IIF(lPixel,0,2))) + IIF( Chr(13)+Chr(10) $ aTokens[i], Chr(13)+Chr(10), '' )
    ENDIF

  ELSEIF Alltrim(Upper(aTokens[i])) == 'GETSIZE' .AND. nType == GETLIST_GET

    lGetWidth := .t.

  ELSEIF Alltrim(Upper(aTokens[i])) == 'SAYSIZE' .AND. nType == GETLIST_SAY

    lGetWidth := .t.

  ELSEIF Alltrim(Upper(aTokens[i])) == 'SIZE'

    lGetWidth := .t.

  ELSEIF Alltrim(Upper(aTokens[i])) == 'WIDTH'

    lGetWidthOnly := .t.

  ELSEIF Alltrim(Upper(aTokens[i])) == 'HEIGHT'

    lGetHeightOnly := .t.

  ELSEIF Alltrim(aTokens[i]) # ',' .AND. !Empty(aTokens[i])

    IF lGetHeight
      cOutput  := Trim(cOutput) + ', ' + Alltrim(Str(nHeight)) + ' '
    ENDIF
    lGetWidth := .f.
    lGetHeight := .f.
    lGetRow := .f.
    lGetCol := .f.
  ENDIF
  cOutput += aTokens[i]

NEXT

IF nType == GETLIST_GET .AND. AScan(aTokens,{|a|Upper(Alltrim(a)) == 'GETSIZE'}) = 0  ;
      .AND. ( aCoords[5] # aCoords[6] .OR. aCoords[7] # aCoords[8] )

   cOutput := SubStr(cOutput,1,Len(cOutput)-2) + ;
              ' GETSIZE ' + Alltrim(Str(nWidth)) + ', ' + Alltrim(Str(nHeight)) + Chr(13) + Chr(10)

ELSEIF nType == GETLIST_SAY .AND. AScan(aTokens,{|a|Upper(Alltrim(a)) == 'SAYSIZE'}) = 0 ;
      .AND. ( aCoords[5] # aCoords[6] .OR. aCoords[7] # aCoords[8] )

   cOutput := SubStr(cOutput,1,Len(cOutput)-2) + ;
              ' SAYSIZE ' + Alltrim(Str(nWidth)) + ', ' + Alltrim(Str(nHeight)) + Chr(13) + Chr(10)

ENDIF

cOutput := Space(nIndent) + cOutput

RETURN cOutput

* --------------------

FUNCTION DC_ParseArray( cString, nIndent )

LOCAL cStartDelims := "'({[" + '"'
LOCAL cEndDelims   := "')}]" + '"' + Chr(10) + ';'
LOCAL cChar, cEnd
LOCAL nLen, nStart
LOCAL i, nFound
LOCAL aParse := {}
LOCAL lStart := .t.
LOCAL lStartSpace := .f.

nIndent := 0
nLen := Len(cString)
nStart := 1
FOR i := 1 TO nLen
  cChar := Substr(cString,i,1)
  IF lStart .AND. (cChar = ' ' .OR. cChar = Chr(K_TAB))
    nStart++
    nIndent++
    LOOP
  ELSEIF cChar = '@' .AND. lStart
    lStart := .f.
    IF Substr(cString,i+1,1) # ' '
      AAdd( aParse, '@' )
      nStart := i + 1
    ENDIF
  ELSEIF cChar $ cStartDelims
    cEnd := SubStr(cEndDelims,AT(cChar,cStartDelims),1)
    nFound := At(cEnd,cString,i+1)
    IF nFound > 0
       i := nFound
    ELSE
       EXIT
    ENDIF
    lStartSpace := .f.
  ELSEIF cChar = ' '  .AND. !lStartSpace
    lStartSpace := .t.
    AAdd( aParse, SubStr(cString,nStart,i-nStart) )
    AAdd( aParse, ' ')
    nStart := i + 1
  ELSEIF cChar = ','
    lStartSpace := .f.
    AAdd( aParse, SubStr(cString,nStart,i-nStart) )
    AAdd( aParse,',')
    nStart := i+1
  ELSEIF cChar = Chr(13)
    AAdd( aParse, SubStr(cString,nStart,i-nStart) )
    AAdd( aParse, Chr(13) + Chr(10))
    nStart := i+2
  ELSEIF cChar # ' '
    lStart := .f.
    lStartSpace := .f.
  ENDIF
NEXT

AAdd( aParse, SubStr(cString,nStart,nLen) )

RETURN aParse

* -----------------------

FUNCTION DC_PopDir( cDirectory, cAvailDrives, cExcludeDrives, cWildCard )

LOCAL GetList := {}, oDirs, cSaveDir := cDirectory, oFiles, cFile, lOk, ;
      GetOptions, cCurPath := DC_CurPath(), oStatic

DEFAULT cDirectory := '', ;
        cWildCard := '*.*'

IF !Empty(cDirectory)
  DC_ChDir(Alltrim(cDirectory))
ENDIF

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 50,8 OBJECT oStatic

cFile := ''
@ 0,0 DCDIRTREE ;
    DIRS oDirs VAR cDirectory ;
    FILES oFiles VAR cFile ;
    SIZE 50,8 ;
    PARENT oStatic ;
    EXT cWildCard ;
    TITLE DCMSG_DIR_CHOOSE ;
    AVAILDRIVES cAvailDrives ;
    EXCLUDEDRIVES cExcludeDrives

DCGETOPTIONS AUTORESIZE

DCREAD GUI ;
   EXPRESS ;
   FIT ;
   ADDBUTTONS ;
   MODAL ;
   TO lOk ;
   TITLE DC_LangMsg(DCMSG_DIR_CHOOSE) ;
   OPTIONS GetOptions ;
   ;// EVAL {||oDirs:dirTree:itemSelected := {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} }

DC_ChDir(cCurPath)

IF !lOk
  RETURN cSaveDir
ENDIF

RETURN cDirectory

* -----------------------

FUNCTION DC_DisplayTabStops( oParent, nLevel, cString )

LOCAL oXbp, i, aChildren := oParent:childList(), GetList := {}
DEFAULT nLevel := 0, cString := ''

FOR i := 1 TO Len(aChildren)
  oXbp := aChildren[i]
  IF IsMemberVar(oXbp,'TABSTOP')
    cString += Space(nLevel) + IIF( oXbp:tabstop,'YES','NO ') + ' ' + oXbp:classname() + Chr(13) + Chr(10)
  ENDIF
  DC_DisplayTabStops(oXbp,nLevel+2,@cString)
NEXT

IF nLevel = 0
  @ 0,0 DCMULTILINE cString SIZE 50,20 FONT '10.Courier'
  DCREAD GUI ;
   EXPRESS ;
   FIT ;
   ADDBUTTONS ;
   MODAL ;
   TITLE 'Display Tabstops in Dialog Tree'
ENDIF

RETURN nil

* ------------------------

FUNCTION DC_GraQueryTextBox( cCaption, cFont, nOption, nMode )

LOCAL oXbp , aArray, nWidth, nHeight

DEFAULT nMode := 2

oXbp := XbpStatic():new(AppDeskTop())
IF Valtype(nOption) == 'N'
  oXbp:option := nOption
ENDIF

IF nMode == 1
  oXbp:create()
ENDIF

IF Valtype(cFont) = 'C'
  oXbp:setFontCompoundName(cFont)
ENDIF

IF nMode == 2
  oXbp:create()
ENDIF

aArray := GraQueryTextBox( oXbp:lockPS(), cCaption )
nWidth := aArray[3,1] - aArray[1,1] // width
nHeight := aArray[1,2] - aArray[2,2] // height
oXbp:unlockPS()
oXbp:destroy()

RETURN {nWidth, nHeight}

* ------------------------

FUNCTION DC_MakeBlock( xData )
RETURN {||xData}

* ------------------------

FUNCTION DC_SetAppFocus( oXbp )

LOCAL aTabPages := {}, oParent, i

oParent := oXbp
DO WHILE .t.
  oParent := oParent:setParent()
  IF Valtype(oParent) # 'O'
    EXIT
  ELSEIF oParent:isDerivedFrom('XbpTabPage')
    AAdd(aTabPages,oParent)
  ENDIF
ENDDO

FOR i := Len(aTabPages) TO 1 STEP -1
  IF aTabPages[i]:minimized
    DC_TabActivate(aTabPages[i])
  ENDIF
NEXT

RETURN SetAppFocus( oXbp )

* ------------------------

FUNCTION DC_TabActivate( oTabPage, lCompleteEvents)

LOCAL nRow, nCol, aChildList, oXbp, i

DEFAULT lCompleteEvents := .f.

IF !oTabPage:isDerivedFrom('XbpTabPage')
  RETURN nil
ENDIF

nCol := oTabPage:currentPos()[1]
nRow := oTabPage:currentPos()[2]

aChildList := oTabPage:setParent():ChildList()

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  IF oXbp:isderivedFrom('XbpTabPage') .AND. oXbp:currentPos()[1] == nCol ;
      .AND. oXbp:currentPos()[2] == nRow
    oXbp:minimize()
  ENDIF
NEXT
oTabPage:maximize()
PostAppEvent(xbeP_SetInputFocus,,,oTabPage)

IF lCompleteEvents
  DC_CompleteEvents()
ENDIF

RETURN nil

* ---------------------

FUNCTION DC_CrtWindow( cTitle, cColorString, oParent, oOwner, aOptions, lModal, lSuspend )

LOCAL oCrtWindow, cSaveColor, oThread, lSuspended := .f.

DEFAULT cTitle := 'eXPress++ Crt Window', ;
        cColorString := '', ;
        aOptions := {}, ;
        lModal := Empty(oParent), ;
        lSuspend := .t.

lSuspend := .f.

ASize(aOptions,7)

DEFAULT aOptions[1] := 8, ;
        aOptions[2] := 12, ;
        aOptions[3] := "Alaska Crt", ;
        aOptions[4] := DC_IconDefault(), ;
        aOptions[5] := 25, ;
        aOptions[6] := 80

DEFAULT oParent := AppDesktop ( SetAppWindow() )
DEFAULT oOwner  := SetAppWindow() // oParent

oCrtWindow := XbpCrt():New( oParent, oOwner, { 0, 0 }, aOptions[5], aOptions[6], cTitle, .f. )
oCrtWindow:FontWidth  := aOptions[1]
oCrtWindow:FontHeight := aOptions[2]
oCrtWindow:FontName   := Alltrim(aOptions[3])
oCrtWindow:icon       := aOptions[4]
IF lSuspend
  oCrtWindow:setInputFocus := {|a,b,o|SetAppWindow(o),lSuspended := .f.}
  oCrtWindow:setDisplayFocus := {|a,b,o|SetAppWindow(o),lSuspended := .f.}
ELSE
  oCrtWindow:setInputFocus := {|a,b,o|SetAppWindow(o)}
  oCrtWindow:setDisplayFocus := {|a,b,o|SetAppWindow(o)}
ENDIF
IF lSuspend
  oCrtWindow:killInputFocus := ;
        {|| lSuspended := .t., ;
          oThread := Thread():new(),;
          Sleep(10),;
          oThread:start({||_Suspend(@lSuspended)} ) }
ENDIf
oCrtWindow:close := aOptions[7]
oCrtWindow:Create()
oCrtWindow:PresSpace()
DC_CenterObject(oCrtWindow)
oCrtWindow:show()

IF lModal
  oCrtWindow:setModalState(XBP_DISP_APPMODAL)
ENDIF
SetAppWindow(oCrtWindow)
IF !Empty(cColorString)
  cSaveColor := SetColor(cColorString)
ELSE
  cSaveColor := SetColor('N/W')
ENDIF
CLS
SetColor(cSaveColor)

RETURN oCrtWindow

* ---------------

STATIC FUNCTION _Suspend( lSuspended )

// DCQQDEBUG 'Start Suspend'
DO WHILE lSuspended
  Sleep(50)
ENDDO
// DCQQDEBUG 'End Suspend'

RETURN nil

* ---------------

FUNCTION DC_CrtRun( bBlock, cTitle, cColorString, oParent, oOwner, lUnique, aOptions, ;
                    lModal, oCrt, lSuspend, lGui, bPreBlock )

LOCAL oAppWindow, lNewCrt, i, lStatus, ;
      aChildList, cBlock := DC_GetCodeBlockText(bBlock)

DEFAULT lUnique := .f., ;
        oParent := AppDeskTop(), ;
        cTitle := 'CRT', ;
        lGui := .f.

lGui := DC_Gui(lGui)

oCrt := DC_CrtRunWindow()
oAppWindow := SetAppWindow()
lNewCrt := Valtype(oCrt) # 'O' .OR. !oCrt:isDerivedFrom('XbpCrt')

IF lUnique
  aChildList := oParent:childList()
  FOR i := 1 TO Len(aChildList)
    IF aChildList[i]:isDerivedFrom('XbpCrt') .AND. Valtype(aChildList[i]:cargo)=='C' .AND. ;
       cBlock == aChildList[i]:cargo
       DC_WinAlert('Cannot run (' + cTitle + ')  program more than once!')
       RETURN .f.
    ENDIF
  NEXT
ENDIF

IF lNewCrt
  oCrt := DC_CrtWindow( cTitle, cColorString, oParent, oOwner, aOptions, lModal, lSuspend )
  oCrt:cargo := cBlock
ELSEIF Valtype(cTitle) = 'C'
  oCrt:setTitle(cTitle)
  oCrt:cargo := cBlock
ENDIF

BEGIN SEQUENCE
SetAppFocus(oCrt)
SET CURSOR ON
IF Valtype(bPreBlock) == 'B'
  Eval(bPreBlock,oCrt)
ENDIF
lStatus := Eval(bBlock,oCrt)
END SEQUENCE

IF lNewCrt
  oCrt:setModalState(XBP_DISP_MODELESS)
  oCrt:Destroy()
ENDIF
IF Valtype(oAppWindow) = 'O' .AND. oAppWindow:status() > 0
  SetAppWindow(oAppWindow)
ENDIF

IF Valtype(oParent) = 'O'
  aChildList := oParent:ChildList()
  FOR i := 1 TO Len(aChildList)
    IF aChildList[i] == SetAppFocus()
      SetAppWindow(aChildList[i])
      EXIT
    ENDIF
  NEXT
ENDIF

DC_Gui(lGui)

RETURN lStatus

* ---------------------

FUNCTION DC_CrtRunWindow( oCrt )

LOCAL oOldCrt
STATIC soCrt

oOldCrt := soCrt
IF Valtype(oCrt) = 'O'
  soCrt := oCrt
ENDIF

RETURN oOldCrt

* ---------------------

FUNCTION DC_ExeLoaded( cProgramToRun )

LOCAL aPrograms := {}, nHandle, i, cProgram

DEFAULT cProgramToRun := AppName()

nHandle := DC_TxtOpen('XPPLOAD.TXT')

IF nHandle >= 0
  DO WHILE !DC_TxtEof(nHandle)
    cProgram := Alltrim(Upper(DC_TxtLine(nHandle)))
    DC_TxtSkip(nHandle,1)
    IF Empty(cProgram)
      EXIT
    ELSEIF cProgram == cProgramToRun
      LOOP
    ENDIF
    AAdd(aPrograms,Alltrim(Upper(cProgram)))
  ENDDO
  FClose(nHandle)
  IF Empty(aPrograms)
    FErase('XPPLOAD.TXT')
  ELSE
    nHandle := FCreate('XPPLOAD.TXT')
    IF nHandle >= 0
      FOR i := 1 TO Len(aPrograms)
        FWrite(nHandle,aPrograms[i]+Chr(13)+Chr(10))
      NEXT
      FClose(nHandle)
    ENDIF
  ENDIF
ENDIF

RETURN .t.

* -----------------

DLLFUNCTION SystemParametersInfoA( nAction, nParam1, @Param2, nWinIni ) ;
  USING STDCALL FROM USER32.DLL

DLLFUNCTION GetDC( hWnd ) USING STDCALL FROM USER32.DLL

/*
o := SetAppwindow()
h := getDc(o:getHwnd())

? getdevicecaps(h,90)
*/

* ----------------

FUNCTION DC_GetWorkArea()

LOCAL cBuffer := SPACE(32)
LOCAL aRet := ARRAY(4)

SystemParametersInfoA( SPI_GETWORKAREA, 0, @cBuffer, SPIF_SENDCHANGE )

aRet[1] := BIN2U( SUBSTR( cBuffer,  1,4 ))
aRet[2] := BIN2U( SUBSTR( cBuffer,  5,4 ))
aRet[3] := BIN2U( SUBSTR( cBuffer,  9,4 ))
aRet[4] := BIN2U( SUBSTR( cBuffer, 13,4 ))

RETURN aRet

* -----------------

FUNCTION DC_SetWorkArea( aArea )

LOCAL cBuffer := SPACE(16)

LOCAL aRet := ARRAY(4)

cBuffer := U2BIN(aArea[1]) + U2BIN(aArea[2]) + U2BIN(aArea[3]) + U2BIN(aArea[4])

SystemParametersInfoA( SPI_SETWORKAREA, 0, @cBuffer, SPIF_SENDCHANGE )

aRet[1] := BIN2U( SUBSTR( cBuffer,  1,4 ))
aRet[2] := BIN2U( SUBSTR( cBuffer,  5,4 ))
aRet[3] := BIN2U( SUBSTR( cBuffer,  9,4 ))
aRet[4] := BIN2U( SUBSTR( cBuffer, 13,4 ))

RETURN aRet

* -----------------

FUNCTION DC_GetTitleBarHeight()

RETURN GetSystemMetrics( SM_CYCAPTION )

* -----------------

FUNCTION DC_GetMenuBarHeight()

RETURN GetSystemMetrics( SM_CYMENU )

* -----------------

FUNCTION DC_GetBorderHeight()

RETURN GetSystemMetrics( SM_CYBORDER )

* -----------------

DLLFUNCTION GetSystemMetrics( nAction ) ;
  USING STDCALL FROM USER32.DLL

* -----------------

DLLFUNCTION GetDeviceCaps( nHandle, nAction ) ;
  USING STDCALL FROM GDI32.DLL

DLLFUNCTION GetComputerNameA( @cComputerName, @nLen)   USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION FindWindowA( @ClassName, @WinName )  USING STDCALL FROM USER32.DLL
DLLFUNCTION GetForegroundWindow()                USING STDCALL FROM USER32.DLL
DLLFUNCTION IsIconic( nHwnd )                    USING STDCALL FROM USER32.DLL
DLLFUNCTION GetLastActivePopup( nHwnd )          USING STDCALL FROM USER32.DLL
DLLFUNCTION ShowWindow( nHwnd, nCmdShow )        USING STDCALL FROM USER32.DLL
DLLFUNCTION BringWindowToTop( nHwnd )            USING STDCALL FROM USER32.DLL
DLLFUNCTION SetForegroundWindow( nHwnd )         USING STDCALL FROM USER32.DLL
DLLFUNCTION AllowSetForegroundWindow( nProcess ) USING STDCALL FROM USER32.DLL
DLLFUNCTION SwitchToThisWindow( nHwnd, x )       USING STDCALL FROM USER32.DLL
DLLFUNCTION SetActiveWindow( nHwnd )             USING STDCALL FROM USER32.DLL
DLLFUNCTION GetWindowThreadProcessId( nForgroundHwnd, @nRetProcId ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetWindowTextA( nHwnd,@cFileName,nLen ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetWindowModuleFileNameA( nHwnd,@cFileName,nLen ) USING STDCALL FROM USER32.DLL
DLLFUNCTION SetWindowTextA( nHwnd,@cTitle,@nLen ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetUserNameA( @cUserName, @nLen ) USING STDCALL FROM ADVAPI32.DLL
DLLFUNCTION GetUserNameExA( cFormat, @cUserName, @nLen ) USING STDCALL FROM SECUR32.DLL
DLLFUNCTION IsWindowVisible( nHwnd ) USING STDCALL FROM USER32.DLL
DLLFUNCTION NetRemoteTOD( a, @b ) USING STDCALL FROM netapi32.dll
DLLFUNCTION CLSIDFromProgID( a, @b ) USING STDCALL FROM OLE32.LIB
DLLFUNCTION GetWindowLongA( nHwnd,nIndex )     USING STDCALL FROM USER32.DLL
DLLFUNCTION SetWindowLongA( nHwnd,nIndex,nNewIndex )    USING STDCALL FROM USER32.DLL
DLLFUNCTION CopyFileA( cSource, cTarget, lOverwrite )  USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION DeleteFileA( cFileName )  USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION SetCursorPos( x, y ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetLogicalDriveStringsA( nSize, cBuffer ) USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION GetLogicalDrives() USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION CreateDirectoryA( a, b ) USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION FindWindowExA( hwndParent, hwndChildAfter, cClassName, cWindowText ) USING STDCALL FROM user32.dll
DLLFUNCTION InvalidateRect( hWnd, pRect, lErase ) USING STDCALL FROM user32.dll
DLLFUNCTION WNetGetConnectionA( @cLocalPath, @cBuffer, @nBufferSize) USING STDCALL FROM mpr.dll
DLLFUNCTION SetLayeredWindowAttributes( hWnd, crKey, bAlpha, dwFlags ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetVolumeInformationA( cRootPathName, @cVolumeNameBuffer, @nVolumeNameSize, @cVolumeSerialNumber, ;
                                  @nMaxComponentLength, @nFileSystemFlags, @cFileSystemNameBuffer, ;
                                  @nFileSystemNameSize ) USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION SetDefaultPrinterA(pPrinter) USING OSAPI FROM WINSPOOL.DRV   // thanks Phil Ide
DLLFUNCTION GetDefaultPrinterA(@pPrinter,@pwdBufferSize) USING OSAPI FROM WINSPOOL.DRV  // thanks Phil Ide
DLLFUNCTION GetModuleHandleA( cModule ) USING STDCALL FROM KERNEL32.DLL
XDLLFUNCTION SetFocusAPI(hWnd) ALIAS SetFocus USING STDCALL FROM user32.dll

DLLFUNCTION TWAIN_AcquireNative(hWnd,nPixTypes) USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_WriteNativeToFilename(hDib,sFile) USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_FreeNative(hdib) USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_AcquireToFilename(hWnd,sFile) USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_AcquireToClipboard(hWnd,nPixTypes) USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_SelectImageSource(hWnd) USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_IsAvailable() USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_OpenDefaultSource() USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_CloseSource() USING STDCALL FROM eztw32.dll
DLLFUNCTION TWAIN_SetHideUI( fHideUI ) USING STDCALL FROM eztw32.dll

DLLFUNCTION GetDiskFreeSpaceA( a, @b, @c, @d, @e ) USING STDCALL FROM KERNEL32.DLL
DLLFUNCTION GetKeyboardStateA( @a ) USING STDCALL FROM USER32.DLL
DLLFUNCTION SetKeyboardStateA( @a ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetAsyncKeyState( @a ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetKeyStateA( @a ) USING STDCALL FROM USER32.DLL

DLLFUNCTION RegOpenKeyExA(nHkeyClass, cKeyName, reserved, access, @nKeyHandle);
            USING STDCALL FROM ADVAPI32.DLL

DLLFUNCTION RegQueryValueExA(nKeyHandle, cEntry, reserved, @valueType, ;
            @cName, @nSize);
            USING STDCALL FROM ADVAPI32.DLL

DLLFUNCTION RegCloseKey( nKeyHandle );
            USING STDCALL FROM ADVAPI32.DLL

DLLFUNCTION GetPixel( nHDC, @x, @y) USING STDCALL FROM GDI32.DLL

/*
DC_IsAppRunning() was contributed by:

Alain Boucher
aboucher@acti-soft.com
*/


FUNCTION DC_IsAppRunning( cClass, cTitle, cFile, lRestore )

Local nHwndFind, nHwndForeground, nForegroundId
Local nFindId, nHwndLast
Local cWinTitle := Space(250)
Local cWinFile := Space(250)

DEFAULT lRestore := .f., ;
        cFile := ''

nHwndFind := FindWindowA( cClass, cTitle )

If nHwndFind == 0
  Return( .f. )
End

GetWindowModuleFileNameA( nHwndFind,@cWinFile,250 )
GetWindowTextA( nHwndFind,@cWinTitle,250 )

if !Upper( cTitle ) $ Upper( cWinTitle ) .and. !Upper( cFile ) $ Upper( cWinFile )
  Return( .f. )
End

if !lRestore
  Return( .t. )
End

nHwndForeground := GetForegroundWindow()
nForeGroundId   := GetWindowThreadProcessId( nHwndForeground, 0 )
nFindId         := GetWindowThreadProcessId( nHwndFind, 0 )

If !nForeGroundId == nFindId .or. !IsIconic( nHwndFind ) == 0
  nHwndLast := GetLastActivePopup( nHwndFind )
  If !IsIconic( nHwndLast ) == 0
    ShowWindow( nHwndLast, SW_RESTORE )
  End
  BringWindowToTop( nHwndLast )
  SetForegroundWindow( nHwndLast )
End

Return( .t. )

* -----------------------

FUNCTION DC_Scrn2ClipBoard( oXbp )

LOCAL oSourcePS, oBitmap, oClipBoard, aPos

IF oXbp == NIL
  keybd_event(VK_SNAPSHOT, 1, 0, 0)
  keybd_event(VK_MENU, 0, 0, 0)
  keybd_event(VK_SNAPSHOT, 0, 0, 0)
  keybd_event(VK_SNAPSHOT, 0, KEYEVENTF_KEYUP, 0)
  keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0)
ELSE
  oSourcePS := oXbp:lockPS()
  IF oXbp:isDerivedFrom('XbpDialog')
    aPos := { -4, -4 }
  ELSE
    aPos := { 0, 0 }
  ENDIF
  oBitmap := GraSaveScreen( oSourcePS, aPos, oXbp:currentSize() )
  oClipBoard := XbpClipboard():new():create()
  oClipBoard:open()
  oClipBoard:setBuffer(oBitmap)
  oClipBoard:close()
  oClipBoard:destroy()
ENDIF

RETURN nil

* -----------------------

FUNCTION DC_Scrn2ImageFile( oXbp, cFileName, nFormat )

LOCAL oSourcePS, oBitmap, oClipBoard, aPos

oSourcePS := oXbp:lockPS()
IF oXbp:isDerivedFrom('XbpDialog')
  aPos := { -4, -4 }
ELSE
  aPos := { 0, 0 }
ENDIF
oBitmap := GraSaveScreen( oSourcePS, aPos, oXbp:currentSize() )

RETURN oBitMap:saveFile( cFileName, nFormat )

* ---------------

DLLFUNCTION keybd_event(mvkey, nscan, flags, xtra) USING STDCALL FROM USER32.DLL

* -----------------------

FUNCTION DC_SetModalState( oDialog, oParent )

LOCAL nCol, nRow, nColParent, nRowParent

IF Empty(oDialog)
  oDialog := SetAppFocus()
  DO WHILE !oDialog:isDerivedFrom('XbpDialog') .AND. !oDialog==AppDeskTop()
    oDialog := oDialog:setParent()
  ENDDO
  IF oDialog == AppDeskTop()
    RETURN nil
  ENDIF
ENDIF

nCol := oDialog:currentPos()[1]+oDialog:setParent():currentPos()[1]
nRow := oDialog:currentPos()[2]+oDialog:setParent():currentPos()[2]

IF Valtype(oParent) == 'O'
  nColParent := oParent:currentPos()[1]
  nRowParent := oParent:currentPos()[2]
  oDialog:setParent( oParent )
  oDialog:setPos( { nColParent - nCol, nRowParent - nRow } )
  oDialog:setModalState(XBP_DISP_MODELESS)
ELSE
  oParent := oDialog:setParent():setParent()
  nColParent := oParent:currentPos()[1]
  nRowParent := oParent:currentPos()[2]
  oDialog:setParent( AppDeskTop() )
//  oDialog:setOwner( SetAppWindow() )
  oDialog:setPos( { nColParent + nCol, nRowParent + nRow } )
  oDialog:setModalState(XBP_DISP_APPMODAL)
  oDialog:configure()
  RETURN oParent
ENDIF

RETURN nil

* --------------

CLASS DC_SetTimerEvent FROM XbpStatic

EXPORTED:
  VAR interval, evalBlock, thread
  METHOD Init, Destroy, HandleEvent, TimerLoop

ENDCLASS

* -----------------

METHOD DC_SetTimerEvent:Init( nInterval, bEval )

::xbpStatic:init(AppDeskTop()):create()

DEFAULT nInterval := 0
IF nInterval > 0
  ::interval := nInterval
  ::evalBlock := bEval
  ::thread := Thread():new()
  Sleep(10)
  ::thread:start({||::TimerLoop()})
ENDIF

RETURN self

* ---------------

METHOD DC_SetTimerEvent:destroy()

::interval := 0
Sleep(5)
::xbpStatic:destroy()
Sleep(5)

RETURN self

* ---------------

METHOD DC_SetTimerEvent:handleEvent( nEvent, mp1, mp2 )

IF Valtype(mp1) == 'B'
  Eval(mp1)
  Grok(nEvent,mp2)
ENDIF
RETURN self

* ---------------

METHOD DC_SetTimerEvent:TimerLoop()

LOCAL nCount := -1, nSleep

DO WHILE ::interval > 0
  IF nCount >= ::interval .OR. nCount == -1
    Eval(::evalBlock)
    nCount := 0
  ENDIF
  IF ::interval < 100
    nSleep := ::interval
  ELSE
    nSleep := 100
  ENDIF
  IF ::interval <= 0
    exit
  ENDIF
  Sleep(nSleep)
  nCount += nSleep
ENDDO

RETURN nil

* ---------------

FUNCTION DC_RegionArray( nMode, nWidth, nHeight )

LOCAL i, nCropSize, aRegion := { { 0, 0, 0, 0 } }

DEFAULT nMode := 0, ;
        nWidth := 0, ;
        nHeight := nWidth

IF nMode == DCGUI_REGION_OCTAGON .OR. nMode == DCGUI_REGION_DIAMOND
  IF nMode == DCGUI_REGION_OCTAGON
    nCropSize := Int(nWidth/3.33)
  ELSE
    nCropSize := Int(nWidth/2)
  ENDIF
  FOR i := nCropSize TO 0 STEP -1
    AAdd(aRegion, {i,nCropSize-i,nWidth-i,nWidth-nCropSize+i})
  NEXT
  AAdd( aRegion, { 0, nCropSize, nWidth, nWidth-nCropSize })
  FOR i := 0 TO nCropSize
    AAdd(aRegion, {i,i+nWidth-nCropSize,nWidth-1-i,i+nWidth-nCropSize+1})
  NEXT
ELSEIF nMode == DCGUI_REGION_ELLIPSE
  RETURN { 0, 0, nWidth, nHeight }
ENDIF

RETURN aRegion

* ---------------

FUNCTION DC_ThreadStack( nThread, nMode )

LOCAL nFound

STATIC saThreadStack := {}

DEFAULT nMode := 0

nFound := AScan( saThreadStack, nThread )
IF nMode == 1 // push
  AAdd( saThreadStack, nThread )
ELSEIF nMode == 2 // pop
  IF nFound > 0
    ARemove( saThreadStack, nFound )
  ENDIF
ENDIF

RETURN saThreadStack

* ---------------

FUNCTION DC_NextAppEvent( mp1, mp2, oNextXbp )

LOCAL nEvent
LOCAL bErrorBlock

bErrorBlock := ErrorBlock({|e|_TrapError(e)}) // bug in Xbase++ sometimes causes error here
BEGIN SEQUENCE
nEvent := NextAppEvent(@mp1,@mp2,@oNextXbp)
END SEQUENCE
ErrorBlock(bErrorBlock)

RETURN nEvent

* -------------------

STATIC PROCEDURE _TrapError()
BREAK
RETURN

* ----------------

FUNCTION DC_ObjectScan( oParent, aStats )

LOCAL aChildList, i, oXbp, cClassName, nFound

DEFAULT oParent := AppDesktop(), ;
        aStats := {}

aChildList := oParent:childList()

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  cClassName := oXbp:className()
  nFound := AScan(aStats,{|a|a[1]==cClassName})
  IF nFound == 0
    AAdd(aStats,{cClassName,0,0,0,0})
    nFound := Len(aStats)
  ENDIF
  aStats[nFound,2]++
  IF IsMethod(oXbp,'isVisible') .AND. oXbp:isVisible()
    aStats[nFound,3]++
  ENDIF
  IF IsMethod(oXbp,'status') .AND. oXbp:status()>0
    aStats[nFound,4]++
  ENDIF
  DC_ObjectScan(oXbp,aStats)
NEXT

RETURN aStats

* ----------------

FUNCTION DC_ObjectReport( aStats )

LOCAL GetList[0], oBrowse, nVisible := 0, nIterations := 0, ;
      nActive := 0, i

IF Valtype(aStats) # 'A'
  aStats := DC_ObjectScan()
  ASort(aStats,,,{|x,y|x[1]<y[1]})
ENDIF

FOR i := 1 TO Len(aStats)
  nIterations += aStats[i,2]
  nVisible += aStats[i,3]
  nActive += aStats[i,4]
NEXT

@ 0,0 DCBROWSE oBrowse DATA aStats SIZE 80,20 ;
      FIT PRESENTATION DC_BrowPres() FONT '8.Courier'

DCBROWSECOL ELEMENT 1 PARENT oBrowse HEADER 'Class Name' WIDTH 20 FOOTER Chr(255)
DCBROWSECOL ELEMENT 2 PARENT oBrowse HEADER 'Iterations' WIDTH 10 ;
            FOOTER Str(nIterations,10)
DCBROWSECOL ELEMENT 3 PARENT oBrowse HEADER 'Visible' WIDTH 10 ;
            FOOTER Str(nVisible,10)
DCBROWSECOL ELEMENT 4 PARENT oBrowse HEADER 'Active' WIDTH 10 ;
            FOOTER Str(nActive,10)

DCREAD GUI FIT ADDBUTTONS TITLE 'Object Report'

RETURN nil

* ----------------

GETSETFUNCTION DC_JazzAgeKey DEFAULT "JARTKEY:Ewwz5A-6GAC1-5B39G-98D53-4"

* ----------------

FUNCTION DC_InspectThreads()

LOCAL aThreadInfo, GetList[0], oBrowse, nPointer := 1, GetOptions, ;
      cMemo := '', oMemo, i

aThreadInfo := ThreadInfo(THREADINFO_TID      + ;
                          THREADINFO_SYSTHND  + ;
                          THREADINFO_FUNCINFO + ;
                          THREADINFO_TOBJ)

FOR i := 1 TO Len(aThreadInfo)
  ASize(aThreadInfo[i],6)
  IF Valtype(aThreadInfo[i,5]) == 'O'
    aThreadInfo[i,6] := aThreadInfo[i,5]:className()
  ELSE
    aThreadInfo[i,6] := '<unknown>'
  ENDIF
NEXT

@ 1,0 DCSAY 'Double-click on item to Inspect Thread Object' SAYSIZE 0

@ 2,0 DCBROWSE oBrowse ;
      DATA aThreadInfo ;
      SIZE 40,10 ;
      PRESENTATION DC_BrowPres() ;
      HEADLINES 2 ;
      FIT ;
      FONT '8.Courier' ;
      POINTER nPointer ;
      RBSELECT ;
      RBDOWN BrowseMenuBlock(@oBrowse,aThreadInfo,@nPointer) ;
      ITEMMARKED {|oThread|cMemo := '', ;
                           oThread:=aThreadInfo[nPointer,5], ;
                           IIF(Valtype(oThread:cargo)=='O', ;
                           PostAppEvent(DCGUI_EVENT_ACTION, ;
                           {||ShowWorkArea(@cMemo),DC_GetRefresh(oMemo)},,oThread:cargo), ;
                                cMemo:='Thread cannot be viewed - cargo is not an Xbase parts object'), ;
                           DC_GetRefresh(oMemo)} ;
      ITEMSELECTED {||DC_InspectObject(aThreadInfo[nPointer,5])}

DCBROWSECOL ELEMENT 1 PARENT oBrowse HEADER 'Thread;ID' WIDTH 10 PICTURE '999'
DCBROWSECOL ELEMENT 2 PARENT oBrowse HEADER 'System;Handle' WIDTH 10 PICTURE '99999'
DCBROWSECOL ELEMENT 3 PARENT oBrowse HEADER 'Line;Number' WIDTH 10 PICTURE '9999999'
DCBROWSECOL ELEMENT 4 PARENT oBrowse HEADER 'Function' WIDTH 30
DCBROWSECOL ELEMENT 6 PARENT oBrowse HEADER 'Class Name' WIDTH 20

@ 12,0 DCMULTILINE cMemo SIZE 97,15 FONT '10.Lucida Console' ;
       OBJECT oMemo

DCGETOPTIONS AUTORESIZE _PIXEL .f.

DCREAD GUI ;
     FIT ;
     OPTIONS GetOptions ;
     BUTTONS DCGUI_BUTTON_OK ;
     MODAL ;
     SETAPPWINDOW ;
     TITLE 'Thread Inspector' ;
     NOAUTORESTORE

soMenu := nil
soBrowse := nil

RETURN nil

* -----------

STATIC FUNCTION ShowWorkArea( cText )

LOCAL i, cCallStack, nArea, cAlias

DEFAULT cText := ''

cText += 'Thread: ' + DC_XtoC(ThreadID()) + CRLF

cText += Replicate( "-", 78 ) + CRLF
cText += "CALLSTACK:" + CRLF
cText += Replicate( "-", 78 ) + CRLF

i := 2
DO WHILE ! Empty( ProcName(++i) )
  cCallStack := Trim( ProcName(i) )   + "(" + ;
                 LTrim( Str( ProcLine(i) ) ) + ")"

  cText += 'Called from: ' + cCallStack + CRLF
ENDDO

//------------------------------------------------------------------
// Workarea status.
//------------------------------------------------------------------
cText += replicate( "-", 78 ) + CRLF
cText += "WORKAREA STATUS:" + CRLF
cText += replicate( "-", 78 ) + CRLF
cText += " Area Alias         Record         Index        Order      Eof Bof Del Found" + CRLF
cText += replicate( "-", 78 ) + CRLF
nArea := Select()
for i := 1 to 255
  if !empty(cAlias := alias((i)))
    // dbselectarea(i)
    cText += iif(i==narea, "*", " ") + str(i,3) + "  " + ;
      padr(cAlias,10) + " " + ;
      str((cAlias)->(recno()),8) + "/" + padr(ltrim(str((cAlias)->(lastrec()),8)),8) + " " + ;
      padr((cAlias)->(ordbagname()),12) + " " + ;
      padr((cAlias)->(ordsetfocus()),10) + " " + ;
      iif((cAlias)->(eof()),     "Yes", "No ") + " " + ;
      iif((cAlias)->(bof()),     "Yes", "No ") + " " + ;
      iif((cAlias)->(deleted()), "Yes", "No ") + " " + ;
      iif((cAlias)->(found()),   "Yes", "No ") + CRLF
  endif
next i

cText += CRLF

RETURN nil

* --------------

STATIC FUNCTION BrowseMenuBlock( oBrowse, aThreadInfo, nPointer )

RETURN {|x,y,z,o|o := BrowseMenu( oBrowse, aThreadInfo, @nPointer ), ;
                                o:popup( nil, x, 1 , ;
                                XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) }

* -------------

STATIC FUNCTION BrowseMenu( oBrowse, aThreadInfo, nPointer )

LOCAL GetList[0], i

IF Valtype(soMenu) # 'O' .OR. soMenu:status()<=0 .OR. soBrowse # oBrowse

  IF Valtype(soMenu) = 'O'
    soMenu := nil
  ENDIF

  soBrowse := oBrowse

  DCSUBMENU soMenu

    DCMENUITEM 'Open Dot-Prompt in this thread' PARENT soMenu ;
        ACTION {||PostAppEvent(DCGUI_EVENT_ACTION, ;
               {||DllLoad('dclip1.dll'),&('DC_Dot(.f.)')},,aThreadInfo[nPointer,5]:cargo)} ;
        WHEN {||Valtype(aThreadInfo[nPointer,5]:cargo)=='O'}

    DCMENUITEM 'Display Info on ALL threads' PARENT soMenu ;
        ACTION {||DC_ThreadInfoText()}

  DCREAD GUI ;
    PARENT oBrowse ;
    EXIT

ENDIF

RETURN soMenu

* -----------

FUNCTION DC_ThreadInfoText(cText,lDisplay)

LOCAL GetList[0], i, oDlg, lDone := .f., oMemo, aThreadInfo

cText := ''

DEFAULT lDisplay := .t.

aThreadInfo := ThreadInfo(THREADINFO_TID      + ;
                          THREADINFO_SYSTHND  + ;
                          THREADINFO_FUNCINFO + ;
                          THREADINFO_TOBJ)

FOR i := 1 TO Len(aThreadInfo)
  oDlg := aThreadInfo[i,5]:cargo
  IF Valtype(oDlg) = 'O' .AND. oDlg:isDerivedFrom('XbpPartHandler')
    PostAppEvent( DCGUI_EVENT_ACTION,{||ShowWorkArea(@cText)},,oDlg)
  ENDIF
NEXT

IF lDisplay

   @ 0,0 DCMULTILINE cText OBJECT oMemo SIZE 100,25 ;
         FONT '10.Lucida Console'

   DCREAD GUI FIT TITLE 'Thread Info' MODAL ;
     EVAL {|o|o:=Thread():new(),Sleep(5),o:start({||_RefreshWindow(oMemo,@lDone)})}

ENDIF

lDone := .t.
Sleep(5)

RETURN cText

* -----------

STATIC FUNCTION _RefreshWindow(oMemo,lDone)

LOCAL i

FOR i := 1 TO 20
  IF lDone
    EXIT
  ENDIF
  DC_GetRefresh(oMemo)
  Sleep(20)
NEXT

RETURN nil

* -----------

CLASS _DC_DbRecord

PROTECTED:

CLASS VAR _Alias
CLASS VAR _RecNo
CLASS VAR _Deleted

EXPORTED:

INLINE METHOD Init

::_Alias := Alias()
::_RecNo := RecNo()
::_Deleted := Deleted()

RETURN self

INLINE METHOD RecNo()
RETURN ::_RecNo

INLINE METHOD Alias()
RETURN ::_Alias

INLINE METHOD Deleted()
RETURN ::_Deleted

INLINE METHOD Scatter()
::_RecNo := (::_Alias)->(RecNo())
::_Deleted := (::_Alias)->(Deleted())
RETURN (::_Alias)->(DC_DbScatter(self))

INLINE METHOD Gather(a,b,c,d)
RETURN (::_Alias)->(DC_DbGather(self,a,b,c,d))

INLINE METHOD IsEmpty()
RETURN (::_Alias)->(DC_DbRecordIsEmpty(self))

INLINE METHOD AsArray()
RETURN (::_Alias)->(DC_DbRecord2Array(self))

INLINE METHOD Trim()
RETURN (::_Alias)->(DC_DbRecordTrim(self))

INLINE METHOD Clear()
LOCAL nSaveRec := (::_Alias)->(RecNo())
(::_Alias)->(dbGoTo(0))
::scatter()
(::_Alias)->(dbGoTo(nSaveRec))
RETURN self

ENDCLASS

* -----------

// Create Data Record Object

FUNCTION DC_DbRecord( cClassName, cRecNoFieldName, cDeletedFieldName )

LOCAL aIVar, oClass, nAttr, aStruct, oRecord
LOCAL aSuperClass := { ClassObject('DC_NoIvarContainer'),ClassObject('_DC_DbRecord') }

DEFAULT cRecNoFieldName := 'RECORD_NUMBER', ;
        cDeletedFieldName := 'RECORD_DELETED'

DEFAULT cClassName := Eval(DC_DbRecordClassName())

oClass := ClassObject( cClassName )

IF oClass <> NIL
  RETURN oClass                 // Class already exists
ENDIF

aStruct := DbStruct()
AAdd(aStruct, { cRecnoFieldName, 'N', 12, 0 })
AAdd(aStruct, { cDeletedFieldName, 'L', 1, 0 })

nAttr   := CLASS_EXPORTED + VAR_INSTANCE
aIVar   := AEval( aStruct, {|a| a:={a[1], nAttr} } ,,, .T.)

oRecord := ClassCreate( cClassName, aSuperClass, aIVar )
oRecord:_DC_DbRecord:init()

RETURN oRecord

* ---------------

GETSETFUNCTION DC_DbRecordClassName DEFAULT {||'DATA_' + Alias()}

* ---------------

// Transfer values from fields to instance variables

FUNCTION DC_DbScatter( oRecord, cRecNoFieldName, cDeletedFieldName )

LOCAL i, aStruct, xData, cFieldName

DEFAULT cRecNoFieldName := 'RECORD_NUMBER', ;
        cDeletedFieldName := 'RECORD_DELETED'

aStruct := dbStruct()

FOR i := 1 TO Len(aStruct)
  cFieldName := aStruct[i,1]
  xData := FieldGet(i)
  IF IsMemberVar(oRecord,cFieldName)
    xData := FieldGet(i)
    oRecord:&(aStruct[i,1]) := xData
  ENDIF
NEXT

IF IsMemberVar(oRecord,'RECORD_NUMBER')
  oRecord:record_number := RecNo()
ENDIF

IF IsMemberVar(oRecord,'RECORD_DELETED')
  oRecord:record_deleted := Deleted()
ENDIF

RETURN oRecord

* --------------

// Write instance variables to database fields

FUNCTION DC_DbGather( oRecord, lNew, lCommit, bLock, cRecNoField )

LOCAL i, aStruct, cFieldName, xData, cLogFile, cAlias, aLog, ;
      nSaveArea, cDatabase, cLogAlias, cDbe, aData, aFields

DEFAULT lNew := Eof(), ;
        lCommit := .f.

IF Empty(bLock)
  bLock := DC_DbGatherLock()
ENDIF

IF Valtype(bLock) == 'B'
  IF !Eval(bLock,lNew)
    RETURN .f.
  ENDIF
ELSE
  IF lNew
    IF !_dbAppend()
      RETURN .f.
    ENDIF
  ELSEIF !_dbRlock()
    RETURN .f.
  ENDIF
ENDIF

aLog := DC_DbGatherLog()
ASize(aLog,6)
DEFAULT aLog[6] := .f.

IF !Empty(aLog[1])
  cAlias := Alias()
  DEFAULT aLog[4] := {}
  IF (!aLog[6] .AND. !_GoodAlias(cAlias,aLog,@aFields,oRecord)) .OR. ;
      (aLog[6] .AND. _GoodAlias(cAlias,aLog,@aFields,oRecord))
    nSaveArea := Select()
    cDatabase := aLog[1]
    cLogAlias := aLog[2]
    cDbe := aLog[3]
    DEFAULT cDbe := dbeSetDefault()
    OpenLogFile( cDatabase, cLogAlias, cDbe )
    IF (cLogAlias)->(DC_AddRec(5))
      (cLogAlias)->alias := cAlias
      (cLogAlias)->recno := (cAlias)->(RecNo())
      (cLogAlias)->type := Valtype(oRecord)
      (cLogAlias)->date := Date()
      (cLogAlias)->time := Time()
      IF Valtype(aLog[5]) == 'B'
        (cLogAlias)->login := Eval(aLog[5])
      ENDIF
      (cLogAlias)->mode := IIF(lNew,'A','E')
      IF !lNew
        aData := Object2Array((cAlias)->(DC_DbScatter(DC_DbRecord():new())))
        (cLogAlias)->dataOld := DC_Ar2Str(aData)
      ENDIF
      aData := Object2Array(oRecord)
      (cLogAlias)->dataNew :=  DC_Ar2Str(aData)
      (cLogAlias)->callStack := Stack2String()
      (cLogAlias)->(dbRUnlock())
      SELE (nSaveArea)
    ENDIF
  ENDIF
ENDIF

aStruct := DbStruct()
FOR i := 1 TO Len(aStruct)
  cFieldName := aStruct[i,1]
  IF IsMemberVar(oRecord,cFieldName)
    xData := oRecord:&(cFieldName)
    FieldPut(i,xData)
  ENDIF
NEXT
IF !Empty(cRecnoField)
  REPLACE &(cRecnoField) WITH RecNo()
ENDIF

dbRUnlock()
IF lCommit
  dbCommit()
ENDIF

RETURN .t.

* ----------

STATIC FUNCTION _GoodAlias( cAlias, aLog, aFields, oRecord )

LOCAL i, acFile, oRecordNew, aData1, aData2

aFields := nil
FOR i := 1 TO Len(aLog[4])
  acFile := aLog[4,i]
  IF Valtype(acFile) == 'C' .AND. cAlias == Upper(acFile)
    RETURN .t.
  ELSEIF Valtype(acFile) == 'A' .AND. cAlias == Upper(acFile[1])
    aFields := acFile[2]
    IF Empty(aFields)
      RETURN .t.
    ENDIF
    oRecordNew := (cAlias)->(DC_DbScatter(DC_DbRecord():new()))
    aData1 := Object2Array(oRecord,aFields)
    aData2 := Object2Array(oRecordNew,aFields)
    IF !DC_Acompare(aData1,aData2)
      RETURN .t.
    ENDIF
  ENDIF
NEXT

RETURN .f.

* ----------

FUNCTION DC_DbGatherLock( bLock )

STATIC sbLock
LOCAL bOldLock := sbLock

IF PCount() == 1 .AND. Valtype(bLock) $ 'UB'
  sbLock := bLock
ENDIF

RETURN bOldLock

* ----------

STATIC FUNCTION OpenLogFile( cDatabase, cLogAlias, cDbe )

LOCAL aStru, aLog, cIndex, lExclusive := .f.

IF Empty(cDatabase)
  aLog := DC_DbGatherLog()
  cDatabase := aLog[1]
  cLogAlias := aLog[2]
  cDbe := aLog[3]
ENDIF

IF Select(cLogAlias) > 0
  RETURN cLogAlias
ENDIF

cIndex := Strtran(Upper(cDatabase),'.DBF','.CDX')

IF !File(cDatabase)
  aStru := { ;
           { 'ALIAS     ','C',   10, 0 },;
           { 'RECNO     ','N',   10, 0 },;
           { 'TYPE      ','C',    1, 0 },;
           { 'DATE      ','D',    8, 0 },;
           { 'TIME      ','C',    8, 0 },;
           { 'LOGIN     ','C',   10, 0 },;
           { 'MODE      ','C',    1, 0 },;
           { 'CALLSTACK ','C',  150, 0 },;
           { 'DATAOLD   ','M',   10, 0 },;
           { 'DATANEW   ','M',   10, 0 }}

  dbCreate( cDatabase, aStru, cDbe )
  lExclusive := .t.
ENDIF

IF lExclusive
  USE (cDatabase) ALIAS (cLogAlias) VIA (cDbe) NEW EXCLUSIVE
  INDEX ON FIELD->login TAG 'LOGIN'
  INDEX ON FIELD->alias + Str(FIELD->recno,10) TAG 'RECNO'
ELSE
  USE (cDatabase) ALIAS (cLogAlias) VIA (cDbe) NEW
  SET INDEX TO (cIndex)
ENDIF

RETURN cLogAlias

* ----------

STATIC FUNCTION Stack2String()

LOCAL i, cStack := ''

i := 2
DO WHILE .t.
  cStack += Trim(ProcName(i))+'('+Alltrim(Str(ProcLine(i))) + '), '
  i++
  IF Empty(ProcName(i)) .OR. i > 6
     EXIT
  ENDIF
ENDDO

RETURN cStack

* -----------

STATIC FUNCTION Object2Array( oRecord, aFields )

LOCAL aResults[0], i, aData[0]

DC_InspectObject( oRecord, .f., @aResults )

FOR i := 1 TO Len(aResults[1])
  IF !Empty(aFields) .AND. !(Upper(aResults[1,i,1]) $ aFields)
    LOOP
  ENDIF
  IF .f. // aResults[1,i,5] == 'M'
    AAdd( aData, Trim(aResults[1,i,1]) + ':<memo>' )
  ELSE
    AAdd( aData, Trim(aResults[1,i,1]) + ':' + Trim(aResults[1,i,2]) )
  ENDIF
NEXT

RETURN aData

* -------------

FUNCTION DC_DbGatherLog( aLog )

STATIC saLog[5]

IF Valtype(aLog) == 'A'
  ASize(aLog,6)
  saLog := aLog
ENDIF

RETURN saLog

* -------------

FUNCTION DC_DbGatherLogBrowse()

LOCAL GetList[0], GetOptions, oBrowse, oTreeDataOld, oTreeDataNew, cLogAlias

cLogAlias := OpenLogFile()

@ 0,0 DCPUSHBUTTON CAPTION 'Print' SIZE 7 ACTION {||DC_PrintBrowse(oBrowse)}

@ 1,0 DCBROWSE oBrowse ALIAS (cLogAlias) SIZE 150,9 ;
      FONT '9.Lucida Console' ;
      ITEMMARKED {||FillTrees(oTreeDataOld,oTreeDataNew,cLogAlias)} ;
      RESIZE DCGUI_RESIZE_AUTORESIZE ;
      COLOR {||IIF((cLogAlias)->dataOld==(cLogAlias)->dataNew,{nil,GRA_CLR_WHITE},{nil,GRA_CLR_CYAN})}

DCBROWSECOL FIELD (cLogAlias)->alias WIDTH 10 HEADER 'Alias' PARENT oBrowse ;
   SORT {||(cLogAlias)->(OrdSetFocus('RECNO'))}
DCBROWSECOL FIELD (cLogAlias)->recno WIDTH 10 PICTURE '9999999999' HEADER 'Record' PARENT oBrowse
DCBROWSECOL FIELD (cLogAlias)->type WIDTH 1 HEADER 'Type' PARENT oBrowse
DCBROWSECOL FIELD (cLogAlias)->date WIDTH 10 HEADER 'Date' PARENT oBrowse
DCBROWSECOL FIELD (cLogAlias)->time WIDTH 8 HEADER 'Time' PARENT oBrowse
DCBROWSECOL FIELD (cLogAlias)->login WIDTH 10 HEADER 'Login' PARENT oBrowse ;
   SORT {||(cLogAlias)->(OrdSetFocus('LOGIN'))}

DCBROWSECOL FIELD (cLogAlias)->mode WIDTH 1 HEADER 'Mode' PARENT oBrowse
DCBROWSECOL FIELD (cLogAlias)->callStack WIDTH 100 HEADER 'Stack' PARENT oBrowse

@ 11,2 DCSAY 'WAS:' SAYSIZE 0
@ 12,0 DCTREEROOT OBJECT oTreeDataOld SIZE 75,20 FONT '10.Lucida Console' ;
       RESIZE DCGUI_RESIZE_AUTORESIZE

@ 11,78 DCSAY 'IS:' SAYSIZE 0
@ 12,76 DCTREEROOT OBJECT oTreeDataNew SIZE 75,20 FONT '10.Lucida Console' ;
       RESIZE DCGUI_RESIZE_AUTORESIZE

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Browsing Transaction Database' OPTIONS GetOptions ;
       MODAL SETAPPWINDOW EXPRESS NOAUTORESTORE

RETURN nil

* ----------

STATIC FUNCTION FillTrees( oTreeDataOld, oTreeDataNew, cLogAlias )

LOCAL cAlias, aRecord1, aRecord2, i, aItems, cItem, nFound, nIcon, ;
      oItem

cAlias := Trim((cLogAlias)->alias)

oTreeDataOld:lockUpdate(.t.)
oTreeDataNew:lockUpdate(.t.)
oTreeDataOld:setColorBG(GRA_CLR_WHITE)
oTreeDataNew:setColorBG(GRA_CLR_WHITE)

aItems := oTreeDataOld:rootItem:getChildItems()
FOR i := 1 TO Len(aItems)
  oTreeDataOld:rootItem:delItem(aItems[i])
NEXT

aItems := oTreeDataNew:rootItem:getChildItems()
FOR i := 1 TO Len(aItems)
  oTreeDataNew:rootItem:delItem(aItems[i])
NEXT

aRecord1 := DC_Str2Ar((cLogAlias)->dataOld)
aRecord2 := DC_Str2Ar((cLogAlias)->dataNew)

IF !Empty((cLogAlias)->dataOld)
  FOR i := 1 TO Len(aRecord1)
    cItem := aRecord1[i]
    nFound := At(':',cItem)
    cItem := Pad(Substr(cItem,1,nFound),15) + Substr(cItem,nFound+1)
    IF Empty(aRecord1) .OR. Empty(aRecord2) .OR. (Len(aRecord1)==Len(aRecord2) ;
         .AND. !(aRecord1[i] == aRecord2[i]))
      nIcon := ICON_QUESTION
      oTreeDataOld:setColorBG(GRA_CLR_CYAN)
    ELSE
      nIcon := ICON_CHECKED
    ENDIF
    oItem := oTreeDataOld:rootItem:additem(cItem,nIcon,nIcon,nIcon)
  NEXT
ENDIF

IF !Empty((cLogAlias)->dataNew)
  FOR i := 1 TO Len(aRecord2)
    cItem := aRecord2[i]
    nFound := At(':',cItem)
    cItem := Pad(Substr(cItem,1,nFound),15) + Substr(cItem,nFound+1)
    oItem := oTreeDataNew:rootItem:additem(cItem)
  NEXT
ENDIF

oTreeDataOld:lockUpdate(.f.)
oTreeDataNew:lockUpdate(.f.)

RETURN nil

* ----------------

STATIC FUNCTION _DbAppend()

LOCAL i, lStatus := .f.

FOR i := 1 TO 3
  dbAppend(1)
  IF !NetErr()
    lStatus := .t.
    EXIT
  ENDIF
  Sleep(100)
NEXT

RETURN lStatus

* ----------------

STATIC FUNCTION _DbRLock()

LOCAL i, lStatus := .f.

FOR i := 1 TO 3
  IF dbRLock()
    lStatus := .t.
    EXIT
  ENDIF
  Sleep(100)
NEXT

RETURN lStatus

* ----------------

FUNCTION DC_DbRecordClone( oRecord )

LOCAL oNewRec

oNewRec := DC_DbRecord(oRecord:className()):new()

DC_DbRecordCopy( ORecord, oNewRec )

IF IsMemberVar(oRecord,'RECORD_NUMBER')
  oRecord:record_number := oNewRec:record_number
ENDIF

IF IsMemberVar(oRecord,'RECORD_DELETED')
  oRecord:record_deleted := oNewRec:record_deleted
ENDIF

RETURN oNewRec

* ----------------

FUNCTION DC_DbRecordCopy( oRecordFrom, oRecordTo )

LOCAL aResults, aIvars, i, cFieldName

aResults := oRecordFrom:classDescribe()

aIvars := {}
FOR i := 1 TO Len(aResults[3])
  AAdd(aIvars,Alltrim(aResults[3,i,1]))
NEXT

FOR i := 1 TO Len(aIvars)
  cFieldName := aIvars[i]
  IF Upper(cFieldName) == '__NOIVAR'
    LOOP
  ENDIF
  IF IsMemberVar(oRecordTo,cFieldName) .AND. IsMemberVar(oRecordFrom,cFieldName)
    oRecordTo:&(cFieldName) := oRecordFrom:&(cFieldName)
  ENDIF
NEXT

RETURN nil

* ----------------

FUNCTION DC_DbRecordCompare( oRecord1, oRecord2, aFields )

LOCAL aResults, aIvars, i, cFieldName, lStatus := .t.

aResults := oRecord1:classDescribe()

aIvars := {}
FOR i := 1 TO Len(aResults[3])
  AAdd(aIvars,Alltrim(aResults[3,i,1]))
NEXT

FOR i := 1 TO Len(aIvars)
  cFieldName := aIvars[i]
  IF IsMemberVar(oRecord1,cFieldName) .AND. IsMemberVar(oRecord2,cFieldName)
    IF !( Trim(DC_Xtoc( oRecord1:&(cFieldName))) == Trim(DC_Xtoc(oRecord2:&(cFieldName))) )
      lStatus := .f.
      IF Valtype(aFields) == 'A'
        AAdd( aFields, ;
           { cFieldName, ;
             Trim(DC_Xtoc( oRecord1:&(cFieldName))), ;
             Trim(DC_Xtoc( oRecord2:&(cFieldName))) } )
      ENDIF
    ENDIF
  ELSE
    lStatus := .f.
  ENDIF
  IF !lStatus .AND. Empty(aFields)
    EXIT
  ENDIF
NEXT

RETURN lStatus

* -----------

FUNCTION DC_DbRecordIsEmpty( oRecord )

LOCAL aResults, lEmpty := .t., i, cFieldName, xValue

aResults := oRecord:classDescribe()

FOR i := 1 TO Len(aResults[3])
  cFieldName := aResults[3,i,1]
  xValue := oRecord:&(cFieldName)
  IF !Empty(xValue) .AND. !(cFieldName $ {'RECORD_NUMBER','RECORD_DELETED'})
    lEmpty := .f.
    EXIT
  ENDIF
NEXT

RETURN lEmpty

* -----------

FUNCTION DC_DbRecordTrim( oRecord )

LOCAL aResults, i, cFieldName, xValue

aResults := oRecord:classDescribe()

FOR i := 1 TO Len(aResults[3])
  cFieldName := aResults[3,i,1]
  xValue := oRecord:&(cFieldName)
  IF Valtype(xValue) $ 'CM'
    oRecord:&(cFieldName) := Trim(xValue)
  ENDIF
NEXT

RETURN nil

* -----------

FUNCTION DC_DbRecord2Array( oRecord )

LOCAL aResults, aData[0], i, cFieldName

aResults := oRecord:classDescribe()

FOR i := 1 TO Len(aResults[3])
  cFieldName := aResults[3,i,1]
  AAdd(aData, oRecord:&(cFieldName) )
NEXT
RETURN aData

* ----------------

FUNCTION DC_DbRecord2File( oRecord, cFileName )

LOCAL aData := { Alias(), Var2Bin(oRecord), RecNo() }

RETURN DC_ASave( aData, cFileName )

* ----------------

FUNCTION DC_DbFile2Record( cFileName, nRecord )

LOCAL cAlias, oRecord, aData

aData := DC_ARestore( cFileName )
IF Valtype(aData) == 'A' .AND. Len(aData) == 3
  cAlias := aData[1]
  IF Select(cAlias) > 0
    oRecord := (cAlias)->(DC_DbRecord():new())
    oRecord := Bin2Var( aData[2] )
  ENDIF
ENDIF

RETURN oRecord

* -------------

FUNCTION DC_DbRecordEdit( oRecord )

LOCAL aResults, i, cFieldName, GetList[0], GetOptions, lStatus, nRow := 0, ;
      bPopup, nGetLen, xValue

aResults := oRecord:classDescribe()

FOR i := 1 TO Len(aResults[3])
  cFieldName := aResults[3,i,1]
  xValue := oRecord:&(cFieldName)
  IF cFieldName # 'RECORD_NUMBER'
    bPopup := nil
    nGetLen := nil
    IF Valtype(xValue) == 'D'
      bPopup := {|d|DC_PopDate(d,,,,,,2)}
    ELSEIF Valtype(xValue) $ 'CM' .AND. Len(xValue) > 50
      nGetLen := 50
    ENDIF
    @ nRow++, 0 DCSAY cFieldName GET oRecord:&(cFieldName) POPUP bPopup GETSIZE nGetLen
  ENDIF
NEXT

DCGETOPTIONS SAYWIDTH 100 SAYRIGHTBOTTOM

DCREAD GUI FIT TITLE 'Editing ' + Alias() + ' record #' + Alltrim(Str(RecNo())) ;
   TO lStatus ADDBUTTONS OPTIONS GetOptions MODAL

IF lStatus
  DC_DbGather( oRecord )
ENDIF

RETURN lStatus

* -------------

FUNCTION DC_RecordDupes( bExpr )

LOCAL aDupes[0], aRecords[0], nSaveRec, nSaveOrder, nFound, ;
      cString, i, j, oRecord

nSaveRec := RecNo()
nSaveOrder := OrdSetFocus()

dbGoTop()
DO WHILE !Eof()
  IF !Deleted()
    cString := Eval(bExpr)
    nFound := AScan(aRecords,{|a|a[1]==cString})
    IF nFound == 0
      AAdd( aRecords, {cString, {{RecNo(),nil}}} )
    ELSE
      AAdd( aRecords[nFound,2],{RecNo(),nil})
    ENDIF
  ENDIF
  dbSkip()
ENDDO
dbGoTo(nSaveRec)
OrdSetFocus(nSaveOrder)

FOR i := 1 TO Len(aRecords)
  IF Len(aRecords[i,2]) > 1
    FOR j := 1 TO Len(aRecords[i,2])
      dbGoTo(aRecords[i,2,j,1])
      oRecord := DC_DbRecord():new()
      DC_DbScatter(oRecord)
      aRecords[i,2,j,2] := oRecord
    NEXT
    AAdd(aDupes,aRecords[i])
  ENDIF
NEXT

RETURN aDupes

* ----------------

FUNCTION DC_ToolTipTimeOut( nTimeOut )

STATIC snTimeOut := 5

LOCAL nOldTimeOut
nOldTimeOut := snTimeOut
IF Valtype(nTimeOut) == 'N'
  snTimeOut := nTimeOut
ENDIF

IF DC_ToolTipShowSource()
  nOldTimeOut := 100
ENDIF

RETURN nOldTimeOut

* ----------------

FUNCTION DC_ToolTipSensitivity( nSensitivity )

STATIC snSensitivity := .8

LOCAL nOldSensitivity
nOldSensitivity := snSensitivity
IF Valtype(nSensitivity) == 'N'
  snSensitivity := nSensitivity
ENDIF

RETURN nOldSensitivity

* --------------

GETSETFUNCTION DC_ToolTipEnable DEFAULT .t.

* --------------

FUNCTION DC_ToolTipThreadActive( nThreadID )

IF Empty(nThreadID)
  nThreadID := ThreadID()
ENDIF

RETURN nil

* -----------------

GETSETFUNCTION DC_TooltipShowSource DEFAULT .f.

* ------------------

FUNCTION VScrollBarSize()
RETURN {DllCall("USER32.DLL", DLL_STDCALL, "GetSystemMetrics",SM_CXVSCROLL),;
        DllCall("USER32.DLL", DLL_STDCALL, "GetSystemMetrics",SM_CYVSCROLL)}

FUNCTION HScrollBarSize()
RETURN {DllCall("USER32.DLL", DLL_STDCALL, "GetSystemMetrics",SM_CXHSCROLL),;
        DllCall("USER32.DLL", DLL_STDCALL, "GetSystemMetrics",SM_CYHSCROLL)}

* -----------------

FUNCTION DC_MoveParentWindow( mp1, mp2, oXbp, nStopEvent )

LOCAL oParent := oXbp, oDeskTop := AppDeskTop(), nEvent, aPos, aPosXbp

DEFAULT nStopEvent := xbeM_LbUp

DO WHILE !(oParent == oDesktop)
  oParent := oParent:setParent()
  IF oParent:isDerivedFrom('XbpDialog')
    EXIT
  ENDIF
ENDDO

aPosXbp := DC_CalcAbsolutePosition( mp1, oXbp, oParent )

oParent:captureMouse(.t.)

nEvent := 0
aPos := oParent:currentPos()
DO WHILE nEvent # nStopEvent
  nEvent := AppEvent( @mp1, @mp2, @oXbp, .1 )
  IF nEvent # 0
    oXbp:handleEvent(nEvent,mp1,mp2)
  ENDIF
  IF nEvent == xbeM_Motion
    aPos := DC_CalcAbsolutePosition(mp1,oXbp)
    aPos[1] -= aPosXbp[1]
    aPos[2] -= aPosXbp[2]
    oParent:setPos( aPos )
    DC_CompleteEvents()
  ENDIF
ENDDO

oParent:captureMouse(.f.)

RETURN nil

* ------------------

FUNCTION DC_IsObscured( oXbp )

LOCAL i, aCoords := DC_CalcAbsolutePosition( nil, oXbp ), ;
      aSize := oXbp:currentSize(), aChildCoords, aChildSize, ;
      nStartRow, nStartCol, nEndRow, nEndCol, nStartRow2, ;
      nStartCol2, nEndRow2, nEndCol2, aChildList, oParentWindow

oParentWindow := ParentWindow(oXbp)

DO WHILE oXbp:setParent() # AppDesktop()
  oXbp := oXbp:setParent()
ENDDO

nStartRow := aCoords[2]
nStartCol := aCoords[1]
nEndRow := nStartRow + aSize[2]
nEndCol := nStartCol + aSize[1]

aChildList := oXbp:drawingArea:childList()

FOR i := 1 TO Len(aChildList)
  aChildCoords := DC_CalcAbsolutePosition( nil, aChildList[i] )
  aChildSize := aChildList[i]:currentSize()
  nStartRow2 := aChildCoords[2]
  nStartCol2 := aChildCoords[1]
  nEndRow2 := nStartRow2 + aChildSize[2]
  nEndCol2 := nStartCol2 + aChildSize[1]
  IF !aChildList[i]:isDerivedFrom('XbpDialog')
    LOOP
  ENDIF
  IF aChildList[i] == oParentWindow
    LOOP
  ELSEIF !aChildList[i]:hasInputFocus()
    LOOP
  ELSEIF nEndRow2 < nStartRow
    LOOP
  ELSEIF nStartCol2 > nEndCol
    LOOP
  ELSEIF nEndCol2 < nStartCol
    LOOP
  ELSEIF nStartRow2 > nEndRow
    LOOP
  ELSE
    RETURN .T.
  ENDIF
NEXT

RETURN .F.

* --------------

STATIC FUNCTION ParentWindow( oXbp )

 oXbp := oXbp:setParent():setParent():setParent()

 DO WHILE !(oXbp:isDerivedFrom('XbpDialog'))
   oXbp := oXbp:setParent()
 ENDDO

RETURN oXbp

* --------------

GETSETFUNCTION DC_TooltipThread DEFAULT 2

* --------------

FUNCTION DC_ReSize( aOldSize, aNewSize, oDlg, aGetList, oGetList, nRecurs )

LOCAL nY, nX, aReSize, aPos, aSize, nStatus, aChildList, i, oXbp, ;
      bSetPos, bSetSize, lScaleFont, nHDelta, nVDelta, cCompoundName, ;
      nPointSize, nY2, nX2, nXRatio, nYRatio, nCurrentCol, nCurrentRow, ;
      nCurrentWidth, nCurrentHeight, nFound, nHRatio, nVRatio, nSpacing, ;
      aState, nDataStore, bPostEval

DEFAULT nRecurs := 0

IF (aOldSize[1] = aNewSize[1] .AND. aOldSize[2] == aNewSize[2]) .OR. aOldSize[2] < 50 .AND. ;
       oDlg:isDerivedFrom('XbpDialog')
  RETURN nil
ENDIF

IF oDlg:isDerivedFrom('XbpDialog') .AND. ;
     Empty(DC_GetProperty(oDlg,aGETLIST_RESIZE))
  oDlg := oDlg:drawingArea
ENDIF

IF oDlg:isDerivedFrom('XbpIWindow') .AND. ;
   ;// oDlg:setParent():isDerivedFrom('DC_XbpDialog1') .AND. ;
   oDlg:setParent():isDerivedFrom('XbpDialog') .AND. ;
   nRecurs = 0

  IF isMemberVar(oDlg:setParent(),'resizeState')
    aState := oDlg:setParent():resizeState
  ENDIF

  IF Empty(aState)
    aState := Array(3)
    oDlg:setParent():resizeState := aState
  ENDIF

  DEFAULT aState[1] := aNewSize[1], ;
          aState[2] := aNewSize[2], ;
          aState[3] := -1

  IF aState[3] == oDlg:setParent():getFrameState() .AND. ;
     aState[3] $ { XBPDLG_FRAMESTAT_MINIMIZED,XBPDLG_FRAMESTAT_MAXIMIZED}
     RETURN nil
  ENDIF

  IF oDlg:setParent():getFrameState() == XBPDLG_FRAMESTAT_MINIMIZED
    aState[3] := XBPDLG_FRAMESTAT_MINIMIZED
    aState[1] := aOldSize[1]
    aState[2] := aOldSize[2]
    RETURN nil
  ELSEIF aState[3] == XBPDLG_FRAMESTAT_MINIMIZED
    aOldSize := { aState[1], aState[2] }
    aState[3] := oDlg:setParent():getFrameState()
    // RETURN nil
  ELSEIF aState[3] == XBPDLG_FRAMESTAT_MAXIMIZED .AND. ;
         oDlg:setParent():getFrameState() == XBPDLG_FRAMESTAT_NORMALIZED
  ENDIF

  aState[1] := aNewSize[1]
  aState[2] := aNewSize[2]
  aState[3] := oDlg:setParent():getFrameState()

ENDIF

nX := (aNewSize[1]-aOldSize[1])
nY := (aNewSize[2]-aOldSize[2])
nXRatio := aNewSize[1]/aOldsize[1]
nYRatio := aNewSize[2]/aOldSize[2]

IF nX = 0 .AND. nY = 0
  RETURN nil
ENDIF

/*
IF oDlg:isDerivedFrom('XbpDialog')
  oDlg:drawingArea:lockUpdate(.t.)
ENDIF
*/

aChildList := oDlg:childList()

IF Valtype(oGetList) # 'O'
  nDataStore := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
  oGetList := aGetList[nDataStore,oGETLIST_OBJECT]
ENDIF

FOR i := 1 TO Len(aChildList)

  oXbp := aChildList[i]
  nStatus := 0
  aResize := DC_GetProperty(oXbp,aGETLIST_RESIZE,,,,@nStatus)

  IF oXbp:isDerivedFrom('DC_XbaseParts')
    oGetList := oXbp:getList
  ENDIF

  IF Valtype(oGetList:reSize) # 'A'
    oGetList:reSize := {}
  ENDIF

  IF nStatus == 0
    LOOP
  ELSEIF Valtype(aResize) # 'A'
    aResize := oGetList:resizeDefault
  ENDIF

  ASize(aResize,4)
  DEFAULT aResize[3] := .f.
  bSetPos := aResize[1]
  bSetSize := aResize[2]
  lScaleFont := aResize[3]
  aOldSize := oXbp:currentSize()
  nFound := AScan( oGetList:reSize, {|a|a[1] == oXbp} )
  IF nFound > 0
    nCurrentCol    := oGetList:reSize[nFound,2]
    nCurrentRow    := oGetList:reSize[nFound,3]
    nCurrentWidth  := oGetList:reSize[nFound,4]
    nCurrentHeight := oGetList:reSize[nFound,5]
    oGetList:reSize[nFound,2] := nCurrentCol * nXRatio
    oGetList:reSize[nFound,3] := nCurrentRow * nYRatio
    oGetList:reSize[nFound,4] := Max(nCurrentWidth * nXRatio,1)
    oGetList:reSize[nFound,5] := Max(nCurrentHeight * nYRatio,1)
  ELSE
    nCurrentCol    := oXbp:currentPos()[1]
    nCurrentRow    := oXbp:currentPos()[2]
    nCurrentWidth  := oXbp:currentSize()[1]
    nCurrentHeight := oXbp:currentSize()[2]
    AADD( oGetList:reSize, { oXbp, nCurrentCol * nXRatio, ;
                             nCurrentRow * nYRatio, ;
                             Max(nCurrentWidth * nXRatio,1), ;
                             Max(nCurrentHeight * nYRatio,1) } )
  ENDIF


  nSpacing := -1
  IF oXbp:isDerivedFrom('DC_XbpGet') .AND. !Empty(oXbp:popupbutton) .AND. ;
    !(oXbp==oXbp:popupbutton:setParent())

    nSpacing := oXbp:popupbutton:currentPos()[1] - ( oXbp:currentPos()[1] + oXbp:currentSize()[1] )
  ENDIF

  IF Valtype(bSetPos) = 'B'

    aPos := Eval( bSetPos, nX, nY, oXbp, nCurrentCol, nCurrentRow, nXRatio, nYRatio )

    oXbp:setPos(aPos)

  ENDIF

  IF Valtype(bSetSize) = 'B' .AND. IsMethod(oXbp,'SETSIZE')
    aSize := Eval( bSetSize, nX, nY, oXbp, nCurrentWidth, nCurrentHeight, nXRatio, nYRatio )

    IF aSize[1] # oXbp:currentSize()[1] .OR. aSize[2] # oXbp:currentSize()[2]
      IF lScaleFont .AND. IsMemberVar(oXbp,'origFont') .AND. Valtype(oXbp:origFont) == 'O'
        nHRatio := aSize[1]/oXbp:origSize[1]
        nVRatio := aSize[2]/oXbp:origSize[2]
        nPointSize := nVRatio*oXbp:origFontSize
        IF nPointSize # oXbp:origFont:nominalPointSize
          cCompoundName := Alltrim(Str(nPointSize,3,0)) + '.' +oXbp:fontFamilyName
          oXbp:setFontCompoundName(cCompoundName)
        ENDIF
      ENDIF
      IF oXbp:isDerivedFrom('DC_XbpGet')
        oXbp:resizeSetSize(aSize)
      ELSE
        oXbp:setSize(aSize)
      ENDIF
      IF oXbp:isDerivedFrom('DC_XbpGet') .AND. !Empty(oXbp:popupbutton) .AND. ;
          (oXbp==oXbp:popupbutton:setParent())
        oXbp:popupButton:setPos({oXbp:currentSize()[1]-oXbp:popupButton:currentSize()[1]-5,0})
      ENDIF
    ENDIF
  ENDIF
  IF nSpacing >= 0
    oXbp:popupButton:setPos({oXbp:currentPos()[1] + oXbp:currentSize()[1] + nSpacing, ;
                            oXbp:currentPos()[2]} )
    oXbp:popupButton:setSize({oXbp:currentSize()[2],oXbp:currentSize()[2]})
  ENDIF

  aNewSize := oXbp:currentSize()
  IF oXbp:isDerivedFrom('XbpDialog')
    oXbp := oXbp:drawingArea
  ENDIF

  IF oXbp:isDerivedFrom('DC_XbpTabPage')
    IF oXbp:angle > 0
      oXbp:configure()
    ENDIF
    IF Valtype(oXbp:staticArea) == 'O'
      Eval(oXbp:resize,aOldSize,aNewSize,oXbp)
      oXbp := oXbp:staticArea
    ENDIF
  ENDIF

  bPostEval := aResize[4]
  IF Valtype(bPostEval) == 'B'
    Eval(bPostEval,oXbp)
  ENDIF

  IF aOldSize[1] # aNewSize[1] .OR. aOldSize[2] # aNewSize[2]
    IF !Empty(oXbp:childList()) .AND. ;
      !oXbp:isDerivedFrom('XbpBrowse') .AND. ;
      !oXbp:isDerivedFrom('DC_XbpGet') .AND. ;
      !oXbp:isDerivedFrom('MxPushButton')
      DC_Resize( aOldSize, aNewSize, oXbp, aGetList, oGetList, ++nRecurs )
    ELSEIF oXbp:isDerivedFrom('DC_XbpBrowse') .AND. oXbp:resizeColumns
      oXbp:resizeColumns( aOldSize, aNewSize )
    ENDIF
  ENDIF

NEXT

/*
IF oDlg:isDerivedFrom('XbpDialog')
  oDlg:drawingArea:lockUpdate(.f.)
ENDIF
*/

RETURN nil

* -------------

FUNCTION DC_FormatMemoToWidth( cString, nWidth, oPS )

LOCAL aTokens, cOutString, cLine, i, cFont, nLineWidth, aRect, cCaption

IF !(Valtype(cString) $ 'CM')
  RETURN ''
ENDIF

DEFAULT nWidth := 200

aTokens := DC_TokenArray( cString, ' '+Chr(10) )

cOutString := ''
cLine := ''

FOR i := 1 TO Len(aTokens)
  IF aTokens[i] == Chr(13)
    cLine += aTokens[i]
    cOutString += cLine
    cLine := ''
    LOOP
  ENDIF
  cCaption := cLine + ' ' + aTokens[i]
  IF Valtype( oPS ) == 'C' // It's a font
    cFont := Alltrim(oPS)
    nLineWidth := DC_GraQueryTextBox(cCaption,cFont)[1]
  ELSE // It's a presentation space
    aRect := GraQueryTextBox(oPS, cCaption )
    nLineWidth := aRect[3,1] - aRect[1,1]
  ENDIF
  IF nLineWidth <= nWidth
    cLine += ' ' + aTokens[i]
  ELSE
    cOutString += cLine + Chr(13)
    cLine := aTokens[i]
  ENDIF
NEXT
IF !Empty(cLine)
  cOutString += cLine
ENDIF

cOutString := Strtran(cOutString,Chr(13)+' ',Chr(13))
cOutString := Strtran(cOutString,Chr(13),Chr(13)+Chr(10))

RETURN LTrim(cOutString)

* --------------

FUNCTION DC_SendMailToDefault( cTo, cCC, cSubject, cBody )

LOCAL cParams, cCommand

cParams := 'url.dll,FileProtocolHandler mailto:'

IF !Empty(cTo)
  // cParams += '?to=' + cTo
  cParams += cTo
ENDIF

IF !Empty(cCC)
  cParams += Chr(38) + 'cc=' + cCC
ENDIF

IF !Empty(cSubject)
  cParams += Chr(38) + 'subject=' + cSubject
ENDIF

IF !Empty(cBody)
  cBody := Strtran(cBody,Chr(13),'%0d')
  cBody := Strtran(cBody,Chr(10),'%0a')
  cBody := Strtran(cBody,' ','%20')
  cBody := Strtran(cBody,Chr(38),'%26')
  cBody := Strtran(cBody,'?','%3f')
  cBody := Strtran(cBody,'=','%3d')
  cParams += Chr(38) + 'body=' + cBody
ENDIF

cCommand := 'Rundll32.exe'

RunShell( cParams, cCommand, .t., .t. )

RETURN nil

* -------------

FUNCTION DC_SpawnURL( cUrl, lBackground, lAsync )

LOCAL cParams, cCommand

DEFAULT lBackground := .F., ;
        lAsync := .t.

cParams := 'url.dll,FileProtocolHandler ' + Alltrim(cURL) // + ;
//         IIF('?'$cUrl,'','?')
cCommand := 'Rundll32.exe'

RunShell( cParams, cCommand, lAsync, lBackground )

RETURN 1

* -----------------

FUNCTION Grok()
RETURN nil

* -----------------

#define UNIVERSAL_NAME_INFO_LEVEL   0x00000001
#define REMOTE_NAME_INFO_LEVEL      0x00000002
#define NO_ERROR                    0
#define ERROR_BAD_DEVICE            1200
#define ERROR_CONNECTION_UNAVAIL    1201
#define ERROR_EXTENDED_ERROR        1208
#define ERROR_MORE_DATA             234
#define ERROR_NOT_SUPPORTED         50
#define ERROR_NO_NET_OR_BAD_PATH    1203
#define ERROR_NO_NETWORK            1222
#define ERROR_NOT_CONNECTED         2250
#DEFINE MAX_BUFFER_SIZE 500
#DEFINE STRUCTURE_HEADER   0

FUNCTION DC_Drive2UNC( cMappedPath )

local cReturnValue
local cDrive, cPath
local cLocalPath, cBuffer, nBufferSize, nResult, cStructureString

IF !EMPTY(cMappedPath)

   DO CASE
   CASE LEN(cMappedPath) > 2
      cDrive = LEFT(cMappedPath, 2)
      cPath  = SUBSTR(cMappedPath, 3)
   CASE len(cMappedPath) <= 2
      cDrive = cMappedPath
      cPath  = ""
   ENDCASE

   nBufferSize = 255
   cLocalPath = cDrive
   cBuffer = space(nBufferSize)

   nResult := WNetGetConnectionA( @cLocalPath, @cBuffer, @nBufferSize )

   DO CASE
   CASE nResult = NO_ERROR                     // string translated sucessfully
      cStructureString = ALLTRIM(SUBSTR(cBuffer, STRUCTURE_HEADER + 1))
      cReturnValue = LEFT(cStructureString, AT(CHR(0), cStructureString) - 1) + cPath
   CASE nResult = ERROR_BAD_DEVICE             // The string pointed to by lpLocalPath is invalid.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_CONNECTION_UNAVAIL     // There is no current connection to the remote device, but there is a remembered (persistent) connection to it.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_EXTENDED_ERROR         // A network-specific error occurred. Use the WNetGetLastError function to obtain a description of the error.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_MORE_DATA              // The buffer pointed to by lpBuffer is too small. The function sets the variable pointed to by lpBufferSize to the required buffer size.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_NOT_SUPPORTED          // The dwInfoLevel parameter was set to UNIVERSAL_NAME_INFO_LEVEL, but the network provider does not support UNC  names. This function is not supported by any of the network providers.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_NO_NET_OR_BAD_PATH     // None of the providers recognized this local name as having a connection. However, the network is not available for at least one provider to whom the connection may belong.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_NO_NETWORK             // There is no network present.
      cReturnValue = cMappedPath
   CASE nResult = ERROR_NOT_CONNECTED          // The device specified by cLocalPath is not redirected.
      cReturnValue = cMappedPath
   OTHERWISE
      cReturnValue = cMappedPath
   ENDCASE
ELSE
   cReturnValue = cMappedPath
ENDIF

RETURN Alltrim(cReturnValue)

* -------------

FUNCTION DC_SetUNC( cFileName )

LOCAL cUNC, cCurDir := CurDir()

IF !('\\' $ cFileName)
  IF !(':' $ cFileName)
     IF Empty(cUNC)
       cUNC := DC_Drive2UNC( CurDrive() + ':')
     ENDIF
     IF !( ':' $ cUNC )
       cFileName := cUNC + '\' + IIF(!Empty(cCurDir),cCurDir + '\','') + cFileName
     ENDIF
  ENDIF
ENDIF

RETURN cFileName


*+
*+
*+  Function DC_ConfigDialogButtons(obj,nMode)
*+
*+  Based on various code examples in the programming community
*+
*+  ++Configures buttons on dialog
*+
*+  Usage:  Call this function via the eval clause of a DCREAD GUI statement
*+          with the appropriate parameters
*+
*+  DC_ConfigDialogButtons(oDlg,DC_BUTTON_REMOVEALL) // to remove minimize/maximize/close buttons
*+  DC_ConfigDialogButtons(oDlg,DC_DISABLEMINIMIZE)  // to disable the minimize button
*+  DC_ConfigDialogButtons(oDlg,DC_DISABLEMAXIMIZE)  // to disable the maximize button
*+  DC_ConfigDialogButtons(oDlg,DC_REMOVEMINMAX)     // to remove minimize/maximize buttons
*+  DC_ConfigDialogButtons(oDlg,DC_HELP)             // to remove minimize/maximize buttons and add "?" help button
*+                                                   // this option would require additional hooks into the dialog to
*+                                                   // implement the help feature;  this option can be removed with
*+                                                   // the corresponding changes to the function to remove the DC_BUTTON_ADDHELP
*+                                                   // modifications
*+
*+
*+

FUNCTION DC_ConfigDialogButtons(oDlg,nMode)
  LOCAL nHwnd, nIndex, nNewIndex


  nHwnd := oDlg:xbpDialog:GetHwnd()

  nIndex    := GetWindowLongA(nHwnd,GWL_STYLE)
  nNewIndex := nIndex

  nNewIndex := DC_XorBitsLong(nIndex, iif(nMode==DC_BUTTON_ADDHELP, ;
                              DC_BUTTON_REMOVEMINMAX,nMode))

  IF nNewIndex != 0
    SetWindowLongA(nHwnd,GWL_STYLE, nNewIndex)
    IF nMode == DC_BUTTON_ADDHELP
      SetWindowLongA(nHwnd,GWL_EXSTYLE, WS_EX_CONTEXTHELP)
    ENDIF
  ENDIF

RETURN NIL

*+
*+
*+  Function DC_Dec2LongInt(n)
*+
*+  ++ Converts a Long Integer (32 bits) TO binary character representation
*+  Thanks to Cliff Wiernik
*+

FUNCTION DC_Dec2LongInt(n)
  LOCAL i, cBin := ''

  FOR i := 32 TO 1 step -1
    IF n >= 2^(i-1)
      n -= 2^(i-1)
      cBin := cBin + '1'
    ELSE
      cBin := cBin + '0'
    ENDIF
  NEXT

  RETURN cBin

*+
*+
*+  Function DC_XorBitsLong ( n1, n2 )
*+
*+  ++ Performs an exclusive OR on 2 long integer (32 bit values) values
*+  Thanks to Cliff Wiernik
*+
*+
FUNCTION DC_XorBitsLong ( n1, n2 )

  LOCAL c1, c2, c3, i

  n1 := IIF(Valtype(n1)='N',n1,0)
  n2 := IIF(Valtype(n2)='N',n2,0)
  c1 := DC_Dec2LongInt(n1)
  c2 := DC_Dec2LongInt(n2)
  c3 := ''

  FOR i := 1 TO 32
    IF Substr(c1,i,1)='1' .AND. Substr(c2,i,1)='0'
      c3 += '1'
    ELSEIF Substr(c1,i,1)='0' .AND. Substr(c2,i,1)='1'
      c3 += '1'
    ELSE
      c3 += '0'
    ENDIF
  NEXT

RETURN DC_Bin2Num(c3)

* ---------------

FUNCTION DC_HourGlassOn()

SetAppWindow():SetPointer( nil, XBPSTATIC_SYSICON_WAIT, XBPWINDOW_POINTERTYPE_SYSPOINTER )
SetAppWindow():captureMouse(.t.)

RETURN nil

* ---------------

FUNCTION DC_HourGlassOff()

SetAppWindow():SetPointer( nil, XBPSTATIC_SYSICON_SYSTEM, XBPWINDOW_POINTERTYPE_SYSPOINTER )
SetAppWindow():captureMouse(.f.)

RETURN nil

////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                        //
// Date     : 02-01-2006                                                                  //
// By       : Jack Duijf   (jdsoftware@tiscali.nl)                                        //
//                                                                                        //
// New function to find the size of the desktop.                                          //
//                                                                                        //
// This code take in account that there could be 2 monitors with a shared desktop.        //
// It assumes that AppDesktop() only returns the App windows that belong to the Xbase++   //
// application. In case there are multiple monitors, it assumes the same resolution for   //
// both.                                                                                  //
//                                                                                        //
// Parameters    None                                                                     //
// Return        aSize        : aSize[1] = Total width of desktop                         //
//                            : aSize[2] = Total height of desktop                        //
//                                                                                        //
//                                                                                        //
// 02-01-2006  J. Duijf    - Initial release                                              //
//                                                                                        //
////////////////////////////////////////////////////////////////////////////////////////////
Function Dc_DeskTopSize()

LOCAL aChild      := AppDeskTop():ChildList()      // List of Xbase++ windows
LOCAL aRet        := AppDeskTop():CurrentSize()    // Current size of main desktop.
LOCAL nWidth      := 0
if Len(aChild) > 0                                 // There are Xbase++ windows
   nWidth         := aChild[1]:CurrentPos()[1] + aChild[1]:CurrentSize()[1] - 8
   //
   // If the app window is maximized, then the aChild[1]:CurrentPos()[1] = -4, and the with is 8 point larger then
   // AppDesktop():CurrentSize(). Therefore, i correct the App window size by 8 points. In later calculations,
   // i can ignore the discrepancy.
   //
   // nWidth = the position of the right edge of the main app window.
   //
   if nWidth > aRet[1]                             // Width exeeds main AppDesktop()
      aRet[1]     += aRet[1]                       // Width is double with dual monitor, assuming same resolution
                                                   // I do not know how to figure out the 2nd monitor resolution
   endif
endif
Return aRet                                        // Size of AppDesktop()

* -----------------

FUNCTION DC_MoveCursorToObject( oXbp )

LOCAL nCol, nRow, aPos, nHeight := AppDeskTop():currentSize()[2]

nCol := oXbp:currentSize()[1]/2
nRow := oXbp:currentSize()[2]/2
aPos := DC_CalcAbsolutePosition({nCol,nRow},oXbp)
nCol := aPos[1]
nRow := aPos[2]

nRow := nHeight - nRow

SetCursorPos( nCol, nRow )

RETURN nil

* -----------------

FUNCTION DC_AvailableDrives()

LOCAL i, nDrives, cDrives, cAvailDrives := '', nDrive

nDrives := GetLogicalDrives()
cDrives := DC_Dec2Bin(nDrives,4)

nDrive := 0
FOR i := Len(cDrives) to 1 STEP -1
   IF cDrives[i] = '1'
    cAvailDrives += Chr(Asc('A')+nDrive)
  ENDIF
  nDrive++
NEXT

RETURN cAvailDrives

* ---------------

FUNCTION DC_GetNetName()

LOCAL nHKey      := 2147483650
LOCAL cKeyName   := "System\CurrentControlSet\Control\ComputerName\ComputerName"
LOCAL cEntryName := "Computername"
LOCAL cName := "", rc
LOCAL nNameSize
LOCAL nKeyHandle
LOCAL nValueType
nKeyHandle := 0
IF RegOpenKeyExA(nHKey, cKeyName,0, 1, @nKeyHandle) = 0
  nValueType  := 0
  nNameSize  := 0
  RegQueryValueExA(nKeyHandle, cEntryName, 0, @nValueType, 0, @nNameSize)
  IF nNameSize > 0
    cName := space( nNameSize )
    rc := RegQueryValueExA(nKeyHandle, cEntryName,;
                           0, @nValueType, @cName, @nNameSize)
  ENDIF
  RegCloseKey( nKeyHandle)
ENDIF

cName := Strtran(cName,Chr(0),'')

RETURN (Upper(Alltrim(cName)))

* ----------------

FUNCTION DC_IsDescendant( oXbp, oParent )

LOCAL aChildList := oParent:ChildList(), i

FOR i := 1 TO Len(aChildList)
  IF oXbp == aChildList[i]
    RETURN .T.
  ELSEIF DC_IsDescendant( oXbp, aChildList[i] )
    RETURN .T.
  ENDIF
NEXT

RETURN .f.

* -----------------

FUNCTION DC_IsCreateChildren( oParent )

IF oParent == nil
  RETURN .t.
ELSEIF !IsMemberVar(oParent,'isCreateChildren')
  RETURN .t.
ELSEIF !oParent:isCreateChildren
  RETURN .f.
ENDIF

RETURN .t.

* -----------------

FUNCTION DC_Unc2Drive( cUnc )

LOCAL cDrive, i, cDrives := DC_AvailableDrives(), cSubPath := '', cReturnedUnc

FOR i := 1 TO Len(cDrives)
  cDrive := cDrives[i] + ':'
  cReturnedUnc := Alltrim(DC_Drive2Unc( cDrive ))
  IF Lower(Substr(cUnc,1,Len(cReturnedUnc))) == Lower(cReturnedUnc)
    cSubPath := Strtran(Lower(cUnc),Lower(cReturnedUnc))
    EXIT
  ENDIF
NEXT
IF i > Len(cDrives)
  cDrive := ''
ENDIF

RETURN cDrive + cSubPath

* ---------

FUNCTION DC_SetWindowTransparency(hWnd,nPercent)

#if XPPVER > 1900000
LOCAL nExStyle, nTransparentValue, lActive

/*
if !("Windows 2000" $ os() .or. "Windows XP" $ os())
  return nil
endif
*/

IF Valtype(hWnd) == 'O'
  hWnd := hWnd:getHWnd()
ENDIF

nExStyle := GetWindowLongA(hWnd, GWL_EXSTYLE)

lActive := Band( nExStyle, WS_EX_LAYERED ) > 0

IF !lActive
  SetWindowLongA(hWnd, GWL_EXSTYLE, nExStyle + WS_EX_LAYERED)
ENDIF

nTransparentValue := (1 - nPercent / 100) * 255

SetLayeredWindowAttributes(hWnd, 0, nTransparentValue, LWA_ALPHA)
#endif

return nil

* ---------

FUNCTION DC_ZoomTransparent( oDlg, nMode, nSeconds, nPercent )

LOCAL hWnd, i, nExStyle

DEFAULT nMode := 0, ;
        nSeconds := 1, ;
        nPercent := 100

nSeconds := nSeconds * 100

hWnd := oDlg:getHWnd()
nExStyle := GetWindowLongA(hWnd, GWL_EXSTYLE)

IF nMode = 0
  DC_SetWindowTransparency( hWnd, nPercent )
  oDlg:show()
  FOR i := nPercent TO 0 STEP -5
    Sleep( nSeconds / 20 )
    DC_SetWindowTransparency( hWnd, i )
  NEXT
ELSEIF nMode = 1
  DC_SetWindowTransparency( hWnd, 0 )
  oDlg:show()
  FOR i := 0 TO nPercent STEP 5
    Sleep( nSeconds / 20 )
    DC_SetWindowTransparency( hWnd, i )
  NEXT
ENDIF

SetWindowLongA(hWnd, GWL_EXSTYLE, nExStyle)

return nil

* ----------

FUNCTION DC_GetDropFileList( oData )

#if XPPVER > 1900000
IF oData:QueryGetFormat(XBPCLPBRD_FILELIST) == .T.
  RETURN oData:GetData( XBPCLPBRD_FILELIST )
ENDIF
#endif

RETURN nil

* -------------

FUNCTION DC_WorkArea2Excel( cExcelFile, nOrientation, lDisplayAlerts, ;
                            lVisible, aFields, lAutoFit, cDateFormat, aFieldEvals, ;
                            cPassword, lFreezeRow1, lCsvFallBack, aColumnNames )

LOCAL oExcel, oBook, oSheet, nRow, aStru, i, cHeader, ;
      cFieldName, cFieldType, nFieldLen, nFieldDec, cFormat, ;
      xValue, GetList[0], GetOptions, oDlg, nCount := 0, ;
      cDbfName, nKeyCount, oProgress, lStatus := .t., aData, ;
      cRow, cColumns, cRange, aRow, bError, aStru2, nFound, ;
      cFieldValue, nFieldBlock

DEFAULT nOrientation := xlLandscape, ;
        lDisplayAlerts := .f., ;
        lVisible := .f., ;
        lAutoFit := .f., ;
        cDateFormat := "US", ;     // US, USSHORT, EURO, EUROSHORT, or send custom?
        aFieldEvals := {}, ;
        cExcelFile := DC_Path(AppName(.t.)) + 'worksheet.xls', ;
        lFreezeRow1 := .t., ;
        lCsvFallBack := .f.

//  aFieldEvals -> {{FIELDNAME,CodeBlock},....}  Code blocks to evaluate for specific fields

#if XPPVER > 1900000
  // Create the "Excel.Application" object
  IF '.CSV' $ Upper(cExcelFile)
    RETURN DC_WorkArea2Csv(cExcelFile)
  ENDIF
  oExcel := CreateObject("Excel.Application")
  IF Empty( oExcel )
    IF lCsvFallBack
      DCMSGBOX 'Excel is not installed. Create CSV file instead?' YESNO TO lStatus
      IF lStatus
        RETURN DC_WorkArea2Csv(cExcelFile)
      ELSE
        RETURN .f.
      ENDIF
    ELSE
      DC_WinAlert( "Excel is not installed" )
    ENDIF
    RETURN .f.
  ENDIF
#else
  DC_WinAlert('This feature is available in Xbase++ 1.9 and later only!')
  RETURN .f.
#endif

IF upper(cDateFormat) = "USSHORT"
  cDateFormat := "m\/d\/yyyy;@"
ELSEIF upper(cDateFormat) = "US"
  cDateFormat := "mm\/dd\/yyyy;@"
ELSEIF upper(cDateFormat) = "EUROSHORT"
  cDateFormat := "d\/m\/yyyy;@"
ELSEIF upper(cDateFormat) = "EURO"
  cDateFormat := "dd\/mm\/yyyy;@"
ENDIF

// Avoid message boxes such as "File already exists". Also,
// ensure the Excel application is visible.
oExcel:DisplayAlerts := lDisplayAlerts
oExcel:visible       := lVisible

// Add a workbook to the Excel application. Query for
// the active sheet (sheet-1) and set up page/paper
// orientation.

cDbfName := dbInfo(DBO_FILENAME)
IF cDbfName = '<CURSOR>'
  nKeyCount := RecCount()
ELSE
  nKeyCount := DC_KeyCount()
ENDIF

@ 0,0 DCSAY 'Creating Excel Worksheet: ' + cExcelFile SAYSIZE 0

@ 1,0 DCPROGRESS oProgress SIZE 50,1 ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_CYAN, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC ;
      EVERY Int(nKeyCount/100)

@ 3,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 9,1.2 ACTION {||lStatus:=.f.}

DCGETOPTIONS NORESIZE ALWAYSONTOP _PIXEL .f.
DCREAD GUI FIT TITLE 'Exporting to Excel' ;
   MODAL EXIT PARENT @oDlg OPTIONS GetOptions NOAUTORESTORE

oBook  := oExcel:workbooks:Add()
oSheet := oBook:ActiveSheet
oSheet:PageSetup:Orientation := nOrientation

DC_DbGoTop()

nRow := 1

// Feed in the data from the table to the Cells
// of the sheet.

aStru := dbStruct()

IF Valtype(aFields) == 'A'
  aStru2 := AClone(aStru)
  aStru := Array(0)

  FOR i := 1 TO Len(aFields)
    cFieldName := Upper(Alltrim(aFields[i]))
    nFound := AScan(aStru2,{|a|Upper(a[1])==cFieldName})
    IF nFound > 0
      AAdd( aStru, aStru2[nFound] )
    ENDIF
  NEXT
ENDIF

aFields := Array(0)
FOR i := 1 TO Len(aStru)
  cFieldName := aStru[i,1]
  nFieldDec := aStru[i,4]
  IF Valtype(&(cFieldName)) $ 'NF'
    IF nFieldDec == 0
      cFormat := '0'
    ELSE
      cFormat := '0.' + Repl('0',nFieldDec)
    ENDIF
  ELSEIF Valtype(&(cFieldName))=='D'
    cFormat := cDateFormat
  ELSEIF Valtype(&(cFieldName)) $ 'CM'
    cFormat := "@"                        // Preserves leading 0s on strings that look like numbers
  ELSE
    cFormat := ''
  ENDIF
  AAdd(aFields,{cFieldName,cFieldName,cFormat})
NEXT

FOR i := 1 TO Len(aFields)
  IF Len(aFields[i]) < 3
    ASize(aFields[i],3)
  ENDIF
  IF Valtype(aColumnNames) == 'A' .AND. Len(aColumnNames) == Len(aFields)
    cHeader := aColumnNames[i]
  ELSE
    cHeader := aFields[i,2]
  ENDIF
  IF !Empty(cHeader)
    oSheet:Cells(nRow,i):Value := cHeader
  ENDIF
  cFormat := aFields[i,3]
  IF !Empty(cFormat)
    oSheet:Columns(i):NumberFormat := cFormat
  ENDIF
NEXT

aRow := Array(Len(aStru))
aData := Array(0)
cColumns := Get_Excel_Column_ID(Len(aRow))

nRow += 2
DO WHILE !DC_Eof() .AND. lStatus
  DC_CompleteEvents()
  DC_GetProgress(oProgress,nCount++,nKeyCount)
  FOR i := 1 TO Len(aFields)
    cFieldName := aFields[i,1]
    cFieldValue := &(cFieldName)
    nFieldBlock := aScan(aFieldEvals,{|a|upper(a[1])==upper(cFieldName)})
    IF nFieldBlock > 0
      cFieldValue := Eval(aFieldEvals[nFieldBlock,2],cFieldValue)
    ENDIF
    IF Valtype(cFieldValue) == 'D'
      aRow[i] := Dtoc(cFieldValue)
    ELSEIF Valtype(cFieldValue) $ 'CM'
      aRow[i] := Trim(cFieldValue)
    ELSE
      aRow[i] := cFieldValue
    ENDIF
  NEXT
  AAdd( aData, AClone(aRow) )
  nRow++
  DC_DbSkip(1)
ENDDO

cRange := 'A3:' + cColumns + Ltrim(Str(nRow-1))

oDlg:destroy()

oSheet:Range(cRange):Value := aData

// Force a reformat for the size of the first column
IF lAutoFit
  FOR i := 1 TO Len(aFields)
    oSheet:Columns(i):AutoFit()
  NEXT
ENDIF

IF lFreezeRow1
  oSheet:Range("A1:A1"):EntireRow:Font:Bold := .t.
  oSheet:Activate()
  oSheet:Application:ActiveWindow:SplitRow := 1
  oSheet:Application:ActiveWindow:FreezePanes := .T.
ENDIF

bError := ErrorBlock( {|e| Break(e) } )

BEGIN SEQUENCE

  // Save workbook as ordinary excel file.
  oBook:SaveAs(cExcelFile,xlWorkbookNormal,cPassword)

RECOVER

END SEQUENCE

ErrorBlock(bError)

oSheet:destroy()
oBook:close()
oBook:destroy()

// Quit Excel
oExcel:Quit()
oExcel:Destroy()

RETURN .t.

* -------------

FUNCTION DC_Excel2WorkArea( cExcelFile )

LOCAL lStatus := .f., oExcel, cPath, oSheet, oBook, aValues, i, j, ;
      aStru, xValue

#if XPPVER > 1900000
  // Create the "Excel.Application" object
  oExcel := CreateObject("Excel.Application")
  IF Empty( oExcel )
    DC_WinAlert( "Excel is not installed" )
    RETURN .f.
  ENDIF
#else
  DC_WinAlert('This feature is available in Xbase++ 1.9 and later only!')
  RETURN .f.
#endif

oExcel:Visible := .f.

// Load a Workbook from an .XLS file
// Get path from ini file

IF !File(cExcelFile)
  DC_WinAlert( 'File does not exist:' + Chr(13) + cExcelFile )
  RETURN lStatus
ENDIF

oBook := oExcel:Workbooks:Open(cExcelFile)

oSheet := oBook:activeSheet

aValues := oBook:workSheets(1):usedRange:value

aStru := dbStruct()

FOR i := 3 TO Len(aValues)
  dbAppend()
  FOR j := 1 TO Len(aValues[i])
    xValue := aValues[i,j]
    IF Valtype(xValue) == 'N' .AND. aStru[j,2] == 'C'
      xValue := DC_XtoC(xValue)
    ELSEIF aStru[j,2] == 'D' .AND. Valtype(xValue) == 'N'
      xValue := Str(xValue)
      xValue := StoD(xValue)
    ELSEIF aStru[j,2] == 'D' .AND. Valtype(xValue) == 'C'
      xValue := Ctod(xValue)
    ELSEIF aStru[j,2] == 'C' .AND. Valtype(xValue) == 'D'
      xValue := DtoS(xValue)
    ENDIF
    FieldPut(j,xValue)
  NEXT
NEXT

oBook:close()
oBook:destroy()

// Quit Excel
oExcel:Quit()
oExcel:Destroy()

RETURN lStatus

* -------------

FUNCTION DC_Array2Excel( cExcelFile, aData, nOrientation, lDisplayAlerts, ;
                         lVisible, lAutoFit, lTrimNilColumns, lCombineSheets, ;
                         cPassword, lFreezeRow1, lCSVFallBack )

LOCAL oExcel, oBook, oSheet, i, j, oScrn, xData, nSheet, xValue, lStatus := .t., ;
      oProgress1, oProgress2, GetList[0], GetOptions, oDlg, nRowOffset, nLastRow, ;
      nColumns, nRows, cRange, oCells, cColId, nStartRow, bError

DEFAULT nOrientation := xlLandscape, ;
        lDisplayAlerts := .f., ;
        lVisible := .f., ;
        lAutoFit := .t., ;
        cExcelFile := DC_Path(AppName(.t.)) + 'worksheet.xls', ;
        lTrimNilColumns := .f., ;
        lCombineSheets := .f., ;
        lFreezeRow1 := .f., ;
        lCSVFallBack := .t.

#if XPPVER > 1900000
  // Create the "Excel.Application" object
  IF '.CSV' $ Upper(cExcelFile)
    RETURN DC_Array2CSV(cExcelFile,aData)
  ENDIF

  oExcel := CreateObject("Excel.Application")
  IF Empty( oExcel )
    IF lCSVFallBack
      DCMSGBOX 'Excel is not installed. Create CSV file instead?' YESNO TO lStatus
      IF lStatus
        RETURN DC_Array2CSV(cExcelFile,aData)
      ELSE
        RETURN .f.
      ENDIF
    ELSE
      DC_WinAlert( "Excel is not installed" )
    ENDIF
    RETURN .f.
  ENDIF
#else
  DC_WinAlert('This feature is available in Xbase++ 1.9 and later only!')
  RETURN .f.
#endif

IF lTrimNilColumns
  FOR i := 1 TO Len(aData)
    aData[i] := DC_ArrayTrim(aData[i])
  NEXT
ENDIF

// Avoid message boxes such as "File already exists". Also,
// ensure the Excel application is visible.
oExcel:DisplayAlerts := lDisplayAlerts
oExcel:visible       := lVisible

// Add a workbook to the Excel application. Query for
// the active sheet (sheet-1) and set up page/paper
// orientation.

@ 0,0 DCSAY 'Creating Excel Worksheet: ' + cExcelFile SAYSIZE 0

@ 1,0 DCPROGRESS oProgress1 SIZE 50,1 ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_CYAN, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC

@ 3,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 9,1.2 ACTION {||lStatus:=.f.}

DCGETOPTIONS ;
   NORESIZE ;
   ALWAYSONTOP ;
   _PIXEL .f.

DCREAD GUI FIT TITLE 'Exporting to Excel' ;
   MODAL EXIT PARENT @oDlg OPTIONS GetOptions NOAUTORESTORE

oBook  := oExcel:workbooks:Add()

nRowOffset := 0
nLastRow := 0

nStartRow := 1

BEGIN SEQUENCE

FOR nSheet := 1 TO Len(aData)

  DC_CompleteEvents()

  IF Empty(aData[nSheet])
    LOOP
  ENDIF

  IF !lStatus
    BREAK
  ENDIF

  DC_GetProgress(oProgress1,nSheet,Len(aData))

  IF nSheet > oBook:Sheets:Count
    IF !lCombineSheets
      oSheet := oBook:Sheets:Add()
      nStartRow := 1
    ELSE
      oSheet := oBook:Sheets:Item(1)
    ENDIF
  ELSEIF lCombineSheets
    oSheet := oBook:Sheets:Item(1)
  ELSE
    oSheet := oBook:Sheets:Item(nSheet)
    nStartRow := 1
  ENDIF

  oSheet:PageSetup:Orientation := nOrientation

  // Feed in the data from the table to the Cells
  // of the sheet.

  nColumns := Len(aData[nSheet,1])
  nRows := Len(aData[nSheet])
  cRange := 'A' + Alltrim(Str(nStartRow)) + ':' + Get_Excel_Column_ID(nColumns) + LTrim(Str(nRows+nStartRow-1))

  FOR i := 1 TO nRows
    DC_CompleteEvents()
    IF !lStatus
      BREAK
    ENDIF
    FOR j := 1 TO nColumns
      aData[nSheet,i,j] := Alltrim(DC_XtoC(aData[nSheet,i,j]))
      aData[nSheet,i,j] := Strtran(aData[nSheet,i,j],'=','')
//      aData[nSheet,i,j] := Strtran(aData[nSheet,i,j],'-','')
    NEXT
  NEXT

  oSheet:Range(cRange):Value := aData[nSheet]

  // Force a reformat for the size of the first column
  IF lAutoFit
    FOR i := 1 TO Len(aData[nSheet,1])
      DC_CompleteEvents()
      IF !lStatus
        BREAK
      ENDIF
      oSheet:Columns(i):AutoFit()
    NEXT
  ENDIF

  nStartRow += Len(aData[nSheet])

  IF lFreezeRow1
    oSheet:Range("A1:A1"):EntireRow:Font:Bold := .t.
    oSheet:Activate()
    oSheet:Application:ActiveWindow:SplitRow := 1
    oSheet:Application:ActiveWindow:FreezePanes := .T.
  ENDIF

NEXT

IF Empty(DC_Path(cExcelFile))
  cExcelFile := DC_Path(AppName(.t.)) + cExcelFile
ENDIF

cExcelFile := Strtran(cExcelFile,'\\','\',2)

END SEQUENCE

bError := ErrorBlock({|e|Break(e)})
BEGIN SEQUENCE

oDlg:Destroy()

/*
IF !lStatus
  BREAK
ENDIF
*/

// Save workbook as ordinary excel file.
oBook:SaveAs(cExcelFile,xlWorkbookNormal,cPassword)

END SEQUENCE
ErrorBlock(bError)

oBook:close()
oBook:destroy()

// Quit Excel
oExcel:Quit()
oExcel:Destroy()

RETURN .t.

* ---------------

FUNCTION Get_Excel_Column_ID( i )

LOCAL cAlpha := "ABCDEFGHIJKLMNOPQRSTUVWXYZ", cLastRow := ""

IF i > 26
  cLastRow := Substr(cAlpha,Int(i/26),1) + Substr(cAlpha,Mod(i,26),1)
ELSE
  cLastRow := Substr(cAlpha,i,1)
ENDIF

RETURN cLastRow

* ---------------

FUNCTION DC_ArrayTrim( aData )

LOCAL nColumns, i, j, lEmpty

IF Empty(aData)
  RETURN aData
ENDIF

FOR i := 1 TO Len(aData)
  IF aData[i] == NIL
    ARemove(aData,i)
    i--
  ENDIF
NEXT

IF Valtype(aData[1]) == 'A'
  nColumns := Len(aData[1])
ELSE
  RETURN aData
ENDIF

FOR i := 1 TO nColumns
  lEmpty := .t.
  FOR j := 1 TO Len(aData)
    IF i > Len(aData[j])
      lEmpty := .f.
      EXIT
    ENDIF
    IF !aData[j,i] == NIL
      lEmpty := .f.
      EXIT
    ENDIF
  NEXT
  IF lEmpty
    FOR j := 1 TO Len(aData)
      ARemove( aData[j], i)
    NEXT
    nColumns--
    i := 0
  ENDIF
NEXT

RETURN aData


// This function was contributed by Brian Wolfsohn

FUNCTION DC_JPGSize( cImage, nWidth, nHeight)

local nHandle
local nBytes,cBuffer,n1,n2,nSize,cMarker,nStart,nPos,i
local cError:=""
if (nHandle := fopen( cImage, FO_READ + FO_SHARED )) >0
  //nSize:=int(fsize(nHandle)/2)
  nSize:=int(fsize(nHandle))
  cBuffer:=space(nSize)
  nBytes:=fread(nHandle,@cBuffer,nSize)
  IF nBytes<>nSize
    cError:="error reading 1/2 file: "+cImage+CRLF
    fclose(nHandle)
    return(cError)
  ENDIF
  cMarker := CHR(255) + CHR(192)
  nStart:=1
  i:=1
  do while .t.
    if (nPos:=at(cMarker,cBuffer,nStart))>0
      nStart:=nPos
      n1:=asc(subs(cBuffer,nStart+5,1))
      n2:=asc(subs(cBuffer,nStart+6,1))
      nHeight:= (n1*256) + n2
      n1:=asc(subs(cBuffer,nStart+7,1))
      n2:=asc(subs(cBuffer,nStart+8,1))
      nWidth := (n1*256) + n2
      nStart+=8
      i++
    else
      exit
    ENDIF
  ENDDO
endif
fclose(nHandle)

return(cError)

* ---------------

CLASS DC_MapDirections

EXPORTED:

VAR vendor   // Microsoft, Google, Yahoo, MapQuest

VAR lat1
VAR lon1
VAR street1
VAR city1
VAR state1
VAR zip1
VAR country1
VAR title1

VAR lat2
VAR lon2
VAR street2
VAR city2
VAR state2
VAR zip2
VAR country2
VAR title2

VAR url
VAR zoom
VAR style
VAR secure

METHOD Init(), Navigate(), AsString()

ENDCLASS

* -------------

METHOD DC_MapDirections:init( cVendor )

::vendor := cVendor

::lat1 := 0
::lon1 := 0
::street1 := ''
::city1 := ''
::state1 := ''
::zip1 := ''
::country1 := ''
::title1 := ''

::lat2 := 0
::lon2 := 0
::street2 := ''
::city2 := ''
::state2 := ''
::zip2 := ''
::country2 := ''
::title2 := ''

::style := 0
::zoom := 5   // 1 - 19
::secure := .f.

DEFAULT ::vendor := 'GOOGLE'

RETURN self

* -------------

METHOD DC_MapDirections:asString()

RETURN ::navigate(.f.)

* -------------

METHOD DC_MapDirections:navigate( lSpawn )

LOCAL cStyle

DEFAULT lSpawn := .t.

IF Upper(::vendor) = 'MICROSOFT' .OR. Upper(::vendor) = 'MSN'

  IF ::style == 1       // map
    cStyle := 'r'
  ELSEIF ::style == 2   // satellite
    cStyle := 'a'
  ELSEIF ::style == 3   // hybrid
    cStyle := 'h'
  ELSE
    cStyle := 'r'
  ENDIF

  ::url := "http" + IIF(::secure,"s","") + "://maps.live.com/default.aspx?v=1&style=" + cStyle + '&'
  IF !Empty(::lat1) .AND. !Empty(::lon1) .AND. !Empty(::lat2) .AND. !Empty(::lon2)
     ::url += 'rtp=pos.' + Alltrim(Str(::lat1))+'_'+Alltrim(Str(::lon1))
     IF !Empty(::title1)
       // ::title1 += ' ' + ::street1 + ' ' + ::city1 + ' ' + ::state1 + ' ' + ::zip1
       ::url += '_' + ::title1
     ENDIF
     ::url += '~pos.' + Alltrim(Str(::lat2))+'_'+Alltrim(Str(::lon2))
     IF !Empty(::title2)
       // ::title2 += ' ' + ::street2 + ' ' + ::city2 + ' ' + ::state2 + ' ' + ::zip2
       ::url += '_' + ::title2
     ENDIF
     ::zoom := 0
  ELSEIF !Empty(::lat1) .AND. !Empty(::lon1)
     ::url += '&cp='+Alltrim(Str(::lat1))+'~'+Alltrim(Str(::lon1))
  ELSEIF !Empty(::street1) .AND. !Empty(::street2)
     ::url += 'rtp=adr.' + Alltrim(::street1)+','+Alltrim(::city1)+','+Alltrim(::state1)+','+Alltrim(::zip1)
     IF !Empty(::title1)
       // ::title1 += '_' + ::street1 + '_' + ::city1 + '_' + ::state1 + '_' + ::zip1
       ::url += '_' +  + Strtran(::title1,' ','_')
     ENDIF
     ::url += '~adr.' + Alltrim(::street2)+','+Alltrim(::city2)+','+Alltrim(::state2)+','+Alltrim(::zip2)
     IF !Empty(::title2)
       // ::title2 += '_' + ::street2 + '_' + ::city2 + '_' + ::state2 + '_' + ::zip2
       ::url += '_' + Strtran(::title2,' ','_') + '_'
     ENDIF
  ELSEIF !Empty(::street1)
     ::url += "where1=" + ::street1 + ' ' + ::city1 + ' ' + ;
          ::state1 + ' ' + ::zip1 + ' ' + ::country1
  ENDIF

  IF ::zoom > 0
    ::url += '&lvl=' + Alltrim(Str(::zoom))
  ENDIF

ELSEIF Upper(::vendor) = 'GOOGLE'

  IF ::style == 1       // map
    cStyle := 'm'
  ELSEIF ::style == 2   // satellite
    cStyle := 'k'
  ELSEIF ::style == 3   // hybrid
    cStyle := 'h'
  ELSE
    cStyle := 'r'
  ENDIF

  ::url := "http" + IIF(::secure,"s","") + "://maps.google.com/maps?ie=UTF8&oe=UTF-8&hl=en&t=" + cStyle + '&'

  IF ::zoom > 0
    ::url += 'z=' + Alltrim(Str(::zoom)) + '&'
  ENDIF

  IF !Empty(::lat1) .AND. !Empty(::lon1) .AND. !Empty(::lat2) .AND. !Empty(::lon2)
     ::url += 'q=' + Alltrim(Str(::lat1))+','+Alltrim(Str(::lon1))
     IF !Empty(::title1)
       ::title1 += ' ' + ::street1 + ' ' + ::city1 + ' ' + ::state1 + ' ' + ::zip1
       ::url += '+(' + ::title1 + ')'
     ENDIF
     ::url += '+to+' + Alltrim(Str(::lat2))+','+Alltrim(Str(::lon2))
     IF !Empty(::title2)
       ::title2 += ' ' + ::street2 + ' ' + ::city2 + ' ' + ::state2 + ' ' + ::zip2
       ::url += '+(' + ::title2 + ')'
     ENDIF
  ELSEIF !Empty(::lat1) .AND. !Empty(::lon1)
     ::url += 'q=' + Alltrim(Str(::lat1))+','+Alltrim(Str(::lon1))
     IF !Empty(::title1)
       ::title1 += ' ' + ::street1 + ' ' + ::city1 + ' ' + ::state1 + ' ' + ::zip1
       ::url += ' (' + ::title1 + ')'
     ENDIF
  ELSEIF !Empty(::street1) .AND. !Empty(::street2)
     ::url += 'q=' + ::street1 + ',' + ::city1 + ',' + ;
          ::state1 + ',' + ::zip1 + ',' + ::country1 + ' (' + ::title1 + ')' + '+to+'
     ::url += ::street2 + ',' + ::city2 + ',' + ;
          ::state2 + ',' + ::zip2 + ',' + ::country2 + ' (' + ::title2 + ')'
  ELSEIF !Empty(::street1)
     ::url += 'q=' + ::street1 + ',' + ::city1 + ',' + ;
          ::state1 + ',' + ::zip1 + ',' + ::country1 + ' (' + ::title1 + ')'
  ENDIF

ELSEIF Upper(::vendor) = 'MAPQUEST'

  ::url := "http" + IIF(::secure,"s","") + "://www.mapquest.com/directions/main.adp?"

  IF !Empty(::street1) .AND. !Empty(::street2)
     ::url += '&1a=' + ::street1 + '&1c=' + ::city1 + '&1s=' + ;
          ::state1 + '&1z=' + ::zip1 + '&1y=' + ::country1
     ::url += '&2a=' + ::street2 + '&2c=' + ::city2 + '&2s=' + ;
          ::state2 + '&2z=' + ::zip2 + '&2y=' + ::country2
  ELSEIF !Empty(::street1)
     ::url += '1a=' + ::street1 + '&1c=' + ::city1 + '&1s=' + ;
          ::state1 + '&1z=' + ::zip1 + '&1y=' + ::country1
  ELSEIF !Empty(::street2)
     ::url += '2a=' + ::street2 + '&2c=' + ::city2 + '&2s=' + ;
          ::state2 + '&2z=' + ::zip2 + '&2y=' + ::country2
  ENDIF

ELSEIF Upper(::vendor) = 'YAHOO'

  ::url := "http" + IIF(::secure,"s","") + "://maps.yahoo.com/dd?"

  IF !Empty(::street2)
     IF 'US' $ Strtran(::country2,'.','') .OR. Empty(::country2)
       ::country2 := 'US'
     ELSEIF 'CA' $ Strtran(::country2,'.','')
       ::country2 := 'CA'
     ENDIF
     ::url += 'taddr=' + ::street2
     ::url += '&tcsz=' + ::city2 + '+' + ::state2 + '+' + ::zip2
     ::url += '&tcountry=' + ::country2
  ENDIF

ENDIF

::url := Strtran(::url,' ','%20')
// ::url := Strtran(::url,'~','%7c')
::url := Strtran(::url,Chr(13),'%0d')
::url := Strtran(::url,Chr(10),'%0a')

IF lSpawn
  DC_SpawnUrl(::url)
ENDIF

RETURN ::url

* --------------

FUNCTION DC_DbeType( cDbf )

LOCAL nHandle, cBuffer:=SPACE(1), nType, aRetVal, cDbe

cDbf := IF(RAT(".",cDbf)==0,cDbf+".DBF",cDbf)
cDbf := Upper(cDbf)

IF !FILE(cDbf)
   RETURN({0,'File not found','???','???'})
ENDIF

IF (nHandle:=Fopen(cDbf))<0 // file is in exclusive use at this time
   cDbe := DbeInfo(COMPONENT_DATA, DBE_NAME)
   IF Left(cDbe,3)=="FOX"
      aRetVal:={nType,'Foxbase','FOXCDX','CDX'}
   ELSE
      aRetVal:={nType,'Foxbase/Foxpro/dBaseIII/IV no memo','DBFNTX','NTX'}
   ENDIF
   FClose(nHandle)
   RETURN aRetVal
ENDIF

FSeek(nHandle,0,0)  // Move pointer to first byte
FRead(nHandle,@cBuffer,1)
FClose(nHandle)
nType := Asc(cBuffer)

RETURN _GetFileType(nType,cDbf)

* ----------------

STATIC FUNCTION _GetFileType(nType,cDbf)

LOCAL cDbfType, cDriver, cInxExt, lIsCdx

lIsCdx := File(Strtran(cDbf,'.DBF','.CDX'))

DO CASE
   CASE nType=2
     cDbfType='Foxbase'
     cDriver:="FOXCDX"
     cInxExt:="CDX"
   CASE nType=3
     cDbfType='Foxpro/dBaseIII/Ads/Clipper no memo'
     IF lIsCdx
        cDriver := 'DBFCDX/ADSDBE'
        cInxExt := 'CDX'
     ELSE
        cDriver:="DBFNTX/ADSDBE"
        cInxExt:="NTX"
     ENDIF
   CASE nType=48
     cDbfType='Visual Foxpro/Ads'
     cDriver:="FOXCDX/ADSDBE"
     cInxExt:="CDX"
   CASE nType=49
     cDbfType='Visual Foxpro AutoIncr'
     cDriver:="FOXCDX"
     cInxExt:="CDX"
   CASE nType=67
     cDbfType='dBase IV SQL table no memo'
   CASE nType=99
     cDbfType='dBase IV SQL system file no memo'
   CASE nType=131
     cDbfType='FoxPro/dBaseIII/Ads/Clipper with memo'
     IF lIsCdx
        cDriver := 'DBFCDX/ADSDBE'
        cInxExt := 'CDX'
     ELSE
        cDriver:="DBFNTX/ADSDBE"
        cInxExt:="NTX"
     ENDIF
   CASE nType=139
     cDbfType='dBaseIV with memo'
     cDriver:="DBFNTX"
     cInxExt:="NTX"
   CASE nType=203
     cDbfType='dBaseIV SQL table with memo'
   CASE nType=245
     cDbfType='Foxpro 2.x/Ads with memo'
     cDriver:="FOXCDX/ADSDBE"
     cInxExt:="CDX"
   CASE nType=251
     cDbfType='Foxbase'
     cDriver:="FOXCDX"
     cInxExt:="CDX"
   OTHERWISE
     cDbfType='Unknown or invalid type'
ENDCASE

RETURN({nType,cDbfType,cDriver,cInxExt})

* ---------------

FUNCTION DC_VarGroup( cName, aVars )

LOCAL oClass, nAttr, aIvar, xRet, oVars, oVarsInstance, i, ;
      aVars2 := {}

FOR i := 1 TO Len(aVars)
  AAdd(aVars2,aVars[i,1])
NEXT

DEFAULT cName := '1'

cName := 'VARGROUP_' + cName

oClass := ClassObject( cName )

IF oClass <> NIL
  RETURN oClass                 // Class already exists
ENDIF

nAttr   := CLASS_EXPORTED + VAR_INSTANCE
aIVar   := AEval( aVars2, {|a| a := {a, nAttr} } ,,, .T.)

oVars := ClassCreate( cName,, aIVar )

oVarsInstance := oVars:new()

FOR i := 1 TO Len(aVars)
  oVarsInstance:&(aVars[i,1]) := aVars[i,2]
NEXT

RETURN oVarsInstance

* ------------

FUNCTION DC_VarGroupOld( cName, aVars )

LOCAL oClass, nAttr, aIvar

DEFAULT cName := '1'

oClass := ClassObject( 'VARGROUP_' + cName )

IF oClass <> NIL
  RETURN oClass                 // Class already exists
ENDIF

nAttr   := CLASS_EXPORTED + VAR_INSTANCE
aIVar   := AEval( aVars, {|a| a := {a, nAttr} } ,,, .T.)

RETURN ClassCreate( 'VARGROUP_' + cName,, aIVar )

* --------------

CLASS DC_DbNotify

EXPORTED:

VAR alias
VAR saveRecordObject
VAR saveRecordNumber
VAR saveOrder
VAR saveDeleted
VAR saveIsDeleted
VAR saveScopeTop
VAR saveScopeBottom
VAR saveFilter
VAR eventList
VAR onMoveDone
VAR onMoveProlog
VAR onGoTop
VAR onGoBottom
VAR onTableUpdate
VAR onTableAppend
VAR onTableDeleted
VAR onCloseRequest
VAR onBulkRequest
VAR onBulkComplete
VAR onOrderChanged
VAR onOrderReversed
VAR onRowsetChanged
VAR data
VAR logFile
VAR log2Array
VAR browseObject
VAR userColumns
VAR writeBlock

* ----------

INLINE METHOD init

::userColumns := {}
::log2Array := .f.
::data := {}
::alias := Alias()
::eventList := {}
::saveRecordObject := DC_DbRecord():new()
::saveRecordNumber := RecNo()
::saveOrder := OrdSetFocus()
::saveDeleted := Deleted()
::saveFilter := dbFilter()
::saveScopeTop := DC_SetScope(0)
::saveScopeBottom := DC_SetScope(1)
::saveIsDeleted := Set(_SET_DELETED)
DC_DbScatter(::saveRecordObject)
dbRegisterClient(self)

RETURN self

* ----------

INLINE METHOD destroy

IF Select(::alias) > 0
  (::alias)->(dbDeRegisterClient(self))
ENDIF

RETURN self

* ----------

INLINE METHOD suspend( lChildAreas )

DEFAULT lChildAreas := .f.

IF Select(::alias) > 0
  (::alias)->(dbSuspendNotifications(lChildAreas))
ENDIF

RETURN self

* ----------

INLINE METHOD resume( lChildAreas )

DEFAULT lChildAreas := .f.
IF Select(::alias) > 0
  (::alias)->(dbResumeNotifications(lChildAreas))
ENDIF

RETURN self

* ----------

INLINE METHOD notify( nEvent, mp1, mp2 )

LOCAL nFound := AScan( ::eventList, {|a|a[1]==mp1})

IF Empty(::alias) .OR. Select(::alias) == 0
  RETURN self
ENDIF

::suspend()

IF mp1 == DBO_MOVE_DONE .AND. !Empty(::onMoveDone)
  Eval(::onMoveDone, self)
ELSEIF mp1 == DBO_TABLE_UPDATE .AND. !Empty(::onTableUpdate)
  Eval(::onTableUpdate, self)
ELSEIF mp1 == DBO_TABLE_DELETED .AND. !Empty(::onTableDeleted)
  Eval(::onTableDeleted, self)
ELSEIF mp1 == DBO_TABLE_APPEND .AND. !Empty(::onTableAppend)
  Eval(::onTableAppend, self)
ELSEIF mp1 == DBO_ORDER_CHANGED .AND. !Empty(::onOrderChanged)
  Eval(::onOrderChanged, self)
ELSEIF mp1 == DBO_GOTOP .AND. !Empty(::onGoTop)
  Eval(::onGoTop, self)
ELSEIF mp1 == DBO_GOBOTTOM .AND. !Empty(::onGoBottom)
  Eval(::onGoBottom, self)
ELSEIF mp1 == DBO_MOVE_PROLOG .AND. !Empty(::onMoveProlog)
  Eval(::onMoveProlog, self)
ELSEIF mp1 == DBO_CLOSE_REQUEST .AND. !Empty(::onCloseRequest)
  Eval(::onCloseRequest, self)
ELSEIF mp1 == DBO_BULK_REQUEST .AND. !Empty(::onBulkRequest)
  Eval(::onBulkRequest, self)
ELSEIF mp1 == DBO_BULK_COMPLETE .AND. !Empty(::onBulkComplete)
  Eval(::onBulkComplete, self)
ELSEIF mp1 == DBO_ROWSET_CHANGED .AND. !Empty(::onRowsetChanged)
  Eval(::onRowsetChanged, self)
ELSEIF mp1 == DBO_ORDER_REVERSED .AND. !Empty(::onOrderReversed)
  Eval(::onOrderReversed, self)
ENDIF

IF nFound > 0
  Eval(::eventList[nFound,2],self)
ENDIF

IF mp1 $ { DBO_GOBOTTOM, DBO_GOTOP, DBO_MOVE_DONE }
  (::alias)->(DC_DbScatter(::saveRecordObject))
  ::saveRecordNumber := (::alias)->(RecNo())
  ::saveDeleted := (::alias)->(Deleted())
ELSEIF mp1 $ { DBO_ORDER_CHANGED }
  ::saveOrder := (::alias)->(OrdSetFocus())
ENDIF

::resume()

RETURN self

* ----------

INLINE METHOD onEvent( nEvent, bBlock )

AAdd(::eventList, { nEvent, bBlock })

RETURN self

* ----------

INLINE METHOD processEvent( mp1, aUpdateFields, aUpdateActions )

LOCAL i, j, aFields, oRecord, cEvent, cDesc, cFieldName, cAction, nFound

IF mp1 == DBO_MOVE_DONE

  cEvent := 'OnMoveDone'
  cDesc := '(Record) Is: ' + Alltrim(Str((::alias)->(RecNo()))) + ;
           '  Was: ' + Alltrim(Str(::saveRecordNumber))
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_GOTOP

  cEvent := 'OnGoTop'
  cDesc := '(Record) Is: ' + Alltrim(Str((::alias)->(RecNo()))) + ;
           '  Was: ' + Alltrim(Str(::saveRecordNumber))
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent,  cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_GOBOTTOM

  cEvent := 'OnGoBottom'
  cDesc := '(Record) Is: ' + Alltrim(Str((::alias)->(RecNo()))) + ;
           '  Was: ' + Alltrim(Str(::saveRecordNumber))
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_BULK_REQUEST

  cEvent := 'OnBulkRequest'
  cDesc := 'Bulk Operation Started'
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_BULK_COMPLETE

  cEvent := 'OnBulkComplete'
  cDesc := 'Bulk Operation Completed'
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_CLOSE_REQUEST

  cEvent := 'OnCloseRequest'
  cDesc := 'Work Area Closed'
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_TABLE_APPEND

  cEvent := 'OnTableAppend'
  cDesc := '(Record) Is: ' + Alltrim(Str((::alias)->(RecNo()))) + ;
           '  Was: ' + Alltrim(Str(::saveRecordNumber))
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_ORDER_CHANGED

  cEvent := 'OnOrderChanged'
  cDesc := '(Order) Is: ' + CheckEmpty((::alias)->(OrdSetFocus())) + '  Was: ' + CheckEmpty(::saveOrder)
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_ORDER_REVERSED

  cEvent := 'OnOrderReversed'
  cDesc := '(Order) Is: ' + (::alias)->(OrdSetFocus()) + '  Was: ' + ::saveOrder
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_ROWSET_CHANGED

  cEvent := 'OnRowsetChanged'
  cDesc := ''
  IF !::saveFilter == (::alias)->(dbFilter())
    cDesc += '(Filter) Is: ' + CheckEmpty((::alias)->(dbFilter())) + ' Was: ' + CheckEmpty(::saveFilter) + '  '
  ENDIF
  IF !::saveScopeTop == (::alias)->(DC_SetScope(0))
    cDesc += '(Scope Top) Is: ' + CheckEmpty(DC_XtoC((::alias)->(DC_SetScope(0)))) + ;
             ' Was: ' + CheckEmpty(DC_XtoC(::saveScopeTop))
  ENDIF
  IF !::saveScopeBottom == (::alias)->(DC_SetScope(1))
    cDesc += '(Scope Bottom) Is: ' + CheckEmpty(DC_XtoC((::alias)->(DC_SetScope(1)))) + ' Was: ' + CheckEmpty(DC_XtoC(::saveScopeBottom))
  ENDIF
  IF !::saveIsDeleted == Set(_SET_DELETED)
    cDesc += '(SET DELETED) Is: ' + IIF(Set(_SET_DELETED),'ON','OFF')
  ENDIF
  IF ::log2Array
    AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
    FOR j := 1 TO Len(::userColumns)
      AAdd(Atail(::data),Eval(::userColumns[j,2]))
    NEXT
  ENDIF
  ::saveFilter := (::alias)->(DbFilter())
  ::saveScopeTop := (::alias)->(DC_SetScope(0))
  ::saveScopeBottom := (::alias)->(DC_SetScope(1))
  ::saveIsDeleted := Set(_SET_DELETED)
  ::write2Log( cEvent, cDesc )
  ::writeCustom( cEvent, cDesc )

ELSEIF mp1 == DBO_TABLE_UPDATE .AND. (::alias)->(RecNo()) == ::saveRecordNumber

  cEvent := 'OnTableUpdate'
  oRecord := (::alias)->(DC_DbRecord():new())
  aFields := {}
  (::alias)->(DC_DbScatter(oRecord))
  (::alias)->(DC_DbRecordCompare( oRecord, ::saveRecordObject, aFields ))
  IF !Empty(aFields)
    FOR i := 1 TO Len(aFields)
      IF !Empty(aUpdateFields) .AND. Ascan(aUpdateFields,aFields[i,1]) == 0
        LOOP
      ENDIF
      cFieldName := aFields[i,1]
      nFound := AScan(aUpdateFields,{|c|c==cFieldName})
      IF nFound > 0 .AND. Valtype(aUpdateActions)=='A' .AND. nFound <= Len(aUpdateActions)
        cAction := aUpdateActions[nFound]
      ENDIF
      cDesc := 'Record #' + Alltrim(Str((::alias)->(RecNo()))) + ;
            '  Field: ' + cFieldName + ;
            '  Is: ' + CheckEmpty(aFields[i,2]) + ;
            '  Was: ' + CheckEmpty(aFields[i,3])
      ::write2Log( cEvent, cDesc, cFieldName, cAction )
      ::writeCustom( cEvent, cDesc, cFieldName, cAction )
      IF ::log2Array
        AAdd( ::data, { cEvent, ::alias, cDesc, Date(), Time() } )
        FOR j := 1 TO Len(::userColumns)
          AAdd(Atail(::data),Eval(::userColumns[j,2]))
        NEXT
      ENDIF
    NEXT
  ENDIF
  IF (::alias)->(Deleted()) # ::saveDeleted .AND. ::saveRecordNumber == (::alias)->(RecNo())
    cEvent := 'OnTableDeleted'
    cDesc := 'Record #' + Alltrim(Str((::alias)->(RecNo()))) + '  DELETED FLAG changed to: ' + IIF((::alias)->(Deleted()),'ON','OFF')
    IF ::log2Array
      AAdd(::data, { cEvent, ::alias, cDesc, Date(), Time() })
      FOR j := 1 TO Len(::userColumns)
        AAdd(Atail(::data),Eval(::userColumns[j,2]))
      NEXT
    ENDIF
    ::write2Log( cEvent, cDesc )
    ::writeCustom( cEvent, cDesc )
  ENDIF
  ::saveRecordObject := oRecord

ENDIF

IF Valtype(::browseObject) == 'O' .AND. !Empty(::data)
  ::browseObject:goBottom()
  ::browseObject:forceStable()
  ::browseObject:refreshAll()
ENDIF

RETURN nil

* ----------

INLINE METHOD SetNotifications( aList, aFields, aActions )

IF DBO_MOVE_DONE $ aList
  ::onMoveDone := {||::processEvent(DBO_MOVE_DONE)}
ENDIF

IF DBO_GOTOP $ aList
  ::onGoTop := {||::processEvent(DBO_GOTOP)}
ENDIF

IF DBO_GOBOTTOM $ aList
  ::onGoBottom := {||::processEvent(DBO_GOBOTTOM)}
ENDIF

IF DBO_TABLE_UPDATE $ aList .OR. DBO_TABLE_DELETED $ aList
  ::onTableUpdate := {||::processEvent(DBO_TABLE_UPDATE,aFields,aActions)}
ENDIF

IF DBO_TABLE_APPEND $ aList
  ::onTableAppend := {||::processEvent(DBO_TABLE_APPEND)}
ENDIF

IF DBO_ORDER_CHANGED $ aList
  ::onOrderChanged := {||::processEvent(DBO_ORDER_CHANGED)}
ENDIF

IF DBO_ORDER_REVERSED $ aList
  ::onOrderReversed := {||::processEvent(DBO_ORDER_REVERSED)}
ENDIF

IF DBO_ROWSET_CHANGED $ aList
  ::onRowsetChanged := {||::processEvent(DBO_ROWSET_CHANGED)}
ENDIF

IF DBO_MOVE_PROLOG $ aList
  ::onMoveProlog := {||::processEvent(DBO_MOVE_PROLOG)}
ENDIF

IF DBO_CLOSE_REQUEST $ aList
  ::onCloseRequest := {||::processEvent(DBO_CLOSE_REQUEST)}
ENDIF

IF DBO_BULK_REQUEST $ aList
  ::onBulkRequest := {||::processEvent(DBO_BULK_REQUEST)}
ENDIF

IF DBO_BULK_COMPLETE $ aList
  ::onBulkComplete := {||::processEvent(DBO_BULK_COMPLETE)}
ENDIF

RETURN nil

* ----------

INLINE METHOD WriteCustom( cNotifyName, cDescription, cFieldName, cAction )

IF Valtype(::writeBlock) == 'B'
  Eval(::writeBlock, cNotifyName, ::alias, cDescription, self, cFieldName, cAction )
ENDIF

RETURN self

* ----------

INLINE METHOD Write2Log( cNotifyName, cDescription )

LOCAL nHandle, j, cUserColumns := ''

IF !Empty(::logFile)
  IF !Fexists(::logFile)
    nHandle := FCreate(::logFile)

    FOR j := 1 TO Len(::userColumns)
      cUserColumns += Pad(::userColumns[j,1],50)
    NEXT


    FWrite( nHandle, Pad('Notification',16) + ;
                     Pad('Alias',11) + ;
                     Pad('Description',101) + ;
                     Pad('Date',11) + ;
                     Pad('Time',9) + ;
                     cUserColumns + ;
                     CRLF + CRLF )
  ELSE
    nHandle := Fopen(::logFile, FO_WRITE + FO_SHARED)
  ENDIF
  IF nHandle > 0
    cUserColumns := ''
    FOR j := 1 TO Len(::userColumns)
      cUserColumns += Pad(DC_XtoC(Eval(::userColumns[j,2])),50)
    NEXT
    FSeek( nHandle, 0, FS_END )
    Fwrite( nHandle, Pad(cNotifyName,16) + ;
                     Pad(::alias,11) + ;
                     Pad(cDescription,101) + ;
                     Dtoc(Date()) + ' ' + ;
                     Time() + ' ' + ;
                     cUserColumns + ;
                     CRLF )
    FClose(nHandle)
  ENDIF
ENDIF

RETURN self

* ----------

INLINE METHOD AddUserColumn( aColumn )

AAdd( ::userColumns, aColumn )

RETURN self

ENDCLASS

* ------------

FUNCTION DC_WtfNotify( nType, aEvents, cAlias, aFields, nFGColor, nBGColor, nOutput, aVars, aVarsDesc )

STATIC aNotify[0]
LOCAL oNotify, nFound

DEFAULT cAlias := Alias(), ;
        nOutput := 1

IF nType == 1 // create
  IF Empty(aEvents)
    aEvents := { DBO_TABLE_UPDATE, DBO_TABLE_APPEND, DBO_TABLE_DELETED }
  ENDIF
  oNotify := (cAlias)->(DC_DbNotify():new())
  oNotify:setNotifications( aEvents, aFields )
  IF nOutput == 1
    oNotify:writeBlock := {|Event,Alias,Comments|(wtf Event,Alias,Comments COLOR nFGColor, nBGColor), ;
                                                 _wtf( aVars, aVarsDesc, nFGColor, nBGColor )}
  ELSE
    oNotify:writeBlock := {|Event,Alias,Comments| ;
                             DC_DebugLogOut( {'Event:',Event} ), ;
                             DC_DebugLogOut( {'Alias:',Alias} ), ;
                             DC_DebugLogOut( {'Comments:',Comments} ), ;
                             _wtl( aVars, aVarsDesc) }
  ENDIF
  AAdd(aNotify,oNotify)
ELSEIF nType == 2 // suspend
  nFound := AScan(aNotify,{|o|o:alias==cAlias})
  IF nFound > 0
    oNotify := aNotify[nFound]
    oNotify:suspend()
  ENDIF
ELSEIF nType == 3 // resume
  nFound := AScan(aNotify,{|o|o:alias==cAlias})
  IF nFound > 0
    oNotify := aNotify[nFound]
    oNotify:resume()
  ENDIF
ELSEIF nType == 4 // destroy
  nFound := AScan(aNotify,{|o|o:alias==cAlias})
  IF nFound > 0
    oNotify := aNotify[nFound]
    oNotify:destroy()
    ARemove(aNotify,nFound)
  ENDIF
ENDIF

RETURN Nil

* -----------

FUNCTION DC_DbNotifyBlock( bEval )

STATIC sbEval

IF Valtype(bEval) == 'B'
  sbEval := bEval
ENDIF

RETURN sbEval

* -----------

STATIC FUNCTION CheckEmpty( cString )

IF Empty(cString)
  RETURN '<none>'
ENDIF

RETURN cString

* -----------

STATIC FUNCTION _wtf( aVars, aVarsDesc, nFGColor, nBGColor )

LOCAL i

IF !Empty(aVars)
  FOR i := 1 TO Len(aVars)
    DC_DebugBrowse( {Eval(aVars[i])}, {aVarsDesc[i]},, nFGColor, nBGColor )
  NEXT
ENDIF

RETURN nil

* -----------

STATIC FUNCTION _wtl( aVars, aVarsDesc )

LOCAL i

IF !Empty(aVars)
  FOR i := 1 TO Len(aVars)
    DC_DebugLogOut( { aVarsDesc[i]+":", Eval(aVars[i]) } )
  NEXT
ENDIF

RETURN nil

* -----------

FUNCTION DC_DebugLogBrowse()

LOCAL aDebug[0], nHandle, aTokens, aTokens2, aTokens3, ;
      aLine[0], i, cLine, GetList[0], oBrowse, GetOptions, ;
      cString

nHandle := DC_TxtOpen( DC_DebugLogFile(), FO_READWRITE )
FSeek( nHandle, 0, FS_END )
FWrite( nHandle, Chr(13)+Chr(10))
FSeek( nHandle, 0, FS_SET )

DO WHILE !DC_TxtEof(nHandle)
  cLine := DC_TxtLine( nHandle )
  DC_TxtSkip(nHandle,1)
  IF Empty(cLine)
    LOOP
  ENDIF
  cLine := Strtran( cLine, '  <- Called From: ',Chr(255))
  IF Left(cLine,1) == ' '
    cLine := Substr(cLine,2)
  ENDIF
  ASize( aLine, 0 )
  aTokens := DC_TokenArray( cLine, Chr(255))
  aTokens2 := DC_TokenArray( aTokens[1], ': ')
  cString := Substr(aTokens[1],1,At(':',aTokens[1]))
  AAdd( aLine, cString )
  cString := Substr(aTokens[1],At(':',aTokens[1])+1)
  AAdd( aLine, cString )
  aTokens3 := DC_TokenArray( aTokens[2], ', ')
  FOR i := 1 TO Len(aTokens3)
    IF !Empty(aTokens3[i])
      AAdd( aLine, aTokens3[i] )
    ENDIF
  NEXT
  AAdd( aDebug, AClone( aLine ))
ENDDO

DC_TxtClose(nHandle)

@ 0,0 DCBROWSE oBrowse SIZE 100,20 PRESENTATION DC_BrowPres() ;
      DATA aDebug RESIZE DCGUI_RESIZE_RESIZEONLY ;
      FONT '9.Lucida Console' OPTIMIZE

DCBROWSECOL ELEMENT 1 HEADER 'Expression' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[1]<b[1]})}

DCBROWSECOL ELEMENT 2 HEADER 'Value' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[2]<b[2]})}

DCBROWSECOL ELEMENT 14 HEADER 'Date' WIDTH 10 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[14]<b[14]})}

DCBROWSECOL ELEMENT 15 HEADER 'Time' WIDTH 8 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[15]<b[15]})}

DCBROWSECOL ELEMENT 3 HEADER 'Stack 1' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[3]<b[3]})}

DCBROWSECOL ELEMENT 4 HEADER 'Stack 2' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[4]<b[4]})}

DCBROWSECOL ELEMENT 5 HEADER 'Stack 3' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[5]<b[5]})}

DCBROWSECOL ELEMENT 6 HEADER 'Stack 4' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[6]<b[6]})}

DCBROWSECOL ELEMENT 7 HEADER 'Stack 5' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[7]<b[7]})}

DCBROWSECOL ELEMENT 8 HEADER 'Stack 6' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[8]<b[8]})}

DCBROWSECOL ELEMENT 9 HEADER 'Stack 7' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[9]<b[9]})}

DCBROWSECOL ELEMENT 10 HEADER 'Stack 8' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[10]<b[10]})}

DCBROWSECOL ELEMENT 11 HEADER 'Stack 9' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[11]<b[11]})}

DCBROWSECOL ELEMENT 12 HEADER 'Stack 10' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[12]<b[12]})}

DCBROWSECOL ELEMENT 13 HEADER 'Stack 11' WIDTH 15 PARENT oBrowse ;
   SORT {||ASort(aDebug,,,{|a,b|a[13]<b[13]})}

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Browsing DEBUG.LOG' OPTIONS GetOptions ;
   SETFOCUS @oBrowse

RETURN nil

* -------------

FUNCTION DC_NumAt( cSubString, cString )

LOCAL nStart := 0, nOccur := 0

DO WHILE (nStart := At( cSubString, cString, nStart+1 )) > 0
  nOccur++
ENDDO

RETURN nOccur

* -------------

FUNCTION DC_Excel2Array( cExcelFile, bEval )

LOCAL oExcel, oBook, aValues

#if XPPVER > 1900000
  // Create the "Excel.Application" object
  oExcel := CreateObject("Excel.Application")
  IF Empty( oExcel )
    DC_WinAlert( "Excel is not installed" )
    RETURN nil
  ENDIF
#else
  DC_WinAlert('This feature is available in Xbase++ 1.9 and later only!')
  RETURN nil
#endif

oExcel:Visible := .f.

// Load a Workbook from an .XLS file

IF !FExists(cExcelFile)
  DC_WinAlert( 'File does not exist:' + Chr(13) + cExcelFile )
  RETURN nil
ENDIF

oBook := oExcel:Workbooks:Open(cExcelFile)

IF Valtype(bEval) == 'B'
  Eval( bEval, oExcel, oBook )
ENDIF

aValues := oBook:workSheets(1):usedRange:value

oBook:close()
oBook:destroy()

// Quit Excel
oExcel:Quit()
oExcel:Destroy()

RETURN aValues

* -----------------

FUNCTION DC_WindowList( oParent, oButton )

LOCAL GetList[0], GetOptions, aWindows, aChildren, i, oMenu, oXbp

aChildren := oParent:childList()

DCSUBMENU oMenu PROMPT 'Windows' OWNERDRAW

FOR i := 1 TO Len(aChildren)
  oXbp := aChildren[i]
  IF oXbp:isDerivedFrom('XbpDialog')
    DCMENUITEM oXbp:title ACTION _ActionBlock(oXbp) PARENT oMenu
  ENDIF
NEXT

DCREAD GUI EXIT SAVE PARENT AppDeskTop()

oMenu:PopUp( oButton:setParent(), oButton:currentPos(), 2 , ;
             XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  )

RETURN nil

* --------------

STATIC FUNCTION _ActionBlock( oXbp )

RETURN {||oXbp:setFrameState(XBPDLG_FRAMESTAT_NORMALIZED), ;
          oXbp:toFront()}

* --------------

FUNCTION DC_FileNameDupe( cFileName )

LOCAL aDir, cPrimary, cExtension, i, cChar, nStart, nEnd, nCount

IF '.' $ cFileName
  FOR i := Len(cFileName) TO 1 STEP -1
    cChar := cFileName[i]
    IF cChar == '.'
      cPrimary := Substr(cFileName,1,i-1)
      cExtension := Substr(cFileName,i)
      EXIT
    ENDIF
  NEXT
ELSE
  cPrimary := cFileName
  cExtension := ''
ENDIF

aDir := Directory( cPrimary + '*' + cExtension )

ASort(aDir,,,{|a,b|a[1]<b[1]})

IF Len(aDir) == 1 .AND. ! '(' $ aDir[1,1]
  cFileName := cPrimary + '(1)' + cExtension
ELSEIF Len(aDir) > 1 .OR. (Len(aDir) == 1 .AND. '(' $ aDir[1,1])
  IF Upper(Alltrim(Atail(aDir)[1])) == Upper(Alltrim(cFileName)) .OR. Len(aDir) == 1
    IF Len(aDir) > 1
      cFileName := aDir[Len(aDir)-1][1]
    ELSE
      cFileName := aDir[1,1]
    ENDIF
    nStart := 0
    nEnd := 0
    FOR i := Len(cFileName) TO 1 STEP -1
      cChar := cFileName[i]
      IF cChar == ')'
        nEnd := i
      ELSEIF cChar == '('
        nStart := i
        EXIT
      ENDIF
    NEXT
    IF nStart > 0 .AND. nEnd > 0
      nCount := Val(Substr(cFileName,nStart+1,nEnd-nStart-1))
      cFileName := Strtran(cFileName, ;
                   '('+Alltrim(Str(nCount)) + ')', ;
                   '('+Alltrim(Str(nCount+1)) + ')')
    ENDIF
  ELSE
    cFileName := cFileName
  ENDIF
ELSEIF Len(aDir) == 1
  cFileName := cPrimary + '(1)' + cExtension
ELSE
  cFileName := cFileName
ENDIF

RETURN cFileName

* -------------

FUNCTION DC_FileCompare( cFile1, cFile2 )

LOCAL i, nHandle1, nHandle2, lStatus, nSize1, nSize2, cBuffer1, cBuffer2

nHandle1 := FOpen( cFile1 )
IF nHandle1 <= 0
  RETURN .f.
ENDIF

nHandle2 := FOpen( cFile2 )
IF nHandle2 <= 0
  FClose(nHandle1)
  RETURN .f.
ENDIF

IF (nSize1 := FSeek(nHandle1,0,FS_END)) == (nSize2 := FSeek(nHandle2,0,FS_END))
  lStatus := .t.
  FSeek(nHandle1,0,FS_SET)
  FSeek(nHandle2,0,FS_SET)
  FOR i := 1 TO nSize1 STEP 10000
    cBuffer1 := Space(10000)
    cBuffer2 := Space(10000)
    FRead( nHandle1, @cBuffer1, 10000 )
    FRead( nHandle2, @cBuffer2, 10000 )
    IF ! cBuffer1 == cBuffer2
      lStatus := .f.
      EXIT
    ENDIF
  NEXT
ELSE
  lStatus := .f.
ENDIF

FClose(nHandle1)
FClose(nHandle2)

RETURN lStatus

* --------------

FUNCTION DC_FileCopy( aFile, cToPath, aMessage, aErrors, lMove )

LOCAL nSource, nTarget, GetList[0], GetOptions, oDlg, lCopying, i, ;
      nSize, oStatus, cToFileName, nBytes, oProgress, cBuffer, ;
      nBufferSize, lStatus := .t., nRow, nCurrent, cMessage := '', ;
      cFromFileName

aErrors := Array(0)
DEFAULT lMove := .f.

IF Valtype(aFile) == 'C'
  aFile := { aFile }
ENDIF

IF Valtype(aMessage) == 'C'
  aMessage := { aMessage }
ENDIF

FOR i := 1 TO Len(aMessage)
  cMessage += aMessage[i] + Chr(13)
NEXT

@ 0,0 DCSAY cMessage SIZE 100,Len(aMessage) FONT Dc_BaseFont(10) SAYWORDBREAK // Jack Duijf 17-07-2014
//      FONT '10.Helvetic Bold' SAYWORDBREAK

nRow := Len(aMessage) + 1

@ nRow, 0 DCPROGRESS oProgress SIZE 100, 1  ;
   TYPE XBPSTATIC_TYPE_TEXT ;
   PERCENT ;
   PERCENTCOLOR GRA_CLR_RED ;
   DYNAMIC ;
   FONT '12.Arial Bold' ;
   COLOR GRA_CLR_CYAN, GRA_CLR_BACKGROUND ;
   RADIUS 20 ;
   OUTLINE

// @ nRow + 2,0 DCSAY '' SAYSIZE 100 COLOR GRA_CLR_BLUE OBJECT oStatus FONT '9.Helvetica'
@ nRow + 2,0 DCSAY '' SAYSIZE 100 COLOR GRA_CLR_BLUE OBJECT oStatus FONT Dc_BaseFont(9)  // Jack Duijf 17-07-2014

@ nRow + 4,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 10,1.2 ;
   ACTION {||lCopying := .f.}

DCREAD GUI FIT MODAL TITLE 'Copying File(s)' OPTIONS GetOptions ;
   EXIT PARENT @oDlg

nBufferSize := 10000
lCopying := .t.
FOR i := 1 TO Len(aFile)
  cFromFileName := aFile[i]
  nSource := FOpen( cFromFileName )
  IF nSource <= 0
    oStatus:setCaption('Cannot open ' + cFromFileName )
    AAdd( aErrors, 'Cannot open ' + cFromFileName )
    lStatus := .f.
    LOOP
  ENDIF
  IF AT('.', cToPath) > 0
    cToFileName := cToPath
  ELSE
    cToFileName := cToPath + '\' + DC_Path(cFromFileName,.t.)
  ENDIF
  nTarget := FCreate( cToFileName )
  IF nTarget <= 0
    oStatus:setCaption('Cannot create ' + cToFileName)
    AAdd( aErrors, 'Cannot create ' + cToFileName )
    FClose(nSource)
    lStatus := .f.
    LOOP
  ENDIF
  nSize := FSeek(nSource,0,FS_END)
  FSeek(nSource,0,FS_SET)
  nBytes := nBufferSize
  oStatus:setCaption(IIF(lMove,'Moving ','Copying ') + cFromFileName)
  DO WHILE FError() == 0 .AND. nBytes > 0 .AND. lCopying
    cBuffer := Space(nBufferSize)
    DC_CompleteEvents()
    nBytes := FRead( nSource, @cBuffer, nBufferSize )
    nCurrent := FSeek(nSource,0,FS_RELATIVE)
    FWrite( nTarget, Left(cBuffer,nBytes) )
    DC_GetProgress(oProgress,nCurrent,nSize)
  ENDDO
  FClose(nSource)
  FClose(nTarget)
  IF lMove
    FErase(cFromFileName)
  ENDIF
NEXT

oDlg:destroy()

RETURN lStatus

* ----------

FUNCTION DC_StripMarkerText( cString, cLeftMarker, cRightMarker )

LOCAL nStart, nEnd, cText

DO WHILE cLeftMarker $ cString .AND. cRightMarker $ cString
  nStart := At(cLeftMarker,cString)
  nEnd := At(cRightMarker,cString,nStart) + Len(cRightMarker)
  cText := Substr( cString, nStart, nEnd-nStart )
  cString := Strtran( cString, cText )
ENDDO

RETURN cString

* ----------

FUNCTION DC_SetDragFullWindows( lSet )

LOCAL lOldSet, nSet := 0
STATIC slSet := .t.

/*
IF slSet == NIL
  SystemParametersInfoA( SPI_GETDRAGFULLWINDOWS, @nSet, nil, 0 )
  wtf nSet
ENDIF
*/

lOldSet := slSet
nSet := IIF(lSet,0,1)

IF Pcount() == 1
  SystemParametersInfoA(SPI_SETDRAGFULLWINDOWS, @nSet, nil, 0)
ENDIF

RETURN lOldSet

* -----------

FUNCTION DC_HmacSha1 (cKey, cMessage)

#DEFINE blocksize 64

LOCAL oPad, iPad

IF Len(cKey) > blocksize
  cKey := Sha1Hash(cKey) // keys longer than blocksize are shortened
ELSEIF Len(cKey) < blocksize
  ckey += Repl(Chr(0x00), blocksize - Len(cKey)) // keys shorter than blocksize are zero-padded
ENDIF

oPad := DC_XorStrings( Repl(Chr(0x5C), blocksize),cKey)
iPad := DC_XorStrings( Repl(Chr(0x36), blocksize),cKey)

RETURN Lower( Str2HexString( Sha1Hash(oPad + Sha1Hash(iPad + cMessage)) ) )

* -------------

FUNCTION DC_XorStrings( cString1, cString2 )

LOCAL i, cString3 := '', n1, n2, n3

IF Len(cString1) # Len(cString2)
  RETURN ''
ENDIF

FOR i := 1 TO Len(cString1)
  n1 := Asc(cString1[i])
  n2 := Asc(cString2[i])
  n3 := BXor( n1, n2 )
  cString3 += Chr(n3)
NEXT

RETURN cString3

* ------------

FUNCTION Sha1Hash( cString )

LOCAL cHexString := Lower(&("Char2Hash")( cString ))

RETURN HexString2String( cHexString )

* ------------

STATIC FUNCTION Str2HexString( cString )

LOCAL cHexString, i

// convert to a hexidecimal equivalent string
cHexString := ''
FOR i := 1 TO Len(cString)
  cHexString += DC_Dec2Hex(Asc(cString[i]))
NEXT

RETURN cHexString

* -----------------

STATIC FUNCTION HexString2String( cHexString )

LOCAL cString := '', i, xVar

// convert hexidecimal string back to original binary string
FOR i := 1 TO Len(cHexString) STEP 2
  cString += Chr(DC_Hex2Dec(SubStr(cHexString,i,2)))
NEXT

RETURN cString

* ------------

FUNCTION DC_SetCPU( nCPU, cFile )

LOCAL nHnd  := 0                             // file handle
LOCAL nLast := 1                             // last CPU used
LOCAL aSet  := {}                            // processor array
LOCAL nSet                                   // default new bitmask
LOCAL i                                      // counter

DEFAULT cFile := GetEnv('WINDIR') + '\Temp\SetCpu.Smp'

DEFAULT nCPU := 15
// 15 = 4 CPUs
//  7 = 3 CPUs
//  3 = 2 CPUs
//  1 = 1 CPU

nSet := nCPU

FOR i := 1 to 32                             // count processors
   IF nCPU[i]                                // processor present
      aadd(aSet, i)                          // add processor id to list
   ENDIF
NEXT

IF len(aSet) > 1                             // more then one processor
   IF Fexists(cFile)
      nHnd := Fopen(cFile, FO_READWRITE)
      IF nHnd > 0                            // file is open
         nLast := Val(Freadstr(nHnd, 2))+ 1  // get last processor
         IF nLast > len(aSet)                // check against available processors
            nLast := 1                       // recycle number
         ENDIF
         Fseek(nHnd, 0, FS_SET)              // place pointer at bof
         Fwrite(nHnd, StrZero(nLast, 2))     // write to file
         Fclose(nHnd)                        // close file
      ENDIF
   ELSE                                      // first time round
      nHnd := Fcreate(cFile, FC_NORMAL)
      IF nHnd > 0                            // file is created and open
         Fwrite(nHnd, StrZero(nLast, 2))     // write to file
         Fclose(nHnd)                        // close file
      ENDIF
   ENDIF

   FOR i := 1 to 32                          // create new bitmask
      nSet[i] := (i = aSet[nLast])           // switch on appropriate bit
   NEXT

   DllCall("xpprt1.dll", DLL_CDECL, "_sysSetCPU", nSet)

ENDIF

RETURN nil

* ---------------

FUNCTION DC_TabPageNavKeys( GetList, aLeft, aRight )

DEFAULT aLeft := { xbeK_ALT_LEFT }, ;
        aRight := { xbeK_ALT_RIGHT }

DCHOTKEY aLeft ACTION {||_TabNavigate(1,GetList)}
DCHOTKEY aRight ACTION {||_TabNavigate(2,GetList)}

RETURN nil

* --------------

STATIC FUNCTION _TabNavigate( nWhich, GetList )

LOCAL aTabs[0], oXbp, oTab, i

FOR i := 1 TO Len(GetList)
  oXbp := GetList[i,oGETLIST_OBJECT]
  IF Valtype(oXbp) == 'O' .AND. oXbp:isDerivedFrom('DC_XbpTabPage')
    AAdd(aTabs,oXbp)
    IF !oXbp:minimized
      oTab := oXbp
    ENDIF
  ENDIF
NEXT

FOR i := 1 TO Len(aTabs)
  IF aTabs[i] == oTab
    IF nWhich == 1 // left
      IF i > 1
        DC_TabActivate(aTabs[i-1])
      ELSE
        DC_TabActivate(ATail(aTabs))
      ENDIF
    ELSE  // right
      IF i < Len(aTabs)
        DC_TabActivate(aTabs[i+1])
      ELSE
        DC_TabActivate(aTabs[1])
      ENDIF
    ENDIF
    EXIT
  ENDIF
NEXT

RETURN nil

* --------------

// This function loads a CSV file into a work area.
// The top line of the CSV file must contain the field names that match the work area.

FUNCTION DC_CSV2WorkArea( cCsvFileName, lHeaders )

LOCAL nHandle, cLine, aTokens, aFields, lStatus, cFieldName, aStru, ;
      oRecord, cValue, i, nFound, nFieldType

DEFAULT lHeaders := .t.

nHandle := DC_TxtOpen( cCsvFileName )

IF  nHandle <= 0
  RETURN .f.
ENDIF

oRecord := DC_DbRecord():new()

aStru := dbStruct()

IF lHeaders
  cLine := DC_TxtLine( nHandle,Chr(10) )
  aFields := DC_TokenArray( cLine, ',' )
  DC_TxtSkip(nHandle,1,Chr(10))
ELSE
  aFields := {}
  FOR i := 1 TO Len(aStru)
    AAdd(aFields,aStru[i,1])
  NEXT
ENDIF

DO WHILE !DC_TxtEof(nHandle)
  cLine := DC_TxtLine(nHandle,Chr(10))
  aTokens := DC_TokenArray(cLine,',',.t.)
  dbGoTo(0)
  DC_DbScatter(oRecord)
  FOR i := 1 TO Len(aFields)
    IF !Empty(cFieldName := Upper(Alltrim(aFields[i]))) .AND. Len(aTokens) == Len(aFields)
      IF IsFieldVar(cFieldName)
        nFound := AScan(aStru,{|a|Upper(Alltrim(a[1]))==cFieldName})
        cValue := Alltrim(aTokens[i])
        IF nFound > 0
          nFieldType := aStru[nFound,2]
          IF nFieldType $ 'CM'
            oRecord:&(cFieldName) := cValue
          ELSEIF nFieldType == 'N'
            oRecord:&(cFieldName) := Val(cValue)
          ELSEIF nFieldType == 'L'
            oRecord:&(cFieldName) := ' ' + Upper(Alltrim(cValue)) + ' ' $ ' Y YES .T. TRUE T '
          ELSEIF nFieldType == 'D'
            oRecord:&(cFieldName) := CtoD(cValue)
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  NEXT
  DC_DbGather(oRecord,.t.)
  DC_TxtSkip(nHandle,1,Chr(10))
ENDDO

DC_TxtClose( nHandle )

RETURN .t.

* --------------

FUNCTION DC_WorkArea2CSV( cFileName, aFields, cDateFormat, aFieldEvals )

LOCAL nRow, aStru, i, cHeader, cCSVFile, nHandle, ;
      cFieldName, cFieldType, nFieldLen, cLine, ;
      xValue, GetList[0], GetOptions, oDlg, nCount := 0, ;
      cDbfName, nKeyCount, oProgress, lStatus := .t., ;
      aStru2, nFound, xFieldValue, nFieldBlock

DEFAULT aFieldEvals := {}, ;
        cDateFormat := 'mm/dd/yyyy', ;
        cFileName := DC_Path(AppName(.t.)) + 'workarea.csv'

//  aFieldEvals -> {{FIELDNAME,CodeBlock},....}  Code blocks to evaluate for specific fields

cDbfName := dbInfo(DBO_FILENAME)
IF cDbfName = '<CURSOR>'
  nKeyCount := RecCount()
ELSE
  nKeyCount := DC_KeyCount()
ENDIF

@ 0,0 DCSAY 'Creating CSV File: ' + cFileName SAYSIZE 0

@ 1,0 DCPROGRESS oProgress SIZE 50,1 ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_CYAN, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC ;
      EVERY Int(nKeyCount/100)

@ 3,0 DCPUSHBUTTON CAPTION 'Cancel' SIZE 9,1.2 ACTION {||lStatus:=.f.}

DCGETOPTIONS NORESIZE ALWAYSONTOP _PIXEL .f.
DCREAD GUI FIT TITLE 'Exporting to CSV' ;
   MODAL EXIT PARENT @oDlg OPTIONS GetOptions NOAUTORESTORE

nHandle := FCreate(cFileName)

IF nHandle <= 0
  RETURN .f.
ENDIF

DC_DbGoTop()

aStru := dbStruct()

IF Valtype(aFields) == 'A'
  aStru2 := AClone(aStru)
  aStru := Array(0)
  FOR i := 1 TO Len(aFields)
    cFieldName := Upper(Alltrim(aFields[i]))
    nFound := AScan(aStru2,{|a|Upper(a[1])==cFieldName})
    IF nFound > 0
      AAdd( aStru, aStru2[nFound] )
    ENDIF
  NEXT
ENDIF

// write the header line
cLine := ''
FOR i := 1 TO Len(aStru)
  cLine += aStru[i,1] + IIF(i<Len(aStru),',','')
NEXT
FWrite( nHandle, cLine + CRLF )

DO WHILE !DC_Eof() .AND. lStatus
  DC_CompleteEvents()
  DC_GetProgress(oProgress,nCount++,nKeyCount)
  // write a data line
  cLine := ''
  FOR i := 1 TO Len(aStru)
    cFieldName := aStru[i,1]
    xFieldValue := &(cFieldName)
    nFieldBlock := Ascan(aFieldEvals,{|a|upper(a[1])==upper(cFieldName)})
    IF nFieldBlock > 0
      xFieldValue := Eval(aFieldEvals[nFieldBlock,2],xFieldValue)
    ENDIF
    IF Valtype(xFieldValue) $ 'CM'
      cLine += '="' + xFieldValue + '"'
    ELSEIF Valtype(xFieldValue) = 'L'
      cLine += IIF(xFieldValue,'Y','N')
    ELSEIF Valtype(xFieldValue) = 'D'
      cLine += Transform(xFieldValue,cDateFormat)
    ELSE
      cLine += DC_XtoC(xFieldValue)
    ENDIF
    IF i < Len(aStru)
      cLine += ','
    ENDIF
  NEXT
  FWrite( nHandle, cLine + CRLF )
  DC_DbSkip(1)
ENDDO

oDlg:destroy()
FClose(nHandle)

RETURN .t.

* --------------

FUNCTION DC_Array2CSV( cFileName, aData, aHeader )

LOCAL nHandle, i, j, cLine

IF '.XLS' $ Upper(cFileName)
  cFileName := Strtran(cFileName,'.xls','.csv')
  cFileName := Strtran(cFileName,'.XLS','.CSV')
ENDIF

nHandle := FCreate(cFileName)

IF nHandle <= 0
  RETURN .f.
ENDIF

IF Valtype(aHeader) == 'A'
  cLine := ''
  FOR i := 1 TO Len(aHeader)
    cLine += aHeader[i] + IIF(i<Len(aHeader),',','')
  NEXT
  FWrite( nHandle, cLine + CRLF )
ENDIF

FOR i := 1 TO Len(aData)
  cLine := ''
  FOR j := 1 TO Len(aData[i])
    IF Valtype(aData[i,j]) = 'C'
      cLine += '="' + aData[i,j] + '"'
    ELSEIF Valtype(aData[i,j]) = 'L'
      cLine += IIF(aData[i,j],'Y','N')
    ELSE
      cLine += DC_XtoC(aData[i,j])
    ENDIF
    IF j < Len(aData[i])
      cLine += ','
    ENDIF
  NEXT
  FWrite( nHandle, cLine + CRLF )
NEXT

FClose( nHandle )

RETURN .t.

* ----------


// This function loads a CSV file into an array

FUNCTION DC_CSV2Array( cCsvFileName )

LOCAL nHandle, cLine, aTokens, aCSV[0]

nHandle := DC_TxtOpen( cCsvFileName )

IF  nHandle <= 0
  RETURN {}
ENDIF

DO WHILE !DC_TxtEof(nHandle)
  cLine := DC_TxtLine(nHandle,Chr(10))
  aTokens := DC_TokenArray(cLine,',',.t.)
  AAdd( aCSV, aTokens )
  DC_TxtSkip(nHandle,1,Chr(10))
ENDDO

DC_TxtClose( nHandle )

RETURN aCSV

* ----------

FUNCTION DC_DimScreen( oDlg, nColor, nTransparency, bGets )

LOCAL GetList[0], hWnd, oStatic, oDlg2, oDeskTop := AppDeskTop(), ;
      GetOptions

DEFAULT oDlg := SetAppWindow(), ;
        nColor := GRA_CLR_BLACK, ;
        nTransparency := 50

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR nil, nColor ;
      OBJECT oStatic

DCGETOPTIONS NOTITLEBAR HIDE BORDER XBPDLG_NO_BORDER

DCREAD GUI EXIT EVAL {|o|oDlg2 := o} OPTIONS GetOptions OWNER oDlg

hWnd := oDlg2:getHwnd()

IF oDlg == oDeskTop
  oDlg2:setParent(oDeskTop)
  oDlg2:setPos({0,0})
  oDlg2:setSize(oDeskTop:currentSize())
ELSE
  oDlg2:setParent(oDlg:parent)
  oDlg2:setPos(oDlg:currentPos())
  oDlg2:setSize(oDlg:currentSize())
ENDIF
oStatic:setSize(oDlg2:drawingArea:currentSize())
oStatic:setPos({0,0})

DC_SetWindowTransparency(hWnd,nTransparency)

oDlg2:show()

IF Valtype(bGets) == 'B'
  GetList := {}
  Eval(bGets,GetList,@oStatic)
  DCREAD GUI PARENT oStatic EXIT
ENDIF

oDlg2:disable()
oDlg2:show()

RETURN oDlg2

* -----------

FUNCTION DC_Object2JS( oObject, nLevel )

LOCAL i, cText, aObject, cJS, aIvars, cIvar, xData, cCrlf

DEFAULT nLevel := 0

cJS := Space(nLevel) + '{' + CRLF

aIvars := oObject:classDescribe()[3]

FOR i := 1 TO Len(aIvars)
  cIvar := aIvars[i,1]
  xData := oObject:&(cIvar)
  cCrlf := ''
  IF Valtype(xData) = 'A'
    cCrlf := CRLF
  ENDIF
  xData := cCrlf + DC_Value2Js(xData,nLevel+1)
  cText := Space(nLevel+1) + '"' + cIvar + '": '
  cText += xData
  cJS += cText + IIF( i=Len(aIvars),'',',') + CRLF
NEXT

cJS += Space(nLevel) + '}'

RETURN cJS

* ------------

FUNCTION DC_Array2JS( aArray, nLevel )

LOCAL i, cText, xData, cCrlf

DEFAULT nLevel := 0

cText := Space(nLevel) + '[' + CRLF

FOR i := 1 TO Len(aArray)
  xData := aArray[i]
  xData := DC_Value2Js(xData,nLevel+1)
  cText += xData + IIF( i<Len(aArray),',','')  + CRLF
NEXT

cText += Space(nLevel) + ']'

RETURN cText

* -----------

FUNCTION DC_Value2Js( xData, nLevel )

LOCAL cCrLf := ''

IF Valtype( xData ) $ 'MC'
  xData := '"' + Trim(xData) + '"'
ELSEIF Valtype( xData ) == 'N'
  xData := Alltrim(Str(xData))
ELSEIF Valtype( xData ) == 'L'
  xData := IIF(xData,"true","false")
ELSEIF Valtype( xData ) == 'D'
  xData := Dtoc(xData)
ELSEIF Valtype( xData ) == 'A'
  xData := DC_Array2JS( xData, nLevel )
  RETURN xData
ELSEIF Valtype( xData ) == 'O'
  xData := DC_Object2JS( xData, nLevel )
  RETURN xData
ELSEIF xData == NIL
  xData := 'null'
ENDIF

RETURN Space(nLevel) + xData + cCrlf

* --------------

FUNCTION DC_Object2Xml( oObject, cTagName, nLevel )

LOCAL i, cText, aObject, cXml, aIvars, cIvar, xData, lArray

DEFAULT nLevel := 0, ;
        cTagName := oObject:className()

aIvars := oObject:classDescribe()[3]

cXml := Space(nLevel) + '<' + cTagName + ' type="object">' + CRLF
FOR i := 1 TO Len(aIvars)
  cIvar := aIvars[i,1]
  xData := oObject:&(cIvar)
  lArray := Valtype(xData) == 'A'
  xData := DC_Value2Xml(xData,cIvar,nLevel+1)
  cXml += xData
NEXT

cXml += Space(nLevel) + '</' + cTagName + '>'

RETURN cXml

* ------------

FUNCTION DC_Array2Xml( aArray, cTagName, nLevel )

LOCAL i, cText, xData

DEFAULT nLevel := 0, ;
        cTagName := 'array'

cText := Space(nLevel) + '<' + cTagName + ' type="array">' + CRLF

FOR i := 1 TO Len(aArray)
  xData := DC_Value2Xml(aArray[i], 'value', nLevel+1)
  cText += xData
NEXT

cText += Space(nLevel) + '</' + cTagName + '>'

RETURN cText

* -----------

FUNCTION DC_Value2Xml( xData, cTagName, nLevel )

LOCAL cType := Valtype(xData), cCrlf := ''

DEFAULT nLevel := 0

IF Valtype( xData ) $ 'MC'
  xData := '"' + Trim(xData) + '"'
ELSEIF Valtype( xData ) == 'N'
  xData := Alltrim(Str(xData))
ELSEIF Valtype( xData ) == 'L'
  xData := IIF(xData,"true","false")
ELSEIF Valtype( xData ) == 'D'
  xData := Dtoc(xData)
ELSEIF Valtype( xData ) == 'A'
  xData := DC_Array2Xml( xData, cTagName, nLevel )
  RETURN xData + CRLF
ELSEIF Valtype( xData ) == 'O'
  xData := CRLF + DC_Object2Xml( xData, xData:className(), nLevel+1 )
  cCrlf := CRLF + Space(nLevel)
ELSEIF xData == NIL
  xData := 'null'
ENDIF

RETURN Space(nLevel) + '<' + cTagName + '>' + xData + cCrlf + '</' + cTagName + '>' + CRLF

* ------------

STATIC FUNCTION _Qout()

LOCAL i

FOR i := 1 TO PCount()
  scQout += Var2Char(PValue(i)) + ' '
NEXT
scQout += Chr(13)+Chr(10)

RETURN nil

* ------------

STATIC FUNCTION _QQout()

LOCAL i

FOR i := 1 TO PCount()
  scQout += Var2Char(PValue(i)) + ' '
NEXT

RETURN nil

* ------------

#command  ?  [<list,...>]  =>  _QOUT( <list> )

FUNCTION DC_Error2String( oError )

// Creates a string with the important Information from the error object

LOCAL i, cCallStack, nStackStart := 1, nArea, cErrorShort, cQout

scQout := ''

? "Operation             :" , Alltrim(oError:operation) + " Called From " +;
                                 Trim(ProcName(1)) + "(" + LTrim( Str( ProcLine(1))) + ")"
? "Subject Description   : ", oError:description
IF ValType(oError:Args) = 'A' .AND. !Empty(_Arguments(oError:Args, 22))
  ? "Arguments             :"
  _Arguments(oError:Args, 22)
ENDIF

? Replicate( "-", 66 )
?

? "System Type           :", IIF( DC_IsDir("C:\Program Files (x86)"), "64 Bit Processor", "32 Bit Processor")
? 'OS Version            :', Os()
? 'Xbase++ Version       :', Version()+"."+Version(3)
? "eXPress++ version     :",DC_VersionExpress()+"."+DC_VersionExpress(3)
? "Set Data Path         : ", Set(_SET_PATH)
? "Default Directory     : "+ AllTrim(Set(_SET_DEFAULT))
? "Computer Name         : "+ AllTrim(_ComputerName())
? "Windows User Name     : "+ AllTrim(_UserName())
? "Current Directory     : "+ AllTrim(DC_CurPath())
?

//------------------------------------------------------------------
// Error object information.
//------------------------------------------------------------------
? Replicate( "-", 66 )
? "ERROR OBJECT:"
? Replicate( "-", 66 )
? "oError:args         :"
_Arguments(oError:Args)

? "oError:canDefault   :" , oError:canDefault
? "oError:canRetry     :" , oError:canRetry
? "oError:canSubstitute:" , oError:canSubstitute
? "oError:cargo        :" , oError:cargo
? "oError:description  :" , oError:description
? "oError:filename     :" , oError:filename
? "oError:genCode      :" , oError:genCode
? "oError:operation    :" , oError:operation
? "oError:osCode       :" , oError:osCode
? "oError:severity     :" , oError:severity
? "oError:subCode      :" , oError:subCode
? "oError:subSystem    :" , oError:subSystem
? "oError:thread       :" , oError:thread
? "oError:tries        :" , oError:tries
? " "

// Callstack dump.
? Replicate( "-", 78 )
? "CALLSTACK:"
? Replicate( "-", 78 )

i := nStackStart
DO WHILE ! Empty( ProcName(++i) )
  cCallStack := Trim( ProcName(i) )   + "(" + ;
                LTrim( Str( ProcLine(i) ) ) + ")"

 ? "Called From:", cCallStack

  IF Empty(cErrorShort)
    cErrorShort := oError:description + ' - ' + cCallStack
  ENDIF
ENDDO

// Workarea status.
? replicate( "-", 78 )
? "WORKAREA STATUS:"
? replicate( "-", 78 )
? " Area Alias         Record         Index        Order      Eof Bof Del Found"
? replicate( "-", 78 )
nArea := Select()
FOR i := 1 to 255
   IF !Empty(Alias((i)))
      dbSelectArea(i)
      ? iif(i==nArea, "*", " ") + str(i,3) + "  " + ;
        Padr(Alias(),10) + " " + ;
        Str(Recno(),8) + "/" + padr(ltrim(str(lastrec(),8)),8) + " " + ;
        Padr(Ordbagname(),12) + " " + ;
        Padr(Ordsetfocus(),10) + " " + ;
        iif(Eof(),     "Yes", "No ") + " " + ;
        iif(Bof(),     "Yes", "No ") + " " + ;
        iif(Deleted(), "Yes", "No ") + " " + ;
        iif(Found(),   "Yes", "No ")
   ENDIF
NEXT i
SELE (nArea)
cQout := scQout
scQout := ''

RETURN cQout

* -----------

STATIC FUNCTION _arguments(aArg, nSpace)

LOCAL n := 0

DEFAULT nSpace := 0

IF Valtype(aArg)=="A"
  IF nSpace > 0
    AEval( aArg, ;
           {|x,y| IIF( ++n = 1, _QQout( "-> VALTYPE:", y:=Valtype(x) ), ;
                                _Qout( Space(nSpace),"-> VALTYPE:", y:=Valtype(x) )), ;
                   IIf( y=="O", _QQout( " CLASS:", x:className() ), ;
                                _QQout( " VALUE:", Var2Char(x) ) ) } )

  ELSE
    nSpace := 10
    AEval( aArg, ;
           {|x,y| Qout( Space(nSpace),"-> VALTYPE:", y:=Valtype(x) )  , ;
                   IIf( y=="O", _QQout( " CLASS:", x:className() ), ;
                                _QQout( " VALUE:", Var2Char(x) ) ) } )
  ENDIF
ELSE
   _Qout( Space(10),"-> NIL" )
ENDIF

return nil

* -----------

STATIC FUNCTION _ComputerName()

LOCAL cComputerName := Space(100)
LOCAL nLen := 100

GetComputerNameA( @cComputerName, @nLen)

RETURN AllTrim(StrTran(cComputerName,Chr(0),''))

* ------------

STATIC FUNCTION _UserName()

LOCAL cUserName := Space(100)
LOCAL nLen := 100

GetUserNameA( @cUserName, @nLen )

return AllTrim(StrTran(cUserName,Chr(0),""))

* ------------

FUNCTION DC_ExpressRootDir()

LOCAL cInclude := GetEnv('INCLUDE'), aTokens, i, nFound

aTokens := DC_TokenArray(cInclude,';')

FOR i := 1 TO Len(aTokens)
  cInclude := aTokens[i] + '\dcdialog.ch'
  IF File(cInclude)
    cInclude := aTokens[i]
    nFound := RAt('\',cInclude)
    cInclude := Substr(cInclude,1,nFound-1)
    RETURN cInclude
  ENDIF
NEXT

RETURN ''
